Package: callr
Title: Call R from R
Version: 3.8.0
Authors@R: c(
    person("Gábor", "Csárdi", , "csardi.gabor@gmail.com", role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0000-0001-7098-9676")),
    person("Winston", "Chang", role = "aut"),
    person("Posit Software, PBC", role = c("cph", "fnd"),
           comment = c(ROR = "03wc8by49")),
    person("Ascent Digital Services", role = c("cph", "fnd"))
  )
Description: It is sometimes useful to perform a computation in a separate
    R process, without affecting the current R process at all.  This
    packages does exactly that.
License: MIT + file LICENSE
URL: https://callr.r-lib.org, https://github.com/r-lib/callr
BugReports: https://github.com/r-lib/callr/issues
Depends: R (>= 3.4)
Imports: otel (>= 0.2.0), processx (>= 3.6.1), R6, utils
Suggests: asciicast (>= 2.3.1), carrier, cli (>= 1.1.0), otelsdk (>=
        0.2.0), ps, rprojroot, spelling, testthat (>= 3.2.0), withr (>=
        2.3.0)
Config/Needs/website: r-lib/asciicast, glue, htmlwidgets, igraph,
        tibble, tidyverse/tidytemplate
Config/testthat/edition: 3
Config/usethis/last-upkeep: 2025-04-28
Encoding: UTF-8
Language: en-US
Config/roxygen2/version: 8.0.0
NeedsCompilation: no
Packaged: 2026-06-05 08:20:00 UTC; gaborcsardi
Author: Gábor Csárdi [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0001-7098-9676>),
  Winston Chang [aut],
  Posit Software, PBC [cph, fnd] (ROR: <https://ror.org/03wc8by49>),
  Ascent Digital Services [cph, fnd]
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Repository: CRAN
Date/Publication: 2026-06-05 11:40:13 UTC
Built: R 4.6.0; ; 2026-06-05 15:30:17 UTC; unix

Package: csomag
Title: Test Package for 'callr'
Version: 0.0.0.9999
Authors@R: c(
    person("Gábor", "Csárdi", role = c("aut", "cre", "cph"),
           email = "csardi.gabor@gmail.com",
	   comment = c(ORCID = "0000-0001-7098-9676")))
Description: Test package for 'callr'.
License: MIT + file LICENSE
LazyData: true
Encoding: UTF-8
Language: en-US

Package: callr
Title: Call R from R
Version: 3.8.0
Authors@R: c(
    person("Gábor", "Csárdi", , "csardi.gabor@gmail.com", role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0000-0001-7098-9676")),
    person("Winston", "Chang", role = "aut"),
    person("Posit Software, PBC", role = c("cph", "fnd"),
           comment = c(ROR = "03wc8by49")),
    person("Ascent Digital Services", role = c("cph", "fnd"))
  )
Description: It is sometimes useful to perform a computation in a separate
    R process, without affecting the current R process at all.  This
    packages does exactly that.
License: MIT + file LICENSE
URL: https://callr.r-lib.org, https://github.com/r-lib/callr
BugReports: https://github.com/r-lib/callr/issues
Depends: R (>= 3.4)
Imports: otel (>= 0.2.0), processx (>= 3.6.1), R6, utils
Suggests: asciicast (>= 2.3.1), carrier, cli (>= 1.1.0), otelsdk (>=
        0.2.0), ps, rprojroot, spelling, testthat (>= 3.2.0), withr (>=
        2.3.0)
Config/Needs/website: r-lib/asciicast, glue, htmlwidgets, igraph,
        tibble, tidyverse/tidytemplate
Config/testthat/edition: 3
Config/usethis/last-upkeep: 2025-04-28
Encoding: UTF-8
Language: en-US
Config/roxygen2/version: 8.0.0
NeedsCompilation: no
Packaged: 2026-06-05 08:20:00 UTC; gaborcsardi
Author: Gábor Csárdi [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0001-7098-9676>),
  Winston Chang [aut],
  Posit Software, PBC [cph, fnd] (ROR: <https://ror.org/03wc8by49>),
  Ascent Digital Services [cph, fnd]
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Repository: CRAN
Date/Publication: 2026-06-05 11:40:13 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# callr

> Call R from R

<!-- badges: start -->
[![lifecycle](https://lifecycle.r-lib.org/articles/figures/lifecycle-stable.svg)](https://lifecycle.r-lib.org/articles/stages.html)
[![R-CMD-check](https://github.com/r-lib/callr/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/r-lib/callr/actions/workflows/R-CMD-check.yaml)
[![](https://www.r-pkg.org/badges/version/callr)](https://www.r-pkg.org/pkg/callr)
[![CRAN Posit mirror downloads](https://cranlogs.r-pkg.org/badges/callr)](https://www.r-pkg.org/pkg/callr)
[![Codecov test coverage](https://codecov.io/gh/r-lib/callr/branch/main/graph/badge.svg)](https://app.codecov.io/gh/r-lib/callr?branch=main)
<!-- badges: end -->


It is sometimes useful to perform a computation in a separate R process,
without affecting the current R process at all. This packages does exactly
that.

---

- [Features](#features)
- [Installation](#installation)
- [Synchronous, one-off R processes](#synchronous-one-off-r-processes)
  - [Passing arguments](#passing-arguments)
  - [Using packages](#using-packages)
  - [Error handling](#error-handling)
  - [Standard output and error](#standard-output-and-error)
- [Background R processes](#background-r-processes)
- [Multiple background R processes and
  `poll()`](#multiple-background-r-processes-and-poll)
- [Persistent R sessions](#persistent-r-sessions)
- [Running `R CMD` commands](#running-r-cmd-commands)
- [Observability](#observability)
- [Configuration](#configuration)
  - [Environment variables](#environment-variables)
- [Code of Conduct](#code-of-conduct)

## Features

- Calls an R function, with arguments, in a subprocess.
- Copies function arguments to the subprocess and copies the return
  value of the function back, seamlessly.
- Copies error objects back from the subprocess, including a stack
  trace.
- Shows and/or collects the standard output and standard error of the
  subprocess.
- Supports both one-off and persistent R subprocesses.
- Calls the function synchronously or asynchronously (in the
  background).
- Can call `R CMD` commands, synchronously or asynchronously.
- Can call R scripts, synchronously or asynchronously.
- Provides extensible `r_process`, `rcmd_process` and `rscript_process`
  R6 classes, based on `processx::process`.
- Emits [OpenTelemetry](https://opentelemetry.io/) traces for every R
  subprocess and propagates trace context across the process boundary.

## Installation

Install the stable version from CRAN:

``` r
install.packages("callr")
```

Install the development version from GitHub:

``` r
pak::pak("r-lib/callr")
```

## Synchronous, one-off R processes

Use `r()` to run an R function in a new R process. The results are
passed back seamlessly:

``` r
callr::r(function() var(iris[, 1:4]))
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/simple-dark.svg">
<img src="man/figures/simple.svg" /> </picture>

### Passing arguments

You can pass arguments to the function by setting `args` to the list of
arguments. This is often necessary as these arguments are explicitly
copied to the child process, whereas the evaluated function cannot refer
to variables in the parent. For example, the following does not work:

``` r
mycars <- cars
callr::r(function() summary(mycars))
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/passargsfail-dark.svg">
<img src="man/figures/passargsfail.svg" /> </picture>

But this does:

``` r
mycars <- cars
callr::r(function(x) summary(x), args = list(mycars))
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/passargsok-dark.svg">
<img src="man/figures/passargsok.svg" /> </picture>

Note that the arguments will be serialized and saved to a file, so if
they are large R objects, it might take a long time for the child
process to start up.

### Using packages

You can use any R package in the child process, just make sure to refer
to it explicitly with the `::` operator. For example, the following code
creates an [igraph](https://github.com/igraph/rigraph) graph in the
child, and calculates some metrics of it.

``` r
callr::r(function() { g <- igraph::sample_gnp(1000, 4/1000); igraph::diameter(g) })
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/packages-dark.svg">
<img src="man/figures/packages.svg" /> </picture>

### Error handling

callr copies errors from the child process back to the main R session:

``` r
callr::r(function() 1 + "A")
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/error1-dark.svg">
<img src="man/figures/error1.svg" /> </picture> callr sets the
`.Last.error` variable, and after an error you can inspect this for more
details about the error, including stack traces both from the main R
process and the subprocess.

``` r
.Last.error
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/error2-2-dark.svg">
<img src="man/figures/error2-2.svg" /> </picture>

The error objects has two parts. The first belongs to the main process,
and the second belongs to the subprocess.

`.Last.error` also includes a stack trace, that includes both the main R
process and the subprocess:

The top part of the trace contains the frames in the main process, and
the bottom part contains the frames in the subprocess, starting with the
anonymous function.

### Standard output and error

By default, the standard output and error of the child is lost, but you
can request callr to redirect them to files, and then inspect the files
in the parent:

``` r
x <- callr::r(function() { print("hello world!"); message("hello again!") },
  stdout = "/tmp/out", stderr = "/tmp/err"
)
readLines("/tmp/out")
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/io-dark.svg">
<img src="man/figures/io.svg" /> </picture>

``` r
readLines("/tmp/err")
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/io-2-dark.svg">
<img src="man/figures/io-2.svg" /> </picture>

With the `stdout` option, the standard output is collected and can be
examined once the child process finished. The `show = TRUE` options will
also show the output of the child, as it is printed, on the console of
the parent.

## Background R processes

`r_bg()` is similar to `r()` but it starts the R process in the
background. It returns an `r_process` R6 object, that provides a rich
API:

``` r
rp <- callr::r_bg(function() Sys.sleep(.2))
rp
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/bg-dark.svg">
<img src="man/figures/bg.svg" /> </picture>

This is a list of all `r_process` methods:

``` r
ls(rp)
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/bg-methods-dark.svg">
<img src="man/figures/bg-methods.svg" /> </picture>

These include all methods of the `processx::process` superclass and the
new `get_result()` method, to retrieve the R object returned by the
function call. Some of the handiest methods are:

- `get_exit_status()` to query the exit status of a finished process.
- `get_result()` to collect the return value of the R function call.
- `interrupt()` to send an interrupt to the process. This is equivalent
  to a `CTRL+C` key press, and the R process might ignore it.
- `is_alive()` to check if the process is alive.
- `kill()` to terminate the process.
- `poll_io()` to wait for any standard output, standard error, or the
  completion of the process, with a timeout.
- `read_*()` to read the standard output or error.
- `suspend()` and `resume()` to stop and continue a process.
- `wait()` to wait for the completion of the process, with a timeout.

## Multiple background R processes and `poll()`

Multiple background R processes are best managed with the
`processx::poll()` function that waits for events (standard output/error
or termination) from multiple processes. It returns as soon as one
process has generated an event, or if its timeout has expired. The
timeout is in milliseconds.

``` r
rp1 <- callr::r_bg(function() { Sys.sleep(1/2); "1 done" })
rp2 <- callr::r_bg(function() { Sys.sleep(1/1000); "2 done" })
processx::poll(list(rp1, rp2), 1000)
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/poll-dark.svg">
<img src="man/figures/poll.svg" /> </picture>

``` r
rp2$get_result()
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/poll-2-dark.svg">
<img src="man/figures/poll-2.svg" /> </picture>

``` r
processx::poll(list(rp1), 1000)
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/poll-3-dark.svg">
<img src="man/figures/poll-3.svg" /> </picture>

``` r
rp1$get_result()
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/poll-4-dark.svg">
<img src="man/figures/poll-4.svg" /> </picture>

## Persistent R sessions

`r_session` is another `processx::process` subclass that represents a
persistent background R session:

``` r
rs <- callr::r_session$new()
rs
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/rsession-dark.svg">
<img src="man/figures/rsession.svg" /> </picture>

`r_session$run()` is a synchronous call, that works similarly to `r()`,
but uses the persistent session. `r_session$call()` starts the function
call and returns immediately. The `r_session$poll_process()` method or
`processx::poll()` can then be used to wait for the completion or other
events from one or more R sessions, R processes or other
`processx::process` objects.

Once an R session is done with an asynchronous computation, its
`poll_process()` method returns `"ready"` and the `r_session$read()`
method can read out the result.

``` r
rs <- callr::r_session$new()
rs$run(function() runif(10))
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/rsession2-dark.svg">
<img src="man/figures/rsession2.svg" /> </picture>

``` r
rs$call(function() rnorm(10))
rs
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/rsession2-2-dark.svg">
<img src="man/figures/rsession2-2.svg" /> </picture>

``` r
rs$poll_process(2000)
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/rsession-4-dark.svg">
<img src="man/figures/rsession-4.svg" /> </picture>

``` r
rs$read()
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/rsession-5-dark.svg">
<img src="man/figures/rsession-5.svg" /> </picture>

## Running `R CMD` commands

The `rcmd()` function calls an `R CMD` command. For example, you can
call `R CMD INSTALL`, `R CMD check` or `R CMD config` this way:

``` r
callr::rcmd("config", "CC")
```

<picture>
<source media="(prefers-color-scheme: dark)" srcset="man/figures/rcmd-dark.svg">
<img src="man/figures/rcmd.svg" /> </picture>

This returns a list with three components: the standard output, the
standard error, and the exit (status) code of the `R CMD` command.

## Observability

callr is instrumented with [OpenTelemetry](https://opentelemetry.io/).
When an OpenTelemetry SDK (such as [otelsdk](https://otelsdk.r-lib.org))
is loaded and configured, callr emits spans for every R subprocess it
starts and propagates the W3C `traceparent` header into the subprocess,
so spans created inside the child become children of the parent span. No
code changes are needed in callr-using code — the existing entry points
start emitting telemetry as soon as an SDK is configured.

See `vignette("opentelemetry", package = "callr")` for what callr emits,
how subprocess context propagation works, and how to test your own
instrumentation on top of it.

## Configuration

### Environment variables

- `CALLR_NO_TEMP_DLLS`: If `true`, then callr does not use a temporary
  directory to copy the client DLL files from, in the subprocess. By
  default callr copies the DLL file that drives the callr subprocess
  into a temporary directory and loads it from there. This is mainly to
  avoid locking a DLL file in the package library, on Windows. If this
  default causes issues for you, set it to `true`, and then callr will
  use the DLL file from the installed processx package. See also
  <https://github.com/r-lib/callr/issues/273>.

- `CALLR_TMPDIR`: If set to a non-empty path, callr writes its auxiliary
  temporary files into this directory instead of the session’s
  `tempdir()`. The directory is created if it does not exist. The value
  is read on each use, so it can be changed at run time via
  `Sys.setenv()`. Note that paths cached at package load time (the
  package’s own `callr-env-` file and the client DLL location) only
  honor this setting if the variable was set before `callr` was loaded,
  typically by exporting it in the shell or via `.Renviron`. See also
  <https://github.com/r-lib/callr/issues/172>.

## Code of Conduct

Please note that the callr project is released with a [Contributor Code
of Conduct](https://callr.r-lib.org/CODE_OF_CONDUCT.html). By
contributing to this project, you agree to abide by its terms.

library(callr)

if (Sys.getenv("NOT_CRAN") == "true") {
  if (callr:::is_false_check_env_var("_R_CHECK_FORCE_SUGGESTS_")) {
    if (requireNamespace("testthat", quietly = TRUE)) {
      library(testthat)
      test_check("callr")
    }
  } else {
    library(testthat)
    test_check("callr")
  }
}

file_from_env <- function(var) {
  if (file.exists(f <- Sys.getenv(var))) readLines(f)
}

if (Sys.getenv("CALLR_DUMP_HERE") != "") {
  saveRDS(
    list(
      env = Sys.getenv(),
      libpaths = .libPaths(),
      search = search(),
      R_ENVIRON = file_from_env("R_ENVIRON"),
      R_ENVIRON_USER = file_from_env("R_ENVIRON_USER"),
      R_PROFILE = file_from_env("R_PROFILE"),
      R_PROFILE_USER = file_from_env("R_PROFILE_USER")
    ),
    file = Sys.getenv("CALLR_DUMP_HERE")
  )
}

#' External R Process
#'
#' @description
#' An R process that runs in the background. This is an R6 class that
#' extends the [processx::process] class. The process starts in the
#' background, evaluates an R function call, and then quits.
#'
#' @examplesIf FALSE
#' ## List all options and their default values:
#' r_process_options()
#'
#' ## Start an R process in the background, wait for it, get result
#' opts <- r_process_options(func = function() 1 + 1)
#' rp <- r_process$new(opts)
#' rp$wait()
#' rp$get_result()
#' @export

r_process <- suppressMessages(R6::R6Class(
  "r_process",
  inherit = processx::process,
  public = list(
    #' @description
    #' Start a new R process in the background.
    #' @param options A list of options created via [r_process_options()].
    #' @return A new `r_process` object.
    initialize = function(options) rp_init(self, private, super, options),

    #' @description
    #' Return the result, an R object, from a finished
    #' background R process. If the process has not finished yet, it throws
    #' an error. (You can use `wait()` method (see [processx::process]) to
    #' wait for the process to finish, optionally with a timeout.) You can
    #' also use [processx::poll()] to wait for the end of the process,
    #' together with other processes or events.
    #'
    #' @return The return value of the R expression evaluated in the R
    #' process.
    get_result = function() rp_get_result(self, private),

    #' @description
    #' Delete the temporary files created for this R process.
    #' Only call this if you are sure that the process is done and you
    #' don't need the result anymore. If you don't call this method
    #' explicitly, the temporary files will be deleted when the process
    #' object is garbage collected.
    cleanup = function() {
      unlink(private$options$tmp_files, recursive = TRUE)
    },

    #' @description
    #' Clean up temporary files once an R process has finished and its
    #' handle is garbage collected.
    finalize = function() {
      self$cleanup()
      if ("finalize" %in% ls(super)) super$finalize()
    }
  ),
  private = list(
    options = NULL
  )
))

rp_init <- function(self, private, super, options) {
  ## This contains the context that we set up in steps
  options <- convert_and_check_my_args(options)

  options <- setup_script_files(options)
  options <- setup_context(options)
  options <- setup_r_binary_and_args(options)

  otel_span <- otel::start_span(
    "callr::r_process",
    attributes = otel::as_attributes(options)
  )
  otel::local_active_span(otel_span)
  otel::log_debug("start r_process")
  if (otel::is_tracing_enabled()) {
    hdrs <- otel::pack_http_context()
    names(hdrs) <- toupper(names(hdrs))
    options$env[names(hdrs)] <- hdrs
  }
  options$otel_span <- otel_span

  private$options <- options

  with_envvar(
    options$env,
    do.call(
      super$initialize,
      c(
        list(
          options$bin,
          options$real_cmdargs,
          stdout = options$stdout,
          stderr = options$stderr,
          poll_connection = options$poll_connection,
          supervise = options$supervise
        ),
        options$extra
      )
    )
  )

  invisible(self)
}

rp_get_result <- function(self, private) {
  if (self$is_alive()) {
    private$options$otel_span$add_event(
      "get_result",
      attributes = list(done = FALSE)
    )
    throw(new_error("Still alive"))
  }
  on.exit(private$options$otel_span$end(status_code = "auto"), add = TRUE)

  ## This is artificial...
  out <- list(
    status = self$get_exit_status(),
    stdout = "",
    stderr = "",
    timeout = FALSE
  )

  get_result(out, private$options)
}

test_that("r() to the other arch", {
  skip_on_cran()
  archs <- supported_archs()
  if (length(archs) < 1) return(expect_true(TRUE))
  ret <- unlist(lapply(
    archs, function(a) r(function() .Platform$r_arch, arch = a)
  ))
  expect_equal(ret, archs)
})

test_that("r_bg() to the other arch", {
  skip_on_cran()
  archs <- supported_archs()
  if (length(archs) < 1) return(expect_true(TRUE))
  procs <- lapply(archs, function(a) {
    r_bg(function() .Platform$r_arch, arch = a)
  })
  on.exit(lapply(procs, function(p) p$kill()), add = TRUE)
  for (p in procs) p$wait(3000)
  for (p in procs) expect_false(p$is_alive())
  res <- unlist(lapply(procs, function(p) p$get_result()))
  expect_equal(res, archs)
})

test_that("r_process to the other arch", {
  skip_on_cran()
  archs <- supported_archs()
  if (length(archs) < 1) return(expect_true(TRUE))
  procs <- lapply(archs, function(a) {
    opts <- r_process_options(
      func = function() .Platform$r_arch,
      arch = a
    )
    r_process$new(opts)
  })
  on.exit(lapply(procs, function(p) p$kill()), add = TRUE)
  for (p in procs) p$wait(3000)
  for (p in procs) expect_false(p$is_alive())
  res <- unlist(lapply(procs, function(p) p$get_result()))
  expect_equal(res, archs)
})

test_that("r_session to the other arch", {
  skip_on_cran()
  archs <- supported_archs()
  if (length(archs) < 1) return(expect_true(TRUE))
  ret <- unlist(lapply(archs, function(a) {
    opts <- r_session_options(arch = a)
    rs <- r_session$new(opts)
    on.exit(rs$close(), add = TRUE)
    rs$run(function() .Platform$r_arch)
  }))
  expect_equal(ret, archs)
})

test_that("r_bg runs", {
  x <- r_bg(function() 1 + 1)
  x$wait()
  expect_identical(x$get_result(), 2)
  rm(x)
  gc()
})

test_that("r_bg takes arguments", {
  x <- r_bg(function(x) x + 10, args = list(32))
  x$wait()
  expect_identical(x$get_result(), 42)
  rm(x)
  gc()
})

test_that("r_bg can be killed", {
  x <- r_bg(function() Sys.sleep(2))
  x$kill()
  expect_false(x$is_alive())
  expect_error(x$get_result())
  rm(x)
  gc()
})

test_that("r_bg can get the error back", {
  x <- r_bg(function() 1 + "A", error = "error")
  x$wait()
  expect_error(x$get_result(), "non-numeric argument to binary operator")
  rm(x)
  gc()
})

test_that("can read standard output", {
  x <- r_bg(function() cat("Hello world!\n"))
  x$wait()
  expect_equal(x$read_output_lines(), "Hello world!")
  rm(x)
  gc()
})

test_that("can read standard error", {
  x <- r_bg(function() message("Hello world!"))
  x$wait()
  expect_equal(x$read_error_lines(), "Hello world!")
  rm(x)
  gc()
})

test_that("can read stdout and stderr", {
  x <- r_bg(function() { cat("Hello world!\n"); message("Again!") })
  x$wait()
  expect_equal(x$read_output_lines(), "Hello world!")
  expect_equal(x$read_error_lines(), "Again!")
  rm(x)
  gc()
})

test_that("cleans up temporary files", {

  skip_on_cran()

  rbg <- function() {
    library(callr)
    old <- dir(tempdir(), pattern = "^callr-")
    rp <- callr::r_bg(function() 1+1)
    on.exit(tryCatch(rp$kill, error = function(e) NULL), add = TRUE)
    rp$wait(5000)
    rp$kill()
    result <- rp$get_result()

    rm(rp)
    gc()
    gc()

    unloadNamespace("callr")
    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rbg)
  expect_identical(out$result, 2)
  expect_identical(out$new, character())
})

test_that("r() does not load anything", {
  skip_in_covr()
  skip_if_not_installed("withr")
  pkgs <- withr::with_envvar(
    clean_envvars(),
    r(without_env(function() loadedNamespaces())))
  if (length(pkgs) > 1) print(pkgs)
  ## Some R versions still load compiler...
  expect_true(all(pkgs %in% c("base", "compiler")))
})

test_that("r_bg() does not load anything", {
  skip_in_covr()
  skip_if_not_installed("withr")
  p <- withr::with_envvar(
    clean_envvars(),
    r_bg(without_env(function() loadedNamespaces())))
  on.exit(p$kill(), add = TRUE)
  p$wait(3000)
  pkgs <- p$get_result()
  if (length(pkgs) > 1) print(pkgs)
  ## Some R versions still load compiler...
  expect_true(all(pkgs %in% c("base", "compiler")))
})

test_that("r_session does not load anything", {
  skip_in_covr()
  skip_if_not_installed("withr")
  rs <- withr::with_envvar(clean_envvars(), r_session$new())
  on.exit(rs$close(), add = TRUE)
  pkgs <- rs$run(without_env(function() loadedNamespaces()))
  if (length(pkgs) > 1) print(pkgs)
  ## Some R versions still load compiler...
  expect_true(all(pkgs %in% c("base", "compiler")))
  gc()
})

test_that("r() does not create objects in global env", {
  vars <- r(function() ls(.GlobalEnv))
  expect_identical(vars, character())
})

test_that("r_bg() does not create objects in global env", {
  p <- r_bg(function() ls(.GlobalEnv))
  on.exit(p$kill(), add = TRUE)
  p$wait(3000)
  vars <- p$get_result()
  expect_identical(vars, character())
})

test_that("r_session does not create objects in global env", {
  rs <- r_session$new()
  on.exit(rs$close(), add = TRUE)
  vars <- rs$run(function() ls(.GlobalEnv))
  expect_identical(vars, character())
  rs$close()
  gc()
})

test_that("quit() in the function", {
  x <- r(function() quit())
  expect_null(x)

  expect_error(
    r(function() quit(status = 2)), "non-zero status",
    class = "callr_status_error")
  gc()
})

test_that("quit() in bg process", {
  p1 <- r_bg(function() quit())
  on.exit(p1$kill())
  p1$wait()
  expect_null(p1$get_result())

  close(p1$get_output_connection())
  close(p1$get_error_connection())

  p2 <- r_bg(function() quit(status = 2))
  on.exit(p2$kill(), add = TRUE)
  p2$wait()
  expect_error(
    p2$get_result(), "non-zero status", class = "callr_status_error")

  close(p2$get_output_connection())
  close(p2$get_error_connection())
})

test_that("set options with hook", {
  add_hook(
    test_hook = function (options) {
      within(options, {
        env["TEST_HOOK"] <- "hello"
        cmdargs <- c(cmdargs, "extra_arg")
      })
    }
  )

  options <- r_process_options(
    func = function() {
      list(env = Sys.getenv("TEST_HOOK"), args = commandArgs())
    }
  )
  x <- r_process$new(options)
  x$wait()
  res <- x$get_result()
  expect_equal(res$env, "hello")
  expect_length(grep("^extra_arg$", res$args), 1L)

  # Remove hook
  add_hook(test_hook = NULL)

  x <- r_process$new(options)
  x$wait()
  res <- x$get_result()
  expect_equal(res$env, "")
  expect_length(grep("^extra_arg$", res$args), 0L)
})

test_that("messages in callr::r do not crash session", {
  skip_if_not_installed("cli")
  ret <- r(function() { cli::cli_text("fooobar"); 1 + 1 })
  expect_identical(ret, 2)
  gc()
})

test_that("messages in callr::r_bg do not crash session", {
  skip_in_covr()  # TODO: what wrong with this on Windows?
  skip_on_cran()
  skip_if_not_installed("cli")

  rx <- r_bg(function() { cli::cli_text("fooobar"); 1 + 1 })
  rx$wait(5000)
  rx$kill()
  expect_equal(rx$get_exit_status(), 0)

  expect_equal(rx$get_result(), 2)
  processx::processx_conn_close(rx$get_output_connection())
  processx::processx_conn_close(rx$get_error_connection())
  gc()
})

test_that("error is propagated, .Last.error is set", {
  expect_r_process_snapshot(
    callr::r(function() 1 + "A", error = "error"),
    .Last.error,
    transform = redact_srcref
  )
})

test_that("error is propagated, printed if non-interactive mode", {
  expect_r_process_snapshot(
    callr::r(function() 1 + "A", error = "error"),
    interactive = FALSE,
    transform = redact_srcref
  )
})

test_that("error stack is passed, .Last.error is set", {
  expect_r_process_snapshot(
    callr::r(
      function() {
        f <- function() g()
        g <- function() 1 + "A"
        f()
      },
      error = "stack"
    ),
    .Last.error,
    transform = redact_srcref
  )
})

test_that("error behavior can be set using option", {
  skip_if_not_installed("withr")
  withr::local_options(callr.error = "error")
  expect_snapshot(
    error = TRUE,
    r(function() 1 + "A")
  )

  withr::local_options(callr.error = "stack")
  expect_snapshot(
    error = TRUE,
    r(
      function() {
        f <- function() g()
        g <- function() 1 + "A"
        f()
      }
    )
  )
})

test_that("parent errors", {
  skip_if_not_installed("withr")
  withr::local_options(list("callr.error" = "error"))
  expect_snapshot({
    err <- tryCatch(
      r(function() 1 + "A"),
      error = function(e) e
    )
    err$parent
  })
})

test_that("parent errors, another level", {
  skip_if_not_installed("withr")
  withr::local_options(list("callr.error" = "error"))
  expect_snapshot({
    err <- tryCatch(
      callr::r(function() {
        withr::local_options(list("callr.error" = "error"))
        callr::r(function() 1 + "A")
      }),
      error = function(e) e
    )
    err$parent
    err$parent$parent
  })
})

test_that("error traces are printed recursively", {
  expect_r_process_snapshot(
    callr::r(function() callr::r(function() 1 + "a")),
    interactive = FALSE,
    transform = redact_srcref
  )
})

test_that("errors in r_bg() are merged", {
  skip_if_not_installed("withr")
  withr::local_options(list("callr.error" = "error"))

  p <- r_bg(function() 1 + "A")
  on.exit(p$kill(), add = TRUE)
  p$wait(2000)

  expect_snapshot(
    error = TRUE,
    p$get_result()
  )
})

test_that("errors in r_process are merged", {
  skip_if_not_installed("withr")
  withr::local_options(list("callr.error" = "error"))

  opts <- r_process_options(func = function() 1 + "A")
  p <- r_process$new(opts)
  on.exit(p$kill(), add = TRUE)
  p$wait(2000)

  expect_snapshot(
    error = TRUE,
    p$get_result()
  )
})

test_that("errors in r_session$run() are merged", {
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  expect_snapshot(
    error = TRUE,
    rs$run(function() 1 + "A")
  )

  expect_snapshot(
    error = TRUE,
    rs$run(function() 1 + "A")
  )
})

test_that("errors in r_session$call() are merged", {
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  rs$call(function() 1 + "A")
  rs$poll_process(2000)
  expect_snapshot(rs$read()$error)

  rs$call(function() 1 + "A")
  rs$poll_process(2000)
  expect_snapshot(rs$read()$error)
})

test_that("child error is not modified", {
  expect_snapshot({
    err <- tryCatch(callr::r(function() stop("foobar")), error = function(e) e)
    err
    class(err)
    class(err$parent)
  })
})

test_that("new_callr_error, timeout", {
  expect_r_process_snapshot(
    callr::r(function() Sys.sleep(3), timeout = 1/5),
    transform = redact_srcref
  )
  expect_snapshot(
    error = TRUE,
    callr::r(function() Sys.sleep(3), timeout = 1/5)
  )
})

test_that("interrupting an R session", {
  # Not a great test, because it is timing dependent, especially bad
  # on Windows, where it takes a bit longer to start running the command.
  skip_on_cran()

  rs <- r_session$new()
  on.exit(rs$close(), add = TRUE)
  rs$call(function() Sys.sleep(3))
  # wait a bit so it starts running
  Sys.sleep(0.2)
  rs$interrupt()
  rs$poll_io(3000)

  expect_snapshot(
    rs$read(),
    transform = redact_callr_rs_result
  )
})

test_that("format.call_status_error", {
  err <- tryCatch(
    callr::r(function() 1 + ""),
    error = function(e) e
  )
  expect_snapshot(format(err))
  expect_snapshot(print(err))

  err <- tryCatch(
    callr::r(function() 1 + "", error = "stack"),
    error = function(e) e
  )
  expect_snapshot(format(err))
  expect_snapshot(print(err))
})

test_that("format.call_status_error 2", {
  skip_if_not_installed("withr")
  expect_r_process_snapshot(
    withr::local_options(rlib_error_always_trace = TRUE),
    err <- tryCatch(
      callr::r(function() 1 + ""),
      error = function(e) e
    ),
    writeLines(format(err, trace = TRUE)),
    interactive = FALSE,
    transform = redact_srcref
  )
})

test_that("stdout/stderr is printed on error", {
  expect_r_process_snapshot(
    callr::r(function() {
      warning("I have a bad feeling about this")
      stop("told ya")
    }),
    .Last.error,
    .Last.error$stderr,
    interactive = TRUE,
    transform = function(x) fix_eol(redact_srcref(x))
  )
})

test_that("stdout/stderr is printed on error 2", {
  expect_r_process_snapshot(
    callr::r(function() {
      writeLines("Just some output")
      stop("told ya")
    }),
    .Last.error,
    .Last.error$stdout,
    interactive = TRUE,
    transform = function(x) fix_eol(redact_srcref(x))
  )
})

test_that("stdout/stderr is printed on error 3", {
  expect_r_process_snapshot(
    callr::r(function() {
      writeLines("Just some output")
      warning("I have a bad feeling about this")
      stop("told ya")
    }),
    interactive = FALSE,
    transform = redact_srcref
  )
})

test_that("error is printed to file", {
  tmp <- tempfile("callr-test")
  on.exit(unlink(tmp), add = TRUE)
  err <- tryCatch(
    callr::r(function() stop("ouch"), stderr = tmp),
    error = function(e) e
  )
  expect_snapshot(
    err$stderr,
    transform = function(x) fix_eol(redact_srcref(x))
  )
  expect_snapshot(readLines(tmp))
})

test_that("r()", {
  # not passed by default
  error <- tryCatch(
    r(callr:::remove_source, list(r)),
    error = function(e) e
  )
  expect_match(conditionMessage(error), "could not find function")

  # keep it
  out <- r(callr:::remove_source, list(r), package = TRUE)
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")

  # set it explicitly to package env
  out <- r(function(x) remove_source(x), list(r), package = "callr")
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")
})

test_that("r_bg()", {
  # not passed by default
  p1 <- r_bg(callr:::remove_source, list(r))
  on.exit(p1$kill(), add = TRUE)
  p2 <- r_bg(callr:::remove_source, list(r), package = TRUE)
  on.exit(p2$kill(), add = TRUE)
  p3 <- r_bg(function(x) remove_source(x), list(r), package = "callr")
  on.exit(p3$kill(), add = TRUE)

  p1$wait(3000)
  p1$kill()
  error <- tryCatch(p1$get_result(), error = function(e) e)
  expect_match(conditionMessage(error), "could not find function")

  p2$wait(3000)
  p2$kill()
  out <- p2$get_result()
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")

  p3$wait(3000)
  p3$kill()
  out <- p3$get_result()
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")
})

test_that("r_session", {
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  error <- tryCatch(
    rs$run(callr:::remove_source, list(r)),
    error = function(e) e
  )
  expect_match(conditionMessage(error), "could not find function")

  # keep it
  out <- rs$run(callr:::remove_source, list(r), package = TRUE)
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")

  # set it explicitly to package env
  out <- rs$run(function(x) remove_source(x), list(r), package = "callr")
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")
})

test_that("quit() in the function", {
  x <- r(function() quit())
  expect_null(x)

  expect_error(
    r(function() quit(status = 2)),
    "non-zero status",
    class = "callr_status_error"
  )
  gc()
})

test_that("quit() in bg process", {
  p1 <- r_bg(function() quit())
  on.exit(p1$kill())
  p1$wait()
  expect_null(p1$get_result())

  close(p1$get_output_connection())
  close(p1$get_error_connection())

  p2 <- r_bg(function() quit(status = 2))
  on.exit(p2$kill(), add = TRUE)
  p2$wait()
  expect_error(
    p2$get_result(),
    "non-zero status",
    class = "callr_status_error"
  )

  close(p2$get_output_connection())
  close(p2$get_error_connection())
})

test_that("r() to the other arch", {
  skip_on_cran()
  archs <- supported_archs()
  if (length(archs) < 1) {
    return(expect_true(TRUE))
  }
  ret <- unlist(lapply(
    archs,
    function(a) r(function() .Platform$r_arch, arch = a)
  ))
  expect_equal(ret, archs)
})

test_that("r_bg() to the other arch", {
  skip_on_cran()
  archs <- supported_archs()
  if (length(archs) < 1) {
    return(expect_true(TRUE))
  }
  procs <- lapply(archs, function(a) {
    r_bg(function() .Platform$r_arch, arch = a)
  })
  on.exit(lapply(procs, function(p) p$kill()), add = TRUE)
  for (p in procs) {
    p$wait(3000)
  }
  for (p in procs) {
    expect_false(p$is_alive())
  }
  res <- unlist(lapply(procs, function(p) p$get_result()))
  expect_equal(res, archs)
})

test_that("r_process to the other arch", {
  skip_on_cran()
  archs <- supported_archs()
  if (length(archs) < 1) {
    return(expect_true(TRUE))
  }
  procs <- lapply(archs, function(a) {
    opts <- r_process_options(
      func = function() .Platform$r_arch,
      arch = a
    )
    r_process$new(opts)
  })
  on.exit(lapply(procs, function(p) p$kill()), add = TRUE)
  for (p in procs) {
    p$wait(3000)
  }
  for (p in procs) {
    expect_false(p$is_alive())
  }
  res <- unlist(lapply(procs, function(p) p$get_result()))
  expect_equal(res, archs)
})

test_that("r_session to the other arch", {
  skip_on_cran()
  archs <- supported_archs()
  if (length(archs) < 1) {
    return(expect_true(TRUE))
  }
  ret <- unlist(lapply(archs, function(a) {
    opts <- r_session_options(arch = a)
    rs <- r_session$new(opts)
    on.exit(rs$close(), add = TRUE)
    rs$run(function() .Platform$r_arch)
  }))
  expect_equal(ret, archs)
})

test_that("r_bg runs", {
  x <- r_bg(function() 1 + 1)
  x$wait()
  expect_identical(x$get_result(), 2)
  rm(x)
  gc()
})

test_that("r_bg takes arguments", {
  x <- r_bg(function(x) x + 10, args = list(32))
  x$wait()
  expect_identical(x$get_result(), 42)
  rm(x)
  gc()
})

test_that("r_bg can be killed", {
  x <- r_bg(function() Sys.sleep(2))
  x$kill()
  expect_false(x$is_alive())
  expect_snapshot(error = TRUE, x$get_result())
  rm(x)
  gc()
})

test_that("r_bg can get the error back", {
  x <- r_bg(function() 1 + "A", error = "error")
  x$wait()
  expect_snapshot(error = TRUE, x$get_result())
  rm(x)
  gc()
})

test_that("r_bg exit status is non-zero on error (#291)", {
  x <- r_bg(function() stop("boom"))
  x$wait()
  expect_equal(x$get_exit_status(), 1)

  y <- r_bg(function() 1 + 1)
  y$wait()
  expect_equal(y$get_exit_status(), 0)
})

test_that("can read standard output", {
  x <- r_bg(function() cat("Hello world!\n"))
  x$wait()
  expect_equal(x$read_output_lines(), "Hello world!")
  rm(x)
  gc()
})

test_that("can read standard error", {
  x <- r_bg(function() message("Hello world!"))
  x$wait()
  expect_equal(x$read_error_lines(), "Hello world!")
  rm(x)
  gc()
})

test_that("can read stdout and stderr", {
  x <- r_bg(function() {
    cat("Hello world!\n")
    message("Again!")
  })
  x$wait()
  expect_equal(x$read_output_lines(), "Hello world!")
  expect_equal(x$read_error_lines(), "Again!")
  rm(x)
  gc()
})

test_that("cleans up temporary files", {
  skip_on_cran()

  rbg <- function() {
    library(callr)
    old <- dir(tempdir(), pattern = "^callr-")
    rp <- callr::r_bg(function() 1 + 1)
    on.exit(tryCatch(rp$kill, error = function(e) NULL), add = TRUE)
    rp$wait(5000)
    rp$kill()
    result <- rp$get_result()

    rm(rp)
    gc()
    gc()

    unloadNamespace("callr")
    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rbg)
  expect_identical(out$result, 2)
  expect_identical(out$new, character())
})

test_that("error is propagated, .Last.error is set", {
  expect_r_process_snapshot(
    callr::r(function() 1 + "A", error = "error"),
    .Last.error,
    transform = redact_srcref
  )
})

test_that("error is propagated, printed if non-interactive mode", {
  expect_r_process_snapshot(
    callr::r(function() 1 + "A", error = "error"),
    interactive = FALSE,
    transform = redact_srcref
  )
})

test_that("error stack is passed, .Last.error is set", {
  expect_r_process_snapshot(
    callr::r(
      function() {
        f <- function() g()
        g <- function() 1 + "A"
        f()
      },
      error = "stack"
    ),
    .Last.error,
    transform = redact_srcref
  )
})

test_that("error behavior can be set using option", {
  skip_if_not_installed("withr")

  withr::local_options(list("callr.error" = "error"))
  expect_snapshot(error = TRUE, callr::r(function() 1 + "A"))

  expect_r_process_snapshot({
    options(callr.error = "error")
    callr::r(function() 1 + "A")
  })

  withr::local_options(callr.error = "stack")
  expect_error(
    r(
      function() {
        f <- function() g()
        g <- function() 1 + "A"
        f()
      }
    )
  )

  expect_r_process_snapshot({
    options(callr.error = "stack")
    callr::r(
      function() {
        f <- function() g()
        g <- function() 1 + "A"
        f()
      }
    )
  })
})

test_that("parent errors", {
  skip_if_not_installed("withr")
  withr::local_options(list("callr.error" = "error"))
  expect_snapshot({
    err <- tryCatch(
      r(function() 1 + "A"),
      error = function(e) e
    )
    err$parent
  })
})

test_that("parent errors, another level", {
  skip_if_not_installed("withr")
  withr::local_options(list("callr.error" = "error"))
  expect_snapshot({
    err <- tryCatch(
      callr::r(function() {
        withr::local_options(list("callr.error" = "error"))
        callr::r(function() 1 + "A")
      }),
      error = function(e) e
    )
    err$parent
    err$parent$parent
  })
})

test_that("error traces are printed recursively", {
  expect_r_process_snapshot(
    callr::r(function() callr::r(function() 1 + "a")),
    interactive = FALSE,
    transform = redact_srcref
  )
})

test_that("errors in r_bg() are merged", {
  skip_if_not_installed("withr")
  withr::local_options(list("callr.error" = "error"))

  p <- r_bg(function() 1 + "A")
  on.exit(p$kill(), add = TRUE)
  p$wait(2000)

  expect_snapshot(
    error = TRUE,
    p$get_result()
  )
})

test_that("errors in r_process are merged", {
  skip_if_not_installed("withr")
  withr::local_options(list("callr.error" = "error"))

  opts <- r_process_options(func = function() 1 + "A")
  p <- r_process$new(opts)
  on.exit(p$kill(), add = TRUE)
  p$wait(2000)

  expect_snapshot(
    error = TRUE,
    p$get_result()
  )
})

test_that("errors in r_session$run() are merged", {
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  expect_snapshot(
    error = TRUE,
    rs$run(function() 1 + "A")
  )

  expect_snapshot(
    error = TRUE,
    rs$run(function() 1 + "A")
  )
})

test_that("errors in r_session$call() are merged", {
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  rs$call(function() 1 + "A")
  rs$poll_process(2000)
  expect_snapshot(rs$read()$error)

  rs$call(function() 1 + "A")
  rs$poll_process(2000)
  expect_snapshot(rs$read()$error)
})

test_that("child error is not modified", {
  expect_snapshot({
    err <- tryCatch(callr::r(function() stop("foobar")), error = function(e) e)
    err
    class(err)
    class(err$parent)
  })
})

test_that("new_callr_error, timeout", {
  expect_r_process_snapshot(
    callr::r(function() Sys.sleep(3), timeout = 1 / 5),
    transform = redact_srcref
  )
  expect_snapshot(
    error = TRUE,
    callr::r(function() Sys.sleep(3), timeout = 1 / 5)
  )
})

test_that("interrupting an R session", {
  # Not a great test, because it is timing dependent, especially bad
  # on Windows, where it takes a bit longer to start running the command.
  skip_on_cran()

  rs <- r_session$new()
  on.exit(rs$close(), add = TRUE)
  rs$call(function() Sys.sleep(3))
  # wait a bit so it starts running
  Sys.sleep(0.2)
  rs$interrupt()
  rs$poll_io(3000)

  expect_snapshot(
    rs$read(),
    transform = redact_callr_rs_result
  )
})

test_that("format.call_status_error", {
  err <- tryCatch(
    callr::r(function() 1 + ""),
    error = function(e) e
  )
  expect_snapshot(format(err))
  expect_snapshot(print(err))

  err <- tryCatch(
    callr::r(function() 1 + "", error = "stack"),
    error = function(e) e
  )
  expect_snapshot(format(err))
  expect_snapshot(print(err))
})

test_that("format.call_status_error 2", {
  skip_if_not_installed("withr")
  expect_r_process_snapshot(
    withr::local_options(rlib_error_always_trace = TRUE),
    err <- tryCatch(
      callr::r(function() 1 + ""),
      error = function(e) e
    ),
    writeLines(format(err, trace = TRUE)),
    interactive = FALSE,
    transform = redact_srcref
  )
})

test_that("stdout/stderr is printed on error", {
  expect_r_process_snapshot(
    callr::r(function() {
      warning("I have a bad feeling about this")
      stop("told ya")
    }),
    .Last.error,
    .Last.error$stderr,
    interactive = TRUE,
    transform = function(x) fix_eol(redact_srcref(x))
  )
})

test_that("stdout/stderr is printed on error 2", {
  expect_r_process_snapshot(
    callr::r(function() {
      writeLines("Just some output")
      stop("told ya")
    }),
    .Last.error,
    .Last.error$stdout,
    interactive = TRUE,
    transform = function(x) fix_eol(redact_srcref(x))
  )
})

test_that("stdout/stderr is printed on error 3", {
  expect_r_process_snapshot(
    callr::r(function() {
      writeLines("Just some output")
      warning("I have a bad feeling about this")
      stop("told ya")
    }),
    interactive = FALSE,
    transform = redact_srcref
  )
})

test_that("error is printed to file", {
  tmp <- tempfile("callr-test")
  on.exit(unlink(tmp), add = TRUE)
  err <- tryCatch(
    callr::r(function() stop("ouch"), stderr = tmp),
    error = function(e) e
  )
  expect_snapshot(
    err$stderr,
    transform = function(x) fix_eol(redact_srcref(x))
  )
  expect_snapshot(readLines(tmp))
})

test_that("r() does not load anything", {
  skip_in_covr()
  skip_if_not_installed("withr")
  pkgs <- withr::with_envvar(
    clean_envvars(),
    r(without_env(function() loadedNamespaces()))
  )
  if (length(pkgs) > 1) {
    print(pkgs)
  }
  ## Some R versions still load compiler...
  expect_true(all(pkgs %in% c("base", "compiler")))
})

test_that("r_bg() does not load anything", {
  skip_in_covr()
  skip_if_not_installed("withr")
  p <- withr::with_envvar(
    clean_envvars(),
    r_bg(without_env(function() loadedNamespaces()))
  )
  on.exit(p$kill(), add = TRUE)
  p$wait(3000)
  pkgs <- p$get_result()
  if (length(pkgs) > 1) {
    print(pkgs)
  }
  ## Some R versions still load compiler...
  expect_true(all(pkgs %in% c("base", "compiler")))
})

test_that("r_session does not load anything", {
  skip_in_covr()
  skip_if_not_installed("withr")
  rs <- withr::with_envvar(clean_envvars(), r_session$new())
  on.exit(rs$close(), add = TRUE)
  pkgs <- rs$run(without_env(function() loadedNamespaces()))
  if (length(pkgs) > 1) {
    print(pkgs)
  }
  ## Some R versions still load compiler...
  expect_true(all(pkgs %in% c("base", "compiler")))
  gc()
})

test_that("r() does not create objects in global env", {
  vars <- r(function() ls(.GlobalEnv))
  expect_identical(vars, character())
})

test_that("r_bg() does not create objects in global env", {
  p <- r_bg(function() ls(.GlobalEnv))
  on.exit(p$kill(), add = TRUE)
  p$wait(3000)
  vars <- p$get_result()
  expect_identical(vars, character())
})

test_that("r_session does not create objects in global env", {
  rs <- r_session$new()
  on.exit(rs$close(), add = TRUE)
  vars <- rs$run(function() ls(.GlobalEnv))
  expect_identical(vars, character())
  rs$close()
  gc()
})

test_that("r()", {
  # not passed by default
  error <- tryCatch(
    r(callr:::remove_source, list(r)),
    error = function(e) e
  )
  expect_match(conditionMessage(error), "could not find function")

  # keep it
  out <- r(callr:::remove_source, list(r), package = TRUE)
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")

  # set it explicitly to package env
  out <- r(function(x) remove_source(x), list(r), package = "callr")
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")
})

test_that("r_bg()", {
  # fails in covr :(
  testthat::skip_on_covr()
  # not passed by default
  p1 <- r_bg(callr:::remove_source, list(r))
  on.exit(p1$kill(), add = TRUE)
  p2 <- r_bg(callr:::remove_source, list(r), package = TRUE)
  on.exit(p2$kill(), add = TRUE)
  p3 <- r_bg(function(x) remove_source(x), list(r), package = "callr")
  on.exit(p3$kill(), add = TRUE)

  p1$wait(3000)
  p1$kill()
  error <- tryCatch(p1$get_result(), error = function(e) e)
  expect_match(conditionMessage(error), "could not find function")

  p2$wait(3000)
  p2$kill()
  out <- p2$get_result()
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")

  p3$wait(3000)
  p3$kill()
  out <- p3$get_result()
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")
})

test_that("r_session", {
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  error <- tryCatch(
    rs$run(callr:::remove_source, list(r)),
    error = function(e) e
  )
  expect_match(conditionMessage(error), "could not find function")

  # keep it
  out <- rs$run(callr:::remove_source, list(r), package = TRUE)
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")

  # set it explicitly to package env
  out <- rs$run(function(x) remove_source(x), list(r), package = "callr")
  expect_true(is.function(out))
  expect_equal(environmentName(environment(out)), "callr")
})

test_that("r() preserves the environment of crated functions by default", {
  skip_if_not_installed("carrier")
  fn <- carrier::crate(function() payload, payload = 42)
  expect_equal(r(fn), 42)

  # explicit package = FALSE still wipes the environment
  err <- tryCatch(r(fn, package = FALSE), error = function(e) e)
  expect_match(conditionMessage(err), "payload")
})

test_that("r_bg() preserves the environment of crated functions by default", {
  skip_if_not_installed("carrier")
  testthat::skip_on_covr()
  fn <- carrier::crate(function() payload, payload = 42)
  p <- r_bg(fn)
  on.exit(p$kill(), add = TRUE)
  p$wait(3000)
  p$kill()
  expect_equal(p$get_result(), 42)
})

test_that("r_session$run() preserves the env of crated funcs by default", {
  skip_if_not_installed("carrier")
  fn <- carrier::crate(function() payload, payload = 42)
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)
  expect_equal(rs$run(fn), 42)
})

test_that("messages in callr::r do not crash session", {
  skip_if_not_installed("cli")
  ret <- r(function() {
    cli::cli_text("fooobar")
    1 + 1
  })
  expect_identical(ret, 2)
  gc()
})

test_that("messages in callr::r_bg do not crash session", {
  skip_in_covr() # TODO: what wrong with this on Windows?
  skip_on_cran()
  skip_if_not_installed("cli")

  rx <- r_bg(function() {
    cli::cli_text("fooobar")
    1 + 1
  })
  rx$wait(5000)
  rx$kill()
  expect_equal(rx$get_exit_status(), 0)

  expect_equal(rx$get_result(), 2)
  processx::processx_conn_close(rx$get_output_connection())
  processx::processx_conn_close(rx$get_error_connection())
  gc()
})

test_that("callr::r() produces a span when tracing is enabled", {
  out <- otelsdk::with_otel_record({
    r(function() 1 + 1)
  })
  expect_equal(out$value, 2)
  spans <- out$traces
  expect_length(spans, 1L)
  expect_equal(spans[[1]]$name, "callr::r")
  expect_equal(spans[[1]]$instrumentation_scope$name, "org.r-lib.callr")
  expect_equal(spans[[1]]$status, "ok")
})

test_that("callr::rscript() produces a span", {
  tmp <- tempfile(fileext = ".R")
  on.exit(unlink(tmp), add = TRUE)
  writeLines("invisible(NULL)", tmp)
  out <- otelsdk::with_otel_record(rscript(tmp, fail_on_status = FALSE))
  names <- vapply(out$traces, "[[", character(1), "name")
  expect_true("callr::rscript" %in% names)
})

test_that("callr::rcmd() produces a span", {
  out <- otelsdk::with_otel_record(rcmd("Rscript", c("-e", "1+1")))
  names <- vapply(out$traces, "[[", character(1), "name")
  expect_true("callr::rcmd" %in% names)
})

test_that("TRACEPARENT is propagated to subprocess", {
  out <- otelsdk::with_otel_record({
    r(function() Sys.getenv("TRACEPARENT"))
  })
  expect_match(
    out$value,
    "^00-[0-9a-f]{32}-[0-9a-f]{16}-[0-9a-f]{2}$"
  )
  span <- out$traces[[1]]
  expect_true(grepl(span$trace_id, out$value, fixed = TRUE))
  expect_true(grepl(span$span_id, out$value, fixed = TRUE))
})

test_that("subprocess errors generate an exception event", {
  out <- otelsdk::with_otel_record({
    tryCatch(r(function() stop("boom")), error = function(e) NULL)
  })
  expect_length(out$traces, 1L)
  events <- vapply(out$traces[[1]]$events, "[[", character(1), "name")
  expect_true("exception" %in% events)
})

test_that("r_session produces spans for the session lifecycle", {
  out <- otelsdk::with_otel_record({
    rs <- r_session$new()
    v <- rs$run(function() 1 + 1)
    rs$close()
    v
  })
  expect_equal(out$value, 2)

  names <- vapply(out$traces, "[[", character(1), "name")
  expect_true("callr::r_session" %in% names)
  expect_true("r_session$initialize() wait" %in% names)
  expect_true("r_session$call" %in% names)
  expect_true("r_session$close" %in% names)
  expect_true("r_session$read" %in% names)

  session_span <- out$traces[[which(names == "callr::r_session")]]
  expect_equal(session_span$parent, "0000000000000000")

  children <- out$traces[names != "callr::r_session"]
  for (ch in children) {
    expect_equal(ch$parent, session_span$span_id)
  }
})

test_that("r_session$read sets message and status_code attributes", {
  out <- otelsdk::with_otel_record({
    rs <- r_session$new()
    rs$run(function() 1 + 1)
    rs$close()
  })
  names <- vapply(out$traces, "[[", character(1), "name")
  read_spans <- out$traces[names == "r_session$read"]
  expect_gt(length(read_spans), 0L)
  with_message <- vapply(
    read_spans,
    function(s) isTRUE(s$attributes$message),
    logical(1)
  )
  expect_true(any(with_message))
  msg_span <- read_spans[with_message][[1]]
  expect_true("status_code" %in% names(msg_span$attributes))
})

test_that("r_process produces a span and records the get_result event", {
  out <- otelsdk::with_otel_record({
    rp <- r_bg(function() Sys.sleep(0.05))
    # Poll while alive to trigger the "Still alive" branch with the event
    while (rp$is_alive()) {
      tryCatch(rp$get_result(), error = function(e) NULL)
      Sys.sleep(0.01)
    }
    rp$get_result()
  })
  names <- vapply(out$traces, "[[", character(1), "name")
  expect_true("callr::r_process" %in% names)
  span <- out$traces[[which(names == "callr::r_process")[1]]]
  events <- vapply(span$events, "[[", character(1), "name")
  expect_true("get_result" %in% events)
})

test_that("tracing is disabled when no SDK is configured", {
  expect_false(otel::is_tracing_enabled("org.r-lib.callr"))
})

test_that("set options with hook", {
  add_hook(
    test_hook = function(options) {
      within(options, {
        env["TEST_HOOK"] <- "hello"
        cmdargs <- c(cmdargs, "extra_arg")
      })
    }
  )

  options <- r_process_options(
    func = function() {
      list(env = Sys.getenv("TEST_HOOK"), args = commandArgs())
    }
  )
  x <- r_process$new(options)
  x$wait()
  res <- x$get_result()
  expect_equal(res$env, "hello")
  expect_length(grep("^extra_arg$", res$args), 1L)

  # Remove hook
  add_hook(test_hook = NULL)

  x <- r_process$new(options)
  x$wait()
  res <- x$get_result()
  expect_equal(res$env, "")
  expect_length(grep("^extra_arg$", res$args), 0L)
})

#' Run an `R CMD` command in the background
#'
#' The child process is started in the background, and the function
#' return immediately.
#'
#' @inheritSection r Security considerations
#' @inheritParams rcmd
#' @param supervise Whether to register the process with a supervisor. If \code{TRUE},
#'   the supervisor will ensure that the process is killed when the R process
#'   exits.
#' @param ... Extra arguments are passed to the [processx::process]
#'   constructor.
#' @return It returns a [process] object.
#'
#' @family R CMD commands
#' @export

rcmd_bg <- function(
  cmd,
  cmdargs = character(),
  libpath = .libPaths(),
  stdout = "|",
  stderr = "|",
  poll_connection = TRUE,
  repos = default_repos(),
  system_profile = FALSE,
  user_profile = "project",
  env = rcmd_safe_env(),
  wd = ".",
  supervise = FALSE,
  ...
) {
  options <- as.list(environment())
  options$extra <- list(...)
  rcmd_process$new(options = options)
}

test_that("create and run rcmd_process", {
  opts <- rcmd_process_options(cmd = "config", cmdargs = "CC")
  x <- rcmd_process$new(opts)
  x$wait()
  expect_equal(x$get_exit_status(), 0)
  out <- x$read_output_lines()
  expect_match(out, ".")
  rm(x)
  gc()
})

test_that("cleans up temp files", {

  skip_on_cran()

  rc <- function() {
    library(callr)
    scriptfile <- tempfile(fileext = ".R")

    old <- dir(tempdir(), pattern = "^callr-")

    rp <- rcmd_bg("config", "CC")
    on.exit(tryCatch(rp$kill, error = function(e) NULL), add = TRUE)
    rp$wait(5000)
    result <- rp$get_exit_status()
    rp$kill()

    rm(rp)
    gc()
    gc()
    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rc)
  expect_identical(out$result, 0L)
  expect_identical(out$new, character())
})

test_that("rcmd_bg runs", {
  out1 <- gsub("\r?\n", "", rcmd("config", "CC")$stdout)
  x <- rcmd_bg("config", "CC")
  x$wait()
  out2 <- x$read_output_lines()
  expect_equal(out1, out2)
  expect_equal(x$get_exit_status(), 0)
  rm(x)
  gc()
})

test_that("r_cmd can be killed", {
  cat("Sys.sleep(5)", file = tmp <- tempfile())
  on.exit(try_silently(unlink(tmp)), add = TRUE)

  x <- rcmd_bg("BATCH", tmp)
  expect_true(x$is_alive())

  x$kill()
  expect_false(x$is_alive())
  rm(x)
  gc()
})

test_that("r_cmd errors", {
  x <- rcmd_bg("config", "axaxaxaxax")
  x$wait()
  expect_equal(x$get_exit_status(), 1)
  rm(x)
  gc()
})

test_that("create and run rcmd_process", {
  opts <- rcmd_process_options(cmd = "config", cmdargs = "CC")
  x <- rcmd_process$new(opts)
  x$wait()
  expect_equal(x$get_exit_status(), 0)
  out <- x$read_output_lines()
  expect_match(out, ".")
  rm(x)
  gc()
})

test_that("cleans up temp files", {
  skip_on_cran()

  rc <- function() {
    library(callr)
    scriptfile <- tempfile(fileext = ".R")

    old <- dir(tempdir(), pattern = "^callr-")

    rp <- rcmd_bg("config", "CC")
    on.exit(tryCatch(rp$kill, error = function(e) NULL), add = TRUE)
    rp$wait(5000)
    result <- rp$get_exit_status()
    rp$kill()

    rm(rp)
    gc()
    gc()
    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rc)
  expect_identical(out$result, 0L)
  expect_identical(out$new, character())
})

test_that("rcmd_bg runs", {
  out1 <- gsub("\r?\n", "", rcmd("config", "CC")$stdout)
  x <- rcmd_bg("config", "CC")
  x$wait()
  out2 <- x$read_output_lines()
  expect_equal(out1, out2)
  expect_equal(x$get_exit_status(), 0)
  rm(x)
  gc()
})

test_that("r_cmd can be killed", {
  cat("Sys.sleep(5)", file = tmp <- tempfile())
  on.exit(try_silently(unlink(tmp)), add = TRUE)

  x <- rcmd_bg("BATCH", tmp)
  expect_true(x$is_alive())

  x$kill()
  expect_false(x$is_alive())
  rm(x)
  gc()
})

test_that("r_cmd errors", {
  x <- rcmd_bg("config", "axaxaxaxax")
  x$wait()
  expect_equal(x$get_exit_status(), 1)
  rm(x)
  gc()
})

file_from_env <- function(var) {
  if (file.exists(f <- Sys.getenv(var))) readLines(f)
}

if (Sys.getenv("CALLR_DUMP_HERE") != "") {
  saveRDS(
    list(
      env = Sys.getenv(),
      libpaths = .libPaths(),
      search = search(),
      R_ENVIRON = file_from_env("R_ENVIRON"),
      R_ENVIRON_USER = file_from_env("R_ENVIRON_USER"),
      R_PROFILE = file_from_env("R_PROFILE"),
      R_PROFILE_USER = file_from_env("R_PROFILE_USER")
    ),
    file = Sys.getenv("CALLR_DUMP_HERE")
  )
}

#' Run an R script
#'
#' It uses the `Rscript` program corresponding to the current R version,
#' to run the script. It streams `stdout` and `stderr` of the process.
#'
#' @inheritSection r Security considerations
#' @inheritParams rcmd
#' @param script Path of the script to run.
#' @param color Whether to use terminal colors in the child process,
#'    assuming they are active in the parent process.
#'
#' @export

rscript <- function(
  script,
  cmdargs = character(),
  libpath = .libPaths(),
  repos = default_repos(),
  stdout = NULL,
  stderr = NULL,
  poll_connection = TRUE,
  echo = FALSE,
  show = TRUE,
  callback = NULL,
  block_callback = NULL,
  spinner = FALSE,
  system_profile = FALSE,
  user_profile = "project",
  env = rcmd_safe_env(),
  timeout = Inf,
  wd = ".",
  fail_on_status = TRUE,
  color = TRUE,
  ...
) {
  load_hook <- rscript_load_hook_color(color)

  options <- convert_and_check_my_args(as.list(environment()))
  options$extra <- list(...)

  options <- setup_context(options)
  options <- setup_callbacks(options)

  options <- setup_rscript_binary_and_args(options)

  ## This cleans up everything...
  on.exit(unlink(options$tmp_files, recursive = TRUE), add = TRUE)

  if (otel::is_tracing_enabled()) {
    otel::start_local_active_span(
      "callr::rscript",
      attributes = otel::as_attributes(options)
    )
    hdrs <- otel::pack_http_context()
    names(hdrs) <- toupper(names(hdrs))
    options$env[names(hdrs)] <- hdrs
  }

  invisible(run_r(options))
}

rscript_load_hook_color <- function(color) {
  if (!color) {
    return("")
  }

  nc <- tryCatch(
    cli::num_ansi_colors(),
    error = function(e) 1L
  )
  if (nc == 1) {
    return("")
  }

  expr <- substitute(
    options(crayon.enabled = TRUE, crayon.colors = `_nc_`),
    list("_nc_" = nc)
  )
  paste0(deparse(expr), "\n")
}

#' External `Rscript` process
#'
#' @description
#' An `Rscript script.R` command that runs in the background. This is an
#' R6 class that extends the [processx::process] class.
#'
#' @name rscript_process
#' @examplesIf FALSE
#' options <- rscript_process_options(script = "script.R")
#' rp <- rscript_process$new(options)
#' rp$wait()
#' rp$read_output_lines()
#' @export

rscript_process <- suppressMessages(R6::R6Class(
  "rscript_process",
  inherit = processx::process,
  public = list(
    #' @description Create a new `Rscript` process.
    #' @param options A list of options created via
    #'   [rscript_process_options()].
    initialize = function(options) rscript_init(self, private, super, options),

    #' @description Delete the temporary files created for this `Rscript`
    #' process. Only call this method if you are sure that the process is
    #' done. If you don't call this method explicitly, the temporary files
    #' will be deleted when the process object is garbage collected.
    cleanup = function() {
      unlink(private$options$tmp_files, recursive = TRUE)
    },

    #' @description Clean up after an `Rscript` process, remove temporary files.
    finalize = function() {
      self$cleanup()
      if ("finalize" %in% ls(super)) super$finalize()
    }
  ),
  private = list(
    options = NULL
  )
))

rscript_init <- function(self, private, super, options) {
  options$load_hook <- rscript_load_hook_color(options$color)
  options <- convert_and_check_my_args(options)
  options <- setup_context(options)
  options <- setup_rscript_binary_and_args(options)

  private$options <- options

  oldwd <- getwd()
  setwd(options$wd)
  on.exit(setwd(oldwd), add = TRUE)

  pty <- isTRUE(options$extra$pty)

  with_envvar(
    options$env,
    do.call(
      super$initialize,
      c(
        list(
          options$bin,
          options$real_cmdargs,
          stdout = if (pty) NULL else options$stdout,
          stderr = if (pty) NULL else options$stderr,
          poll_connection = options$poll_connection
        ),
        options$extra
      )
    )
  )

  invisible(self)
}

test_that("rscript", {
  out <- rscript("fixtures/script.R", show = FALSE)
  expect_equal(out$status, 0L)
  expect_equal(
    out$stdout,
    if (os_platform() == "windows") "stdout\r\n" else "stdout\n")
  expect_equal(
    out$stderr,
    if (os_platform() == "windows") "stderr\r\n" else "stderr\n")
  gc()
})

test_that("rscript_process", {
  px  <- rscript_process$new(
    rscript_process_options(script = "fixtures/script.R"))
  on.exit(try(px$kill(), silent = TRUE), add = TRUE)
  px$wait(5000)

  expect_equal(px$get_exit_status(), 0)
  expect_equal(px$read_output_lines(), "stdout")
  expect_equal(px$read_error_lines(), "stderr")
  rm(px); gc()
})

test_that("stderr -> stdout", {
  out <- rscript("fixtures/script2.R", show = FALSE, stderr = "2>&1")
  exp <- if (os_platform() == "windows") {
    "out1err1out2err2\r\n"
  } else {
    "out1err1out2err2\n"
  }
  expect_equal(out$stdout, exp)
  expect_null(out$stderr)

  out2 <- test_temp_file(create = FALSE)
  rscript("fixtures/script2.R", show = FALSE, stdout = out2, stderr = out2)
  expect_equal(readLines(out2), "out1err1out2err2")
  gc()
})

test_that("cleans up temporary files", {

  skip_on_cran()

  rsc <- function() {
    library(callr)
    scriptfile <- tempfile(fileext = ".R")
    cat("cat('foobar')\n", file = scriptfile)

    old <- dir(tempdir(), pattern = "^callr-")

    result <- callr::rscript(scriptfile)

    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rsc)
  expect_identical(out$result$stdout, "foobar")
  expect_identical(out$new, character())
})

test_that("bg process cleans up temporary files", {

  skip_on_cran()

  rsc <- function() {
    library(callr)
    scriptfile <- tempfile(fileext = ".R")
    cat("cat('foobar')\n", file = scriptfile)

    old <- dir(tempdir(), pattern = "^callr-")

    opts <- rscript_process_options(script = scriptfile)
    rp <- rscript_process$new(opts)
    on.exit(tryCatch(rp$kill, error = function(e) NULL), add = TRUE)
    rp$wait(5000)
    result <- rp$read_output()
    rp$kill()

    rm(rp)
    gc()
    gc()
    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rsc)
  expect_identical(out$result, "foobar")
  expect_identical(out$new, character())
})

test_that("rscript", {
  out <- rscript("fixtures/script.R", show = FALSE)
  expect_equal(out$status, 0L)
  expect_equal(
    out$stdout,
    if (os_platform() == "windows") "stdout\r\n" else "stdout\n"
  )
  expect_equal(
    out$stderr,
    if (os_platform() == "windows") "stderr\r\n" else "stderr\n"
  )
  gc()
})

test_that("rscript_process", {
  px <- rscript_process$new(
    rscript_process_options(script = "fixtures/script.R")
  )
  on.exit(try(px$kill(), silent = TRUE), add = TRUE)
  px$wait(5000)

  expect_equal(px$get_exit_status(), 0)
  expect_equal(px$read_output_lines(), "stdout")
  expect_equal(px$read_error_lines(), "stderr")
  rm(px)
  gc()
})

test_that("stderr -> stdout", {
  out <- rscript("fixtures/script2.R", show = FALSE, stderr = "2>&1")
  exp <- if (os_platform() == "windows") {
    "out1err1out2err2\r\n"
  } else {
    "out1err1out2err2\n"
  }
  expect_equal(out$stdout, exp)
  expect_null(out$stderr)

  out2 <- test_temp_file(create = FALSE)
  rscript("fixtures/script2.R", show = FALSE, stdout = out2, stderr = out2)
  expect_equal(readLines(out2), "out1err1out2err2")
  gc()
})

test_that("stdout = '|' does not hang when child errors (#313)", {
  skip_on_cran()
  tmp <- test_temp_file(create = FALSE)
  writeLines("stop('test error')", tmp)

  setTimeLimit(elapsed = 30, transient = TRUE)
  on.exit(setTimeLimit(), add = TRUE)

  res <- rscript(
    tmp,
    show = FALSE,
    fail_on_status = FALSE,
    timeout = 5,
    stdout = "|",
    stderr = "2>&1"
  )

  expect_false(res$timeout)
  expect_equal(res$status, 1L)
  expect_match(res$stdout, "test error")
  expect_null(res$stderr)
  gc()
})

test_that("pty = TRUE merges stderr into stdout and sets a tty", {
  skip_on_cran()

  tmp <- test_temp_file(create = FALSE)
  writeLines(
    c(
      "cat('isatty:', isatty(stdout()), '\\n')",
      "message('err line')",
      "cat('out line\\n')"
    ),
    tmp
  )

  res <- rscript(tmp, pty = TRUE, show = FALSE)
  expect_equal(res$status, 0L)
  expect_null(res$stderr)
  ## ConPTY on Windows interleaves CSI mode-change escapes with output;
  ## strip them before matching.
  out <- cli::ansi_strip(res$stdout)
  out <- sub("\033.*\a", "", out)
  expect_match(out, "isatty: TRUE")
  expect_match(out, "err line")
  expect_match(out, "out line")
})

test_that("pty = TRUE rejects a non-null stderr", {
  skip_on_cran()

  tmp <- test_temp_file(create = FALSE)
  writeLines("cat('hi\\n')", tmp)

  expect_error(
    rscript(tmp, pty = TRUE, stderr = "err.txt", show = FALSE),
    "`stderr` cannot be set when `pty = TRUE`"
  )
})

test_that("rscript_process supports pty = TRUE", {
  skip_on_cran()

  tmp <- test_temp_file(create = FALSE)
  writeLines(
    c("message('on stderr')", "cat('on stdout\\n')"),
    tmp
  )

  opts <- rscript_process_options(script = tmp, extra = list(pty = TRUE))
  px <- rscript_process$new(opts)
  on.exit(try(px$kill(), silent = TRUE), add = TRUE)
  px$wait(5000)

  expect_false(px$has_error_connection())
  out <- cli::ansi_strip(px$read_all_output())
  out <- sub("\033.*\a", "", out)
  expect_match(out, "on stderr")
  expect_match(out, "on stdout")
})

test_that("cleans up temporary files", {
  skip_on_cran()

  rsc <- function() {
    library(callr)
    scriptfile <- tempfile(fileext = ".R")
    cat("cat('foobar')\n", file = scriptfile)

    old <- dir(tempdir(), pattern = "^callr-")

    result <- callr::rscript(scriptfile)

    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rsc)
  expect_identical(out$result$stdout, "foobar")
  expect_identical(out$new, character())
})

test_that("bg process cleans up temporary files", {
  skip_on_cran()

  rsc <- function() {
    library(callr)
    scriptfile <- tempfile(fileext = ".R")
    cat("cat('foobar')\n", file = scriptfile)

    old <- dir(tempdir(), pattern = "^callr-")

    opts <- rscript_process_options(script = scriptfile)
    rp <- rscript_process$new(opts)
    on.exit(tryCatch(rp$kill, error = function(e) NULL), add = TRUE)
    rp$wait(5000)
    result <- rp$read_output()
    rp$kill()

    rm(rp)
    gc()
    gc()
    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rsc)
  expect_identical(out$result, "foobar")
  expect_identical(out$new, character())
})

#' Run an R child process, with no configuration
#'
#' It tries to mimic a fresh R installation. In particular:
#' * No library path setting.
#' * No CRAN(-like) repository is set.
#' * The system and user profiles are not run.
#'
#' @param ... Additional arguments are passed to [r()].
#' @inheritParams r
#' @inheritSection r Security considerations
#'
#' @family callr functions
#' @export
#' @examplesIf FALSE
#' # Compare to r()
#' r(function() .libPaths())
#' r_vanilla(function() .libPaths())
#'
#' r(function() getOption("repos"))
#' r_vanilla(function() getOption("repos"))

r_vanilla <- function(
  func,
  args = list(),
  libpath = character(),
  repos = c(CRAN = "@CRAN@"),
  cmdargs = "--slave",
  system_profile = FALSE,
  user_profile = FALSE,
  env = character(),
  ...
) {
  r(
    func,
    args = args,
    libpath = libpath,
    repos = repos,
    cmdargs = cmdargs,
    system_profile = system_profile,
    user_profile = user_profile,
    env = env,
    ...
  )
}

#' @rdname r
#' @export

r_safe <- r

#' Run an R process that mimics the current R process
#'
#' Differences to [r()]:
#' * No extra repositories are set up.
#' * The `--no-save`, `--no-restore`
#'   command line arguments are not used. (But `--slave` still is.)
#' * The system profile and the user profile are loaded.
#' * No extra environment variables are set up.
#'
#' @inheritSection r Security considerations
#' @inheritParams r
#' @param ... Additional arguments are passed to [r()].
#'
#' @family callr functions
#' @export

r_copycat <- function(
  func,
  args = list(),
  libpath = .libPaths(),
  repos = getOption("repos"),
  cmdargs = "--slave",
  system_profile = TRUE,
  user_profile = TRUE,
  env = character(),
  ...
) {
  r(
    func,
    args = args,
    libpath = libpath,
    repos = repos,
    cmdargs = cmdargs,
    system_profile = system_profile,
    user_profile = user_profile,
    env = env,
    ...
  )
}

test_that("r", {
  skip_if_not_installed("withr")

  withr::with_options(
    list(repos = "foobar"),
    expect_equal(
      r_copycat(function() getOption("repos"),
        user_profile = FALSE,
        system_profile = FALSE
      ),
      "foobar"
    )
  )
  gc()
})

## Need to supply libpath for covr...
test_that("r_vanilla", {
  expect_equal(
    r_vanilla(function() getOption("repos"), libpath = .libPaths()),
    c(CRAN = "@CRAN@")
  )
  gc()
})

test_that("r_safe", {

  expect_equal(
    r_safe(function() Sys.getenv("R_TESTS")),
    ""
  )
  gc()
})

## https://github.com/r-lib/callr/issues/66
test_that("names of getOption('repos') are preserved", {
  skip_if_not_installed("withr")
  repos <- withr::with_options(
    list(repos = c(foo = "bar")),
    callr::r(function() getOption("repos"))
  )
  expect_false(is.null(names(repos)))
  expect_identical("foo", names(repos)[[1]])
  gc()
})

test_that("r", {
  skip_if_not_installed("withr")

  withr::with_options(
    list(repos = "foobar"),
    expect_equal(
      r_copycat(
        function() getOption("repos"),
        user_profile = FALSE,
        system_profile = FALSE
      ),
      "foobar"
    )
  )
  gc()
})

## Need to supply libpath for covr...
test_that("r_vanilla", {
  expect_equal(
    r_vanilla(function() getOption("repos"), libpath = .libPaths()),
    c(CRAN = "@CRAN@")
  )
  gc()
})

test_that("r_safe", {
  expect_equal(
    r_safe(function() Sys.getenv("R_TESTS")),
    ""
  )
  gc()
})

## https://github.com/r-lib/callr/issues/66
test_that("names of getOption('repos') are preserved", {
  skip_if_not_installed("withr")
  repos <- withr::with_options(
    list(repos = c(foo = "bar")),
    callr::r(function() getOption("repos"))
  )
  expect_false(is.null(names(repos)))
  expect_identical("foo", names(repos)[[1]])
  gc()
})

## R CMD check workaround
dummy_r6 <- function() R6::R6Class

clients <- NULL
sofiles <- NULL
env_file <- NULL

## We save this as an RDS, so it can be loaded quickly
.onLoad <- function(libname, pkgname) {
  err$onload_hook()

  # Register methods on load as hacky work-around for pak double registration
  registerS3method("format", "callr_status_error", format.callr_status_error)
  registerS3method("print", "callr_status_error", print.callr_status_error)
  env_file <<- callr_tempfile("callr-env-")
  clients <<- asNamespace("processx")$client
  sofiles <<- get_client_files()
  client_env$`__callr_data__`$sofile <- sofiles
  client_env$`__callr_data__`$pxdir <- system.file(package = "processx")
}

prepare_client_files <- function() {
  for (aa in names(client_env$`__callr_data__`$sofile)) {
    fn <- client_env$`__callr_data__`$sofile[[aa]]
    if (!file.exists(fn)) {
      dir.create(dirname(fn), recursive = TRUE)
      writeBin(clients[[aa]]$bytes, fn)
    }
  }

  if (!file.exists(env_file)) {
    saveRDS(client_env, file = env_file, version = 2, compress = FALSE)
  }
  invisible()
}

get_client_files <- function() {
  archs <- ls(clients)
  vapply(
    archs,
    function(aa) {
      hash <- substr(clients[[aa]]$md5, 1, 7)

      # Filename must be `client.ext` so that `dyn.load()` can find
      # the init function
      file.path(
        callr_tempdir(),
        "callr",
        sub("arch-", "", aa), # Might be empty
        hash,
        paste0("client", .Platform$dynlib.ext)
      )
    },
    character(1)
  )
}

.onUnload <- function(libpath) {
  unlink(
    normalizePath(c(sofiles, env_file), mustWork = FALSE),
    recursive = TRUE,
    force = TRUE
  )
}

#' Evaluate an expression in another R session, in the background
#'
#' Starts evaluating an R function call in a background R process, and
#' returns immediately.
#' Use `p$get_result()` to collect the result or to throw an error
#' if the background computation failed.
#'
#' # Draining standard output and error
#'
#' With the default `stdout = "|"` and `stderr = "|"`, the child process
#' writes its output and error streams into OS pipes with a small fixed
#' buffer (typically 64 KB or less). If nothing drains these pipes, a
#' chatty child fills the buffer and then blocks on the next `write()`.
#' The child will not
#' terminate until the parent reads from the pipes, so `p$is_alive()` will
#' keep returning `TRUE` even though the work appears to be done.
#'
#' To avoid this:
#' * Pass a filename to `stdout` / `stderr` to redirect output to files, or
#' * pass `NULL` to discard it, or
#' * periodically call `p$read_output()` and `p$read_error()` (or
#'   `p$read_all_output()` etc.) to drain the pipes while the process is
#'   running.
#'
#' @inheritSection r Security considerations
#' @inheritParams r
#' @param supervise Whether to register the process with a supervisor. If \code{TRUE},
#'   the supervisor will ensure that the process is killed when the R process
#'   exits.
#' @param ... Extra arguments are passed to the [processx::process]
#'   constructor.
#' @return An `r_process` object, which inherits from [process],
#'   so all `process` methods can be called on it, and in addition it also
#'   has a `get_result()` method to collect the result.
#'
#' @export
#' @examplesIf FALSE
#' rx <- r_bg(function() 1 + 2)
#'
#' # wait until it is done
#' rx$wait()
#' rx$is_alive()
#' rx$get_result()

r_bg <- function(
  func,
  args = list(),
  libpath = .libPaths(),
  repos = default_repos(),
  stdout = "|",
  stderr = "|",
  poll_connection = TRUE,
  error = getOption("callr.error", "error"),
  cmdargs = c("--slave", "--no-save", "--no-restore"),
  system_profile = FALSE,
  user_profile = "project",
  env = rcmd_safe_env(),
  supervise = FALSE,
  package = NULL,
  arch = "same",
  ...
) {
  options <- as.list(environment())
  options$extra <- list(...)
  options$load_hook <- default_load_hook()
  r_process$new(options = options)
}

run_r <- function(options) {
  oldwd <- getwd()
  setwd(options$wd)
  on.exit(setwd(oldwd), add = TRUE)

  pty <- isTRUE(options$extra$pty)

  if (pty && !is.null(options$stderr)) {
    stop(
      "`stderr` cannot be set when `pty = TRUE`; ",
      "stdout and stderr are merged into the pty stream"
    )
  }

  ## We redirect stderr to stdout if either of these are true:
  ## - stderr is the string "2>&1"
  ## - both stdout and stderr are non-null, and they are the same
  stderr_to_stdout <- with(
    options,
    (!is.null(stderr) && stderr == "2>&1") ||
      (!is.null(stdout) && !is.null(stderr) && stdout == stderr)
  )

  otel::log_debug("callr start subprocess")

  res <- with(
    options,
    with_envvar(
      env,
      do.call(
        processx::run,
        c(
          list(
            bin,
            args = real_cmdargs,
            stdout_line_callback = real_callback(stdout),
            stdout_callback = real_block_callback,
            echo_cmd = echo,
            echo = show,
            spinner = spinner,
            error_on_status = fail_on_status,
            timeout = timeout
          ),
          if (!pty) {
            list(
              stderr_line_callback = real_callback(stderr),
              stderr_callback = real_block_callback,
              stderr_to_stdout = stderr_to_stdout
            )
          },
          extra
        )
      )
    )
  )

  res$command <- c(options$bin, options$real_cmdargs)
  res
}

common_hook <- function() {
  substitute(
    {
      # This should not happen in a new R session, but just to be safe
      while ("tools:callr" %in% search()) {
        detach("tools:callr")
      }
      env <- readRDS(`__envfile__`)

      # OpenTelemetry setup
      has_otel <- nzchar(Sys.getenv("TRACEPARENT")) &&
        requireNamespace("otel", quietly = TRUE)
      assign(envir = env$`__callr_data__`, "has_otel", has_otel)
      if (has_otel) {
        hdrs <- as.list(c(
          traceparent = Sys.getenv("TRACEPARENT"),
          tracestate = Sys.getenv("TRACESTATE"),
          baggage = Sys.getenv("BAGGAGE")
        ))
        prtctx <- otel::extract_http_context(hdrs)
        assign(
          envir = env$`__callr_data__`,
          "otel_span",
          otel::start_local_active_span(
            "callr subprocess",
            options = list(parent = prtctx),
            activation_scope = .GlobalEnv,
            end_on_exit = TRUE
          )
        )
      }

      do.call("attach", list(env, pos = length(search()), name = "tools:callr"))
      data <- env$`__callr_data__`
      data$pxlib <- data$load_client_lib(
        data$sofile[[paste0("arch-", .Platform$r_arch)]],
        data$pxdir
      )
      options(error = function() invokeRestart("abort"))
      rm(list = c("data", "env", "has_otel"))

      lapply(
        c(
          "R_ENVIRON",
          "R_ENVIRON_USER",
          "R_PROFILE",
          "R_PROFILE_USER",
          "R_LIBS",
          "R_LIBS_USER",
          "R_LIBS_SITE"
        ),
        function(var) {
          bakvar <- paste0("CALLR_", var, "_BAK")
          val <- Sys.getenv(bakvar, NA_character_)
          if (!is.na(val)) {
            do.call("Sys.setenv", structure(list(val), names = var))
          } else {
            Sys.unsetenv(var)
          }
          Sys.unsetenv(bakvar)
        }
      )

      Sys.unsetenv("CALLR_CHILD_R_LIBS")
      Sys.unsetenv("CALLR_CHILD_R_LIBS_SITE")
      Sys.unsetenv("CALLR_CHILD_R_LIBS_USER")
    },
    list("__envfile__" = env_file)
  )
}

default_load_hook <- function(user_hook = NULL) {
  prepare_client_files()
  hook <- common_hook()

  if (!is.null(user_hook)) {
    hook <- substitute(
      {
        d
        u
      },
      list(d = hook, u = user_hook)
    )
  }
  paste0(deparse(hook), "\n")
}

session_load_hook <- function(user_hook = NULL) {
  chook <- common_hook()
  ehook <- substitute({
    data <- as.environment("tools:callr")$`__callr_data__`
    data$pxlib$disable_fd_inheritance()
    rm(data)
  })

  hook <- substitute(
    {
      c
      e
    },
    list(c = chook, e = ehook)
  )

  if (!is.null(user_hook)) {
    hook <- substitute(
      {
        d
        u
      },
      list(d = hook, u = user_hook)
    )
  }

  hook <- substitute(
    {
      err_ <- TRUE
      callr_startup_hook <- function() {
        on.exit(if (err_) quit("no", 1, TRUE))
        {
          `_hook_`
        }
        err_ <<- FALSE
      }
      callr_startup_hook()
      rm(err_, callr_startup_hook)
    },
    list("_hook_" = hook)
  )

  paste0(deparse(hook), "\n")
}

user_hooks_env <- new.env(parent = emptyenv())

#' Add a user hook to be executed before launching an R subprocess
#'
#' This function allows users of `callr` to specify functions that get invoked
#' whenever an R session is launched. The function can modify the environment
#' variables and command line arguments.
#'
#' The prototype of the hook function is `function (options)`, and it is
#' expected to return the modified `options`.
#' @param ... Named argument specifying a hook function to add, or `NULL` to
#'   delete the named hook.
#' @return `add_hook` is called for its side-effects.
#' @export

add_hook <- function(...) {
  args <- list(...)
  if (length(args) != 1L) {
    stop("More than one argument passed to `add_hook`")
  }

  name <- names(args)
  if (is.null(name)) {
    stop("Argument passed to `add_hook` must be named")
  }

  hook <- args[[1]]
  if (is.null(hook)) {
    rm(list = name, envir = user_hooks_env)
  } else {
    assign(name, match.fun(hook), envir = user_hooks_env)
  }

  invisible()
}

call_user_hooks <- function(options) {
  for (name in names(user_hooks_env)) {
    hook <- user_hooks_env[[name]]
    options <- tryCatch(hook(options), error = function(e) options)
  }
  options
}

test_that("r with timeout", {
  tic <- Sys.time()
  e <- tryCatch(
    r(function() Sys.sleep(5), timeout = 1),
    error = function(e) e
  )
  tac <- Sys.time()

  expect_true("callr_timeout_error" %in% class(e))
  expect_true(tac - tic < as.difftime(4, units = "secs"))
  gc()
})

test_that("callr_message, then error", {
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  do <- function() {
    msg <- structure(list(message = "hi"),
                     class = c("callr_message", "condition"))
    signalCondition(msg)
    signalCondition(msg)
    stop("nah-ah")
  }

  msg <- err <- NULL
  tryCatch(
    withCallingHandlers(
      rs$run(do),
      callr_message = function(m) msg <<- c(msg, list(m))),
    error = function(e) err <<- e)

  expect_s3_class(msg[[1]], "callr_message")
  expect_equal(conditionMessage(msg[[1]]), "hi")
  expect_s3_class(msg[[2]], "callr_message")
  expect_equal(conditionMessage(msg[[2]]), "hi")

  expect_s3_class(err, "error")
  expect_match(conditionMessage(err), "nah-ah")

  expect_true(rs$is_alive())
  expect_equal(rs$get_state(), "idle")
  expect_identical(rs$read_error_lines(), character())

  rs$close()
})

test_that("message handlers", {
  skip_if_not_installed("withr")
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  do <- function() {
    msg <- structure(list(message = "hi"),
                     class = c("myclass", "callr_message", "condition"))
    signalCondition(msg)
  }

  cond <- NULL
  withr::with_options(
    list(callr.condition_handler_myclass = function(x) {
      cond <<- x
    }),
    rs$run(do)
  )

  expect_s3_class(cond, "myclass")
  expect_equal(cond$message, "hi")

  rs$close()
})

test_that("large messages", {
  skip_if_not_installed("withr")
  rs <- r_session$new()
  on.exit(rs$close(), add = TRUE)

  do <- function() {
    msg <- structure(list(message = paste(1:150000, sep = " ")),
                     class = c("myclass", "callr_message", "condition"))
    signalCondition(msg)
    for (i in 1:5) {
      msg <- structure(list(message = paste("message", i)),
                       class = c("myclass", "callr_message", "condition"))
      signalCondition(msg)
    }
  }

  cond <- list()
  withr::with_options(
    list(callr.condition_handler_myclass = function(x) {
      cond <<- c(cond, list(x))
    }),
    rs$run(do)
  )

  expect_equal(length(cond), 6)
  expect_s3_class(cond[[1]], "myclass")
  expect_equal(cond[[1]]$message, paste(1:150000, sep = " "))
  for (i in 1:5) {
    expect_equal(cond[[i + 1]]$message, paste("message", i))
  }

  rs$close()
})

test_that("repos is a list, #82", {
  skip_if_not_installed("withr")
  expect_true(withr::with_options(
    list(repos = list(CRAN = "https://cloud.r-project.org")),
    callr::r(function() inherits(getOption("repos"), "list"))
  ))
})

test_that("is_complete_expression", {
  skip_if_not_installed("withr")
  do_tests <- function() {
    expect_true(is_complete_expression(""))
    expect_true(is_complete_expression("1"))
    expect_true(is_complete_expression("1+1"))
    expect_true(is_complete_expression("foo + \n  bar"))
    expect_true(is_complete_expression("1 1"))

    expect_false(is_complete_expression("1+"))
    expect_false(is_complete_expression("1+1+"))
    expect_false(is_complete_expression("1+\n2+"))
  }

  do_tests()

  if (has_locale("de_DE")) {
    withr::with_envvar(c(LANGUAGE = "de_DE"), do_tests())
  }
})

test_that("default_repos", {
  skip_if_not_installed("withr")
  def <- "https://cloud.r-project.org"

  withr::with_options(list(repos = NULL),
    expect_equal(
      default_repos(),
      c(CRAN = def)))

  withr::with_options(list(repos = character()),
    expect_equal(
      default_repos(),
      c(CRAN = def)))

  withr::with_options(list(repos = list()),
    expect_equal(
      default_repos(),
      list(CRAN = def)))

  withr::with_options(list(repos = c(foo = "bar")),
    expect_equal(
      default_repos(),
      c(foo = "bar", CRAN = def)))

  withr::with_options(list(repos = list(foo = "bar")),
    expect_equal(
      default_repos(),
      list(foo = "bar", CRAN = def)))

  withr::with_options(list(repos = c(foo = "bar", CRAN = "set")),
    expect_equal(
      default_repos(),
      c(foo = "bar", CRAN = "set")))

  withr::with_options(list(repos = c(foo = "bar", CRAN = "@CRAN@")),
    expect_equal(
      default_repos(),
      c(foo = "bar", CRAN = def)))
})

test_that(".Library", {
  expect_equal(
    .Library,
    r(function() .Library)
  )
  gc()
})

test_that(".Library.site", {
  expect_equal(
    .Library.site,
    r(function() .Library.site)
  )
  gc()
})

test_that(".libPaths()", {
  skip_if_not_installed("withr")
  dir.create(tmp <- tempfile())
  on.exit(unlink(tmp, recursive = TRUE))

  lp <- withr::with_libpaths(
    tmp, action = "prefix",
    r(function() {
      .libPaths()
    })
  )

  expect_true(normalizePath(tmp) %in% normalizePath(lp))
  gc()
})

test_that("if .Renviron overrides R_PROFILE", {

  ## But we still need to use the proper lib path, as set in the fake
  ## profile
  skip_in_covr()
  skip_if_not_installed("withr")

  cat("Sys.setenv(FOO='nope')\n", file = tmp_prof <- tempfile())
  cat("R_PROFILE=\"", tmp_prof, "\"\n", file = tmp_env <- tempfile(), sep = "")
  cat("R_PROFILE_USER=\"", tmp_prof, "\"\n", file = tmp_env, sep = "", append = TRUE)

  cat("FOO=bar\n", file = tmp_env, sep = "", append = TRUE)

  dir.create(tmp_lib <- tempfile())

  on.exit(unlink(c(tmp_prof, tmp_env, tmp_lib), recursive = TRUE))

  lp <- withr::with_envvar(
    c(R_ENVIRON = tmp_env),
    withr::with_libpaths(
      tmp_lib, action = "prefix",
      r(function() list(.libPaths(), Sys.getenv("FOO"), Sys.getenv("R_PROFILE")))
    )
  )

  expect_true(normalizePath(tmp_lib) %in% normalizePath(lp[[1]]))
  expect_equal(lp[[2]], "bar")
  gc()
})

test_that("libpath in system(), empty .Renviron", {

  # We remove the library with covr from the lib path, so this
  # cannot work in a subprocess.
  skip_in_covr()
  skip_if_not_installed("withr")

  dir.create(tmpdrop <- tempfile("drop"))
  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(c(tmpdrop, tmpkeep), recursive = TRUE), add  = TRUE)

  tmpenv <- withr::local_tempfile()
  cat("", file = tmpenv)
  withr::local_envvar(c(R_ENVIRON_USER = tmpenv))

  withr::local_libpaths(tmpdrop, action = "prefix")

  test_paths(tmpdrop, tmpkeep)

  ## To close FDs
  gc()
})

test_that("libpath in system, R_LIBS in .Renviron", {

  # We remove the library with covr from the lib path, so this
  # cannot work in a subprocess.
  skip_in_covr()
  skip_if_not_installed("withr")

  dir.create(tmpdrop <- tempfile("drop"))
  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(c(tmpdrop, tmpkeep), recursive = TRUE), add  = TRUE)

  tmpenv <- withr::local_tempfile()
  cat("R_LIBS=\"", tmpdrop, "\"\n", sep = "", file = tmpenv)
  withr::local_envvar(c(R_ENVIRON_USER = tmpenv))

  withr::local_libpaths(tmpdrop, action = "prefix")

  # Since we add tmpdrop in .Renviron, it will only be dropped by --vanilla
  test_paths(tmpdrop, tmpkeep, system_drop = NULL)

  ## To close FDs
  gc()
})

test_that("libpath in system, R_LIBS", {

  # We remove the library with covr from the lib path, so this
  # cannot work in a subprocess.
  skip_in_covr()
  skip_if_not_installed("withr")

  dir.create(tmpdrop <- tempfile("drop"))
  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(c(tmpdrop, tmpkeep), recursive = TRUE), add  = TRUE)

  tmpenv <- withr::local_tempfile()
  cat("", file = tmpenv)
  withr::local_envvar(c(R_ENVIRON_USER = tmpenv, R_LIBS=tmpdrop))

  withr::local_libpaths(tmpdrop, action = "prefix")

  # R_LIBS is used by both R and R --vanilla, so it will not be dropped
  test_paths(tmpdrop, tmpkeep, system_drop = NULL, system_vanilla_drop = NULL)

  ## To close FDs
  gc()
})

test_that("libpath in system, R_LIBS and .Renviron", {

  # We remove the library with covr from the lib path, so this
  # cannot work in a subprocess.
  skip_in_covr()
  skip_if_not_installed("withr")

  dir.create(tmpdrop <- tempfile("drop"))
  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(c(tmpdrop, tmpkeep), recursive = TRUE), add  = TRUE)

  tmpenv <-  withr::local_tempfile()
  cat("R_LIBS=\"", tmpdrop, "\"\n", sep = "", file = tmpenv)
  withr::local_envvar(c(R_ENVIRON_USER = tmpenv, R_LIBS=tmpdrop))

  withr::local_libpaths(tmpdrop, action = "prefix")

  # R_LIBS is used by both R and R --vanilla, so it will not be dropped
  test_paths(tmpdrop, tmpkeep, system_drop = NULL, system_vanilla_drop = NULL)

  ## To close FDs
  gc()
})

test_that("libpath in system, if subprocess changes R_LIBS", {
  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(tmpkeep, recursive = TRUE), add  = TRUE)

  rbin <- setup_r_binary_and_args(list())$bin
  rbin <- shQuote(rbin)

  f <- function(rbin, new) {
    Sys.setenv(R_LIBS = new)
    Sys.setenv(R_ENVIRON_USER = "no_such_file")
    system(paste(
      rbin, "--no-site-file --no-init-file --no-save --no-restore --slave",
      "-e \".libPaths()\""), intern = TRUE)
  }

  out <- callr::r(f, list(rbin = rbin, new = tmpkeep))
  expect_true(any(grepl(basename(normalizePath(tmpkeep)), out)))

  ## Close FDs
  gc()
})

test_that("libpath in system, if subprocess changes R_LIBS #2", {

  if (.Platform$OS.type != "unix") skip("Unix only")

  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(tmpkeep, recursive = TRUE), add  = TRUE)

  rbin <- setup_r_binary_and_args(list())$bin

  f <- function(rbin, new) {
    Sys.setenv(R_LIBS = new)
    Sys.setenv(R_ENVIRON_USER = "no_such_file")
    env <- paste0("R_LIBS=", shQuote(new))
    tmp <- tempfile()
    on.exit(unlink(tmp), add = TRUE)
    system2(
      rbin,
      c("--no-site-file", "--no-init-file", "--no-save",
        "--no-restore", "--slave", "-e", "'.libPaths()'"),
      env = env,
      stdout = tmp
    )
    readLines(tmp)
  }

  out <- callr::r(f, list(rbin = rbin, new = tmpkeep))
  expect_true(any(grepl(basename(normalizePath(tmpkeep)), out)))

  ## Close FDs
  gc()
})

test_that("setting profile/environ variables in 'env'", {
  # See https://github.com/r-lib/callr/issues/193

  skip_in_covr()

  profile <- tempfile()
  on.exit(unlink(profile), add = TRUE)
  cat("foo <- '11'\n", file = profile)

  envfile <- tempfile()
  on.exit(unlink(envfile), add = TRUE)
  cat("MY_ENV2=MILES2\n", file = envfile)

  ret <- callr::r(
    function() {
      c(Sys.getenv("MY_ENV"),
        Sys.getenv("R_PROFILE_USER"),
        exists("foo"),
        Sys.getenv("MY_ENV2")
        )
    },
    user_profile = TRUE,
    env = c(
      "R_PROFILE_USER" = profile,
      "R_ENVIRON_USER" = envfile,
      "MY_ENV" = "MILES"
    )
  )

  expect_equal(ret, c("MILES", profile, "TRUE", "MILES2"))
})

test_that("show option works", {

  expect_output(
    r(function() print("hello"), show = TRUE),
    "hello"
  )
  gc()
})

test_that("callbacks work", {
  out <- NULL
  r(function() cat("hello\n"), callback = function(x) out <<- x)
  expect_equal(out, "hello")
  gc()
})

test_that("show and callbacks at the same time", {
  out <- NULL

  expect_output(
    r(
      function() cat("hello\n"),
      show = TRUE,
      callback = function(x) out <<- x
    ),
    "hello"
  )

  expect_equal(out, "hello")
  gc()
})

test_that("basic r", {
  expect_equal(r(function() 1 + 1), 2)
  expect_equal(r(function(x) 1 + x, list(5)), 6)
  gc()
})

test_that("the same R version is called", {
  expect_equal(r(function() R.version), R.version)
  gc()
})

test_that("standard output", {
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  r(function() cat("hello\n"), stdout = tmp)
  expect_equal(readLines(tmp), "hello")
  gc()
})

test_that("standard error", {
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  r(function() message("hello"), stderr = tmp)
  expect_equal(readLines(tmp), "hello")
  gc()
})

test_that("standard output and standard error", {
  tmp_out <- tempfile("stdout-")
  tmp_err <- tempfile("stderr-")
  on.exit(unlink(c(tmp_out, tmp_err)), add = TRUE)
  expect_silent(
    r(function() { cat("hello world!\n"); message("hello again!") },
      stdout = tmp_out, stderr = tmp_err)
  )
  expect_equal(readLines(tmp_out), "hello world!")
  expect_equal(readLines(tmp_err), "hello again!")
  gc()
})

test_that("cmdargs argument", {
  o1 <- tempfile()
  o2 <- tempfile()
  on.exit(unlink(c(o1, o2)), add = TRUE)

  r(function() ls(), stdout = o1)
  r(function() ls(), stdout = o2, cmdargs = character())

  expect_true(length(readLines(o2)) > length(readLines(o1)))
  gc()
})

test_that("env", {

  expect_equal(
    r(function() Sys.getenv("CALLR_FOOBAR"),
      env = c(CALLR_FOOBAR = "indeed")
      ),
    "indeed"
  )
  gc()
})

test_that("stdout and stderr in the same file", {
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)


  r(function() {
      cat("hello1\n")
      Sys.sleep(0.1)
      message("hello2")
      Sys.sleep(0.1)
      cat("hello3\n")
    },
    stdout = tmp, stderr = tmp
  )

  expect_equal(readLines(tmp), paste0("hello", 1:3))
  gc()
})

test_that("profiles are used as requested", {
  skip_if_not_installed("withr")
  do <- function(system, user) {
    tmp1 <- tempfile()
    tmp2 <- tempfile()
    on.exit(unlink(c(tmp1, tmp2)), add = TRUE)
    cat("Sys.setenv(FOO = 'bar')\n", file = tmp1)
    cat("Sys.setenv(NAH = 'doh')\n", file = tmp2)
    withr::with_envvar(list(R_PROFILE = tmp1, R_PROFILE_USER = tmp2),  {
      res <- r(
        function() c(Sys.getenv("FOO", ""), Sys.getenv("NAH", "")),
        system_profile = system, user_profile = user)
    })
  }

  ## None
  res <- do(FALSE, FALSE)
  expect_equal(res, c("", ""))

  ## System
  res <- do(TRUE, FALSE)
  expect_equal(res, c("bar", ""))

  ## User
  res <- do(FALSE, TRUE)
  expect_equal(res, c("", "doh"))

  ## Both
  res <- do(TRUE, TRUE)
  expect_equal(res, c("bar", "doh"))
  gc()
})

test_that(".Renviron is used, but lib path is set over it", {
  skip_if_not_installed("withr")
  dir.create(tmp <- tempfile())
  on.exit(unlink(tmp, recursive = TRUE), add = TRUE)
  withr::with_dir(tmp, {
    ## Create .Renviron file
    dir.create("not")
    dir.create("yes")
    cat("R_LIBS=\"", file.path(getwd(), "not"), "\"\n",
        sep = "", file = ".Renviron")
    cat("FOO=bar\n", file = ".Renviron", append = TRUE)

    ## R CMD check sets R_ENVIRON and R_ENVIRON_USER to empty,
    ## so we need to recover that.
    withr::with_envvar(c(R_ENVIRON_USER=".Renviron"), {
      res <- r(
        function() list(.libPaths(), Sys.getenv("FOO")),
        libpath = c(file.path(getwd(), "yes"), .libPaths())
      )
    })
  })

  expect_equal(basename(res[[1]][1]), "yes")
  expect_equal(res[[2]], "bar")
  gc()
})

test_that("errors are printed on stderr", {
  ## See https://github.com/r-lib/callr/issues/80
  f <- function() {
    print("send to stdout")
    message("send to stderr")
    stop("send to stderr 2")
  }

  expect_error(
    r(f, stdout = out <- tempfile(), stderr = err <- tempfile()))
  on.exit(unlink(c(out, err), recursive = TRUE), add = TRUE)

  expect_false(any(grepl("send to stderr", readLines(out))))
  expect_true(any(grepl("send to stderr 2", readLines(err))))
  gc()
})

test_that("stdout and stderr are interleaved correctly", {
  f <- function() {
    cat("stdout", file = stdout())
    cat("stderr", file = stderr())
    cat("stdout2\n", file = stdout())
  }

  on.exit(unlink(out, recursive = TRUE), add = TRUE)

  r(f, stdout = out <- tempfile(), stderr = "2>&1")
  expect_equal(readLines(out), "stdoutstderrstdout2")
  unlink(out)

  r(f, stdout = out, stderr = out)
  expect_equal(readLines(out), "stdoutstderrstdout2")
  gc()
})

test_that("callr messages do not cause problems", {

  do <- function() {
    cnd <- structure(
      list(message = "foobar"),
      class = c("callr_message", "condition")
    )
    signalCondition(cnd)
    signalCondition(cnd)
    signalCondition(cnd)
    cat("stdout\n")
    message("stderr")
    "hi"
  }

  out <- tempfile()
  err <- tempfile()
  on.exit(unlink(c(out, err)), add = TRUE)
  ret <- callr::r(do, stdout = out, stderr = err, poll_connection = FALSE)

  expect_equal(ret, "hi")
  expect_equal(readLines(out), "stdout")
  expect_equal(readLines(err), "stderr")
})

test_that("cleans up temp files", {
  skip_on_cran()

  rsc <- function() {
    library(callr)
    old <- dir(tempdir(), pattern = "^callr-")

    result <- callr::r(function() 1+1)

    unloadNamespace("callr")

    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rsc)
  expect_identical(out$result, 2)
  expect_identical(out$new, character())
})

test_that("local .Rprofile is loaded", {
  tmp <- tempfile()
  on.exit(unlink(tmp, recursive = TRUE), add = TRUE)
  dir.create(tmp)
  wd <- getwd()
  on.exit(setwd(wd), add = TRUE)
  setwd(tmp)
  cat("aa <- 123\n", file = ".Rprofile")
  out <- callr::r(function() aa)
  expect_equal(out, 123)
})

test_that("local .Rprofile is not loaded from actual wd", {
  tmp <- tempfile()
  on.exit(unlink(tmp, recursive = TRUE), add = TRUE)
  dir.create(tmp)
  wd <- getwd()
  on.exit(setwd(wd), add = TRUE)
  setwd(tmp)

  dir.create(wd2 <- tempfile())
  on.exit(unlink(wd2, recursive = TRUE), add = TRUE)
  cat("aa <- 123\n", file = ".Rprofile")
  out <- callr::r(function() ls(.GlobalEnv), wd = wd2)
  expect_equal(out, character())
})

test_that("local .Rprofile is not loaded recursively", {
  tmp <- tempfile()
  on.exit(unlink(tmp, recursive = TRUE), add = TRUE)
  dir.create(tmp)
  wd <- getwd()
  on.exit(setwd(wd), add = TRUE)
  setwd(tmp)

  expr <- quote({
    rprofile <- Sys.getenv("R_PROFILE_USER", "~/.Rprofile")
    if (file.exists(rprofile)) source(rprofile)
    rm(rprofile)
    aa <- 123
  })
  cat(deparse(expr), file = ".Rprofile", sep = "\n")
  out <- callr::r(function() aa)
  expect_equal(out, 123)
})

test_that("symbolic arguments are protected", {
  expect_equal(
    callr::r(function(x) x, list(x = quote(foobar))),
    quote(foobar)
  )
})

test_that("regular use", {
  rs <- r_session$new()
  on.exit(rs$kill())

  expect_equal(rs$get_state(), "idle")

  ## Clean session
  expect_identical(rs$run(function() ls(.GlobalEnv)), character())

  ## Start a command
  rs$call(function() 42)

  ## Get result
  res <- read_next(rs)
  expect_equal(res$result, 42)
  expect_null(res$error)
  expect_equal(rs$get_state(), "idle")

  ## Run another command, with arguments
  rs$call(function(x, y)  x + y, list(x = 42, y = 42))

  ## Get result
  res <- read_next(rs)
  expect_equal(res$result, 84)
  expect_equal(rs$get_state(), "idle")

  ## While session is idle the current call running time is NA
  rs$call(function() 42)
  expect_equal(
    is.na(rs$get_running_time()),
    c(total = FALSE, current = FALSE)
  )
  res <- read_next(rs)
  expect_equal(
    is.na(rs$get_running_time()),
    c(total = FALSE, current = TRUE)
  )
  expect_s3_class(rs$get_running_time(), "difftime")

  ## Close
  rs$close()
  expect_equal(rs$get_state(), "finished")
  expect_false(rs$is_alive())
})

test_that("run", {
  rs <- r_session$new()
  on.exit(rs$kill())

  expect_equal(rs$run_with_output(function() 42)$result, 42)
  expect_equal(rs$run_with_output(function() 42)$result, 42)
  expect_equal(
    rs$run_with_output(function(x, y) { x + y },
                       list(x = 42, y = 42))$result,
    84)

  ## Finish
  rs$close()
  expect_equal(rs$get_state(), "finished")
  expect_false(rs$is_alive())
})


test_that("get stdout/stderr from file", {
  rs <- r_session$new()
  on.exit(rs$kill())

  eol <- function(x) {
    paste0(x, if (.Platform$OS.type == "windows") "\r\n" else "\n")
  }

  for (i in 1:10) {
    res <- rs$run_with_output(function() {
      cat("foo\n"); message("bar"); 42 })
    expect_equal(
      res[c("result", "stdout", "stderr")],
      list(result = 42, stdout = eol("foo"), stderr = eol("bar")))

    res <- rs$run_with_output(function() {
      cat("bar\n"); message("foo"); 43 })
    expect_equal(
      res[c("result", "stdout", "stderr")],
      list(result = 43, stdout = eol("bar"), stderr = eol("foo")))
  }
  rs$close()
})

test_that("stdout/stderr from pipe", {
  skip_on_cran()
  opt <- r_session_options(stdout = "|", stderr = "|")
  rs <- r_session$new(opt)
  on.exit(rs$kill())

  ## Sometimes a NULL slips through....  this is bug to be fixed
  rs$read_output_lines()

  res <- rs$run_with_output(function() {
    cat("foo\n"); message("bar"); 42 })
  expect_equal(
    res[c("result", "stdout", "stderr")],
    list(result = 42, stdout = NULL, stderr = NULL))

  res <- rs$run_with_output(function() {
    cat("bar\n"); message("foo"); 43 })
  expect_equal(
    res[c("result", "stdout", "stderr")],
    list(result = 43, stdout = NULL, stderr = NULL))

  processx::poll(list(rs$get_output_connection()), 1000)
  expect_equal(rs$read_output_lines(n = 1), "foo")
  processx::poll(list(rs$get_output_connection()), 1000)
  expect_equal(rs$read_output_lines(n = 1), "bar")
  processx::poll(list(rs$get_error_connection()), 1000)
  expect_equal(rs$read_error_lines(n = 1), "bar")
  processx::poll(list(rs$get_error_connection()), 1000)
  expect_equal(rs$read_error_lines(n = 1), "foo")
  rs$close()
})

test_that("interrupt", {
  rs <- r_session$new()
  on.exit(rs$kill())

  rs$call(function() Sys.sleep(5))
  Sys.sleep(0.5)
  rs$interrupt()
  rs$poll_process(1000)
  res <- rs$read()
  expect_s3_class(res$error, "callr_timeout_error")
  rs$close()
})

test_that("messages", {
  f <- function() {
    x <- structure(
      list(code = 301, message = "ahoj"),
      class = c("callr_message", "condition"))
    signalCondition(x)
    22
  }

  msg <- NULL
  cb <- function(x) msg <<- x

  rs <- r_session$new()
  on.exit(rs$kill())

  withCallingHandlers(
    expect_silent(res <- rs$run_with_output(f)),
    callr_message = function(e) msg <<- e
  )
  expect_equal(res$result, 22)
  expect_equal(
    msg,
    structure(
      list(code = 301, message = "ahoj", muffle = "callr_r_session_muffle"),
      class = c("callr_message", "condition")))
  rs$close()
})

test_that("messages with R objects", {
  obj <- list(a = 1, b = 2)
  f <- function(obj) {
    x <- structure(
      c(list(code = 301), obj),
      class = c("foobar_class", "callr_message", "condition"))
    signalCondition(x)
    22
  }

  msg <- NULL
  cb <- function(x) msg <<- x

  rs <- r_session$new()
  on.exit(rs$kill())

  withCallingHandlers(
    expect_silent(res <- rs$run_with_output(f, args = list(obj))),
    foobar_class = function(e) msg <<- e
  )
  expect_equal(res$result, 22)
  exp <- exp2 <- structure(
    list(code = 301, a = 1, b = 2),
    class = c("foobar_class", "callr_message", "condition"))
  exp2$muffle <- "callr_r_session_muffle"
  expect_equal(msg, exp2)
  rs$call(f, args = list(obj))
  rs$poll_process(2000)
  expect_equal(
    rs$read(),
    structure(
      list(code = 301, message = exp),
      class = "callr_session_result"))
  rs$poll_process(2000)
  expect_equal(rs$read()$result, 22)
  rs$close()
})

test_that("run throws", {
  rs <- r_session$new()
  on.exit(rs$kill())
  expect_error(rs$run(function() stop("foobar")), "foobar")
  rs$close()
})

test_that("exit", {
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)
  err <- tryCatch(
    res <- rs$run(function() q()),
    error = function(x) x)

  deadline <- Sys.time() + 3
  while (rs$is_alive() && Sys.time() < deadline) Sys.sleep(0.05)
  expect_true(Sys.time() < deadline)

  expect_false(rs$is_alive())
  expect_equal(rs$get_state(), "finished")
  rs$close()
})

test_that("crash", {
  skip_on_cran()
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)
  err <- tryCatch(
    rs$run(function() get("crash", asNamespace("callr"))()),
    error = function(e) e)
  expect_true(
    grepl("crashed with exit code", conditionMessage(err)) ||
    grepl("R session closed the process connection", conditionMessage(err)) ||
    grepl("Invalid (uninitialized or closed?) connection object",
          conditionMessage(err), fixed = TRUE)
  )
  expect_false(rs$is_alive())
  expect_equal(rs$get_state(), "finished")
  rs$close()

  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)
  res <- rs$run_with_output(function() {
    cat("o\n"); message("e");
    get("crash", asNamespace("callr"))()
  })
  expect_null(res$result)
  expect_s3_class(res$error, "error")

  ## This is a race, and sometimes we don't get the stdout/stderr
  ## on Windows
  if (os_platform() != "windows") expect_equal(res$stdout, "o\n")
  if (os_platform() != "windows") expect_equal(substr(res$stderr, 1, 2), "e\n")
  expect_false(rs$is_alive())
  expect_equal(rs$get_state(), "finished")
  rs$close()
})

test_that("custom load hook", {
  opts <- r_session_options(load_hook = quote(options(foobar = "baz")))
  rs <- r_session$new(opts)
  on.exit(rs$kill(), add = TRUE)

  res <- rs$run_with_output(function() getOption("foobar"))
  expect_null(res$error)
  expect_identical(res$result, "baz")
  expect_equal(res$stdout, "")
  expect_equal(res$stderr, "")
  rs$close()
})

test_that("traceback", {
  skip_if_not_installed("withr")
  withr::local_options(callr.traceback = TRUE)
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  do <- function() {
    f <- function() g()
    g <- function() stop("oops")
    f()
  }

  expect_error(rs$run(do), "oops")
  expect_output(tb <- rs$traceback(), "1: \"?f()\"?")
  expect_match(c(tb[[3]]), "f()", fixed = TRUE)
})

test_that("error in the load hook", {
  opts <- r_session_options(load_hook = quote(stop("oops")))
  expect_error({
    rs <- r_session$new(opts)
    on.exit(rs$kill(), add = TRUE)
  })

  rs2 <- r_session$new(opts, wait = FALSE)
  on.exit(rs2$kill(), add = TRUE)

  processx::poll(list(rs2$get_poll_connection()), 3000)
  msg <- rs2$read()
  expect_true(msg$code %in% c(501L, 502L))
  expect_match(msg$stderr, "oops")
})

test_that("fds are not leaked", {
  skip_if_not_installed("ps")
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  old <- rs$run(function() ps::ps_num_fds())
  for (i in 1:10) {
    rs$run(function() 1 + 1)
  }
  new <- rs$run(function() ps::ps_num_fds())

  # Allow 2 new fds, just in case
  expect_true(new - old <= 2)
})

test_that("spell check", {
  skip_on_cran()
  skip_in_covr()
  skip_if_not_installed("spelling")
  pkg_dir <- test_package_root()
  results <- spelling::spell_check_package(pkg_dir)

  if (nrow(results)) {
    output <- sprintf(
      "Potential spelling errors: %s\n",
      paste(results$word, collapse = ", "))
    stop(output, call. = FALSE)
  } else {
    expect_true(TRUE)
  }
})

test_that("rcmd works", {
  expect_equal(rcmd("config", "CC")$status, 0)
  expect_match(rcmd("config", "CC")$stdout, ".")
  gc()
})

test_that("rcmd show works", {
  expect_output(rcmd("config", "CC", show = TRUE), ".")
  gc()
})

test_that("rcmd echo works", {
  skip_if_not_installed("withr")
  withr::local_options(width = 500)
  expect_output(rcmd("config", "CC", echo = TRUE), "config\\s+CC")
  gc()
})

test_that("rcmd_safe", {
  expect_equal(rcmd_safe("config", "CC")$status, 0)
  gc()
})

test_that("wd argument", {
  tmp <- tempfile(fileext = ".R")
  tmpout <- paste0(tmp, "out")
  cat("print(getwd())", file = tmp)

  mywd <- getwd()

  rcmd("BATCH", c(tmp, tmpout), wd = tempdir())

  expect_equal(mywd, getwd())
  expect_match(
    paste(readLines(tmpout), collapse = "\n"),
    basename(tempdir())
  )
  gc()
})

test_that("fail_on_status", {
  skip_if_not_installed("withr")
  rand <- tempfile()
  expect_error(
    withr::with_dir(
      tempdir(),
      rcmd("BATCH", rand, fail_on_status = TRUE)),
    "System command .* failed|System command error",
    class = "system_command_status_error"
  )
  expect_silent(
    out <- withr::with_dir(
      tempdir(),
      rcmd("BATCH", rand, fail_on_status = FALSE))
  )
  expect_true(out$status != 0)
  gc()
})

test_that("command is included in result", {
  res <- rcmd_safe("config", "CC")
  expect_false(is.null(res$command))
  expect_true(is.character(res$command))
  gc()
})

test_that("stderr -> stdout", {
  lib <- test_temp_dir()
  pkg <- test_temp_dir()
  file.copy(test_path("fixtures/D1"), file.path(pkg, "DESCRIPTION"))
  out <- rcmd("INSTALL", c("-l", lib, pkg))
  expect_match(out$stdout, "No man pages found", useBytes = TRUE)
  expect_match(out$stderr, "installing help indices")

  out2 <- rcmd("INSTALL", c("-l", lib, pkg), stderr = "2>&1")
  expect_equal(out2$status, 0L)
  expect_match(
    out2$stdout,
    "installing.*No man pages found.*testing if installed package")
  expect_null(out2$stderr)

  out3 <- test_temp_file(create = FALSE)
  rcmd("INSTALL", c("-l", lib, pkg), stdout = out3, stderr = out3)
  expect_match(
    readChar(out3, nchars = file.info(out3)$size),
    "installing.*No man pages found.*testing if installed package")
  gc()
})

test_that("cleans up temp files", {
  skip_on_cran()

  rc <- function() {
    library(callr)
    scriptfile <- tempfile(fileext = ".R")

    old <- dir(tempdir(), pattern = "^callr-")

    result <- callr::rcmd("config", "CC")

    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rc)
  expect_identical(out$result$status, 0L)
  expect_identical(out$new, character())
})

test_that("load_client_lib", {
  lib <- load_client_lib()

  funcs <- c("base64_decode", "set_stderr", "write_fd")
  expect_true(
    all(funcs %in% names(lib))
  )

  lib <- load_client_lib(pxdir = find.package("processx"))
  expect_true(
    all(funcs %in% names(lib))
  )
})

test_that("errors", {
  skip_if_not_installed("mockery")
  mockery::stub(load_client_lib, "system.file", "")
  expect_error(
    load_client_lib(),
    "Cannot find client file"
  )
})

test_that("errors 2", {
  skip_if_not_installed("mockery")
  sofile <- system.file(
    "libs", .Platform$r_arch, paste0("client", .Platform$dynlib.ext),
    package = "processx"
  )
  mockery::stub(load_client_lib, "dyn.load", function(...) stop("ooops"))
  expect_error(load_client_lib(sofile))
})

test_that("base64", {
  lib <- load_client_lib()
  enc <- lib$base64_encode(charToRaw("hello world!"))
  expect_equal(lib$base64_decode(enc), charToRaw("hello world!"))
})

test_that("write_fd", {
  do <- function() {
    lib <- asNamespace("callr")$load_client_lib()
    f1 <- tempfile()
    c1 <- processx::conn_create_file(f1, write = TRUE)
    lib$write_fd(processx::conn_get_fileno(c1), "hello world!\n")
    close(c1)
    readLines(f1)
  }

  ret <- callr::r(do)
  expect_equal(ret, "hello world!")
})

test_that("set_stdout, set_stderr", {
  # TODO why does this not work on windows, if `set_std{out,err}_file` work?
  # Also, `set_std{out,err}` work in `r_session`.
  # But this test crashes at the `set_stdout()` call.
  skip_on_os("windows")

  do <- function() {
    lib <- asNamespace("callr")$load_client_lib()
    f1 <- tempfile()
    f2 <- tempfile()
    c1 <- processx::conn_create_file(f1, write = TRUE)
    c2 <- processx::conn_create_file(f2, write = TRUE)
    lib$set_stdout(processx::conn_get_fileno(c1))
    lib$set_stderr(processx::conn_get_fileno(c2))
    cat("this is output")
    message("this is error")
    close(c1)
    close(c2)
    c(readLines(f1), readLines(f2))
  }

  ret <- callr::r(do)
  expect_equal(ret, c("this is output", "this is error"))
})

test_that("set_stdout_file, set_setderr_file", {
  do <- function() {
    lib <- asNamespace("callr")$load_client_lib()
    f1 <- tempfile()
    f2 <- tempfile()
    lib$set_stdout_file(f1)
    lib$set_stderr_file(f2)
    cat("this is output")
    message("this is error")
    c(readLines(f1), readLines(f2))
  }

  ret <- callr::r(do)
  expect_equal(ret, c("this is output", "this is error"))
})

test_that("init function of client lib is run", {
  pxlib <- r(function() {
    as.environment("tools:callr")$`__callr_data__`$pxlib
  })

  # File name should be `client.SOEXT` so that R can match the init
  # function from the name
  expect_true(grepl("^client\\.", basename(pxlib$.path)))

  # In case R removes the `dynamicLookup` field
  skip_on_cran()

  # Should be `FALSE` since processx disables dynamic lookup in the
  # init function
  expect_false(unclass(pxlib$.lib)$dynamicLookup)
})

test_that("CALLR_NO_TEMP_DLLS", {
  skip_on_cran()
  if (.Platform$OS.type != "windows") skip("Windows only")

  # If not set, then it should come from the temporary location
  withr::local_envvar(CALLR_NO_TEMP_DLLS = NA_character_)
  dlls <- callr::r(function() ps::ps_shared_libs())$path
  px <- grep("processx.*client.dll", dlls)
  cr <- grep("callr.*client.dll", dlls)
  expect_true(length(px) == 0)
  expect_true(length(cr) >= 1)

  # If set, then it should come from processx
  withr::local_envvar(CALLR_NO_TEMP_DLLS = "true")
  dlls <- callr::r(function() ps::ps_shared_libs())$path
  px <- grep("processx.*client.dll", dlls)
  cr <- grep("callr.*client.dll", dlls)
  expect_true(length(px) >= 1)
  expect_true(length(cr) == 0)
})

test_that("error for unknown options", {

  expect_error(
    r_process_options(func = function() {}, foo = "bar"),
    "Unknown option"
  )

  expect_error(
    r_process_options(func = function() {}, foo = "bar", bar = "foo"),
    "Unknown options"
  )

  gc()
})

try_silently <- function(expr) {
  tryCatch(
    expr,
    error = function(x) "error",
    warning = function(x) "warning",
    message = function(x) "message"
  )
}

read_next <- function(x, timeout = 3000) {
  pr <- x$poll_process(timeout)
  if (any(pr == "ready")) {
    x$read()
  } else {
    stop("R session is not ready, timed out...")
  }
}

has_locale <- function(l) {
  skip_if_not_installed("withr")
  has <- TRUE
  tryCatch(
    withr::with_locale(c(LC_CTYPE = l), "foobar"),
    warning = function(w) has <<- FALSE,
    error = function(e) has <<- FALSE
  )
  has
}

test_paths <- function(callr_drop, callr_keep,
                       system_drop = callr_drop, system_keep = callr_keep,
                       system_vanilla_drop = system_drop,
                       system_vanilla_keep = system_keep) {

  # env vars we manipulate and need to restore in the child process
  envs <- c("R_ENVIRON", "R_ENVIRON_USER", "R_PROFILE", "R_PROFILE_USER",
            "R_LIBS", "R_LIBS_USER", "R_LIBS_SITE")

  # env vars that should not be set, in addition to the CALLR_*_BAK ones
  xenvs <- c("CALLR_CHILD_R_LIBS", "CALLR_CHILD_R_LIBS_SITE",
             "CALLR_CHILD_R_LIBS_USER")

  check_env <- function(subenv) {
    miss <- paste0("CALLR_", envs, "_BAK")
    expect_equal(Sys.getenv()[envs], subenv[envs])
    expect_false(any(miss %in% names(subenv)))
  }

  fc <- function() {
    lib <- normalizePath(.libPaths())
    list(env = Sys.getenv(), lib = lib)
  }

  out <- callr::r(fc , libpath = callr_keep)
  expect_equal(
    out$lib,
    unique(normalizePath(c(callr_keep, .Library.site, .Library)))
  )
  check_env(out$env)

  rbin <- setup_r_binary_and_args(list())$bin
  rbin <- shQuote(rbin)

  f1 <- function(rbin) {
    lib <- system(paste(rbin, "-q -e \".libPaths()\""), intern = TRUE)
    list(env = Sys.getenv(), lib = lib)
  }

  out <- callr::r(f1, list(rbin = rbin), libpath = system_keep)
  if (length(system_keep)) {
    expect_false(any(grepl(basename(normalizePath(system_keep)), out)))
  }
  if (length(system_drop)) {
    expect_false(any(grepl(basename(normalizePath(system_drop)), out)))
  }
  check_env(out$env)

  fvanilla <- function(rbin) {
    lib <- system(paste(rbin, "--vanilla -q -e \".libPaths()\""), intern = TRUE)
    list(env = Sys.getenv(), lib = lib)
  }

  outvanilla <- callr::r(
    fvanilla, list(rbin = rbin),
    libpath = system_vanilla_keep
  )
  if (length(system_vanilla_keep)) {
    expect_false(
      any(grepl(basename(normalizePath(system_vanilla_keep)), outvanilla))
    )
  }
  if (length(system_vanilla_drop)) {
    expect_false(
      any(grepl(basename(normalizePath(system_vanilla_drop)), outvanilla))
    )
  }
  check_env(out$env)
}

test_temp_file <- function(fileext = "", pattern = "test-file-",
                           envir = parent.frame(), create = TRUE) {
  skip_if_not_installed("withr")
  tmp <- tempfile(pattern = pattern, fileext = fileext)
  if (identical(envir, .GlobalEnv)) {
    message("Temporary files will _not_ be cleaned up")
  } else {
    withr::defer(
      try(unlink(tmp, recursive = TRUE, force = TRUE), silent = TRUE),
      envir = envir)
  }
  if (create) {
    cat("", file = tmp)
    normalizePath(tmp)
  } else {
    tmp
  }
}

test_temp_dir <- function(pattern = "test-dir-", envir = parent.frame()) {
  tmp <- test_temp_file(pattern = pattern, envir = envir, create = FALSE)
  dir.create(tmp, recursive = TRUE, showWarnings = FALSE)
  normalizePath(tmp)
}

expect_error <- function(..., class = "error") {
  testthat::expect_error(..., class = class)
}

test_package_root <- function() {
  skip_if_not_installed("rprojroot")
  x <- tryCatch(
    rprojroot::find_package_root_file(),
    error = function(e) NULL)

  if (!is.null(x)) return(x)

  pkg <- testthat::testing_package()
  x <- tryCatch(
    rprojroot::find_package_root_file(
      path = file.path("..", "..", "00_pkg_src", pkg)),
    error = function(e) NULL)

  if (!is.null(x)) return(x)

  stop("Cannot find package root")
}

in_covr <- function() {
  Sys.getenv("R_COVR") == "true"
}

skip_in_covr <- function() {
  if (in_covr()) skip("In covr")
}

clean_envvars <- function() {
  c(R_DEFAULT_PACKAGES = "NULL", R_ENABLE_JIT = "0")
}

without_env <- function(f) {
  environment(f) <- .GlobalEnv
  f
}

expect_r_process_snapshot <- function(..., interactive = TRUE, echo = TRUE,
                                      transform = NULL, variant = NULL) {
  skip_if_not_installed("asciicast")
  skip_if_not_installed("withr")

  # Skip these tests on platforms where V8 is not available
  if (! R.Version()$arch %in% c("i386", "x86_64", "aarch64") &&
                   ! requireNamespace("asciicast", quietly = TRUE)) {
    skip("No asciicast package")
  }

  # errors.R assumes non-interactive in testthat, but we don't want that
  withr::local_envvar(TESTTHAT = NA_character_)
  dots <- eval(substitute(alist(...)))
  nms <- names(dots)
  if (all(nms == "")) {
    code_pos <- rep(TRUE, length(dots))
  } else {
    code_pos <- nms == ""
  }
  code <- unlist(lapply(dots[code_pos], deparse))
  args <- dots[!code_pos]

  record_output <- asciicast::record_output
  output <- do.call(
    "record_output",
    c(list(code), args, interactive = interactive, echo = echo)
  )

  r_process <- function() writeLines(output)

  expect_snapshot(r_process(), transform = transform, variant = variant)
}

redact_srcref <- function(x) {
  sub("[ ]*at [-a-zA-Z0-9]+[.]R:[0-9]+:[0-9]+?", "", x)
}

redact_callr_rs_result <- function(x) {
  sub("done callr-rs-result-[a-f0-9]+", "done callr-rs-result-<id>", x)
}

fix_eol <- function(x) {
  gsub("\\r\\n", "\\n", x, fixed = TRUE)
}

test_that("all figures in man/figures are needed", {
  skip_on_cran()
  skip_on_covr()
  pkg_dir <- test_package_root()
  figs <- dir(file.path(pkg_dir, "man", "figures"))
  readme <- file.path(pkg_dir, "README.md")
  readme_figs <- grep("man/figures/", readLines(readme), value = TRUE)
  readme_figs <- sub("^.*man/figures/(.*[.]svg).*$", "\\1", readme_figs)
  expect_equal(
    sort(figs),
    sort(readme_figs)
  )
})

test_that("error for unknown options", {
  expect_snapshot(error = TRUE, {
    r_process_options(
      func = function() {},
      foo = "bar"
    )
  })

  expect_snapshot(error = TRUE, {
    r_process_options(
      func = function() {},
      foo = "bar",
      bar = "foo"
    )
  })

  gc()
})

test_that("load_client_lib", {
  lib <- load_client_lib()

  funcs <- c("base64_decode", "set_stderr", "write_fd")
  expect_true(
    all(funcs %in% names(lib))
  )

  lib <- load_client_lib(pxdir = find.package("processx"))
  expect_true(
    all(funcs %in% names(lib))
  )
})

test_that("errors", {
  fake(load_client_lib, "system.file", "")
  expect_snapshot(error = TRUE, load_client_lib())
})

test_that("errors 2", {
  sofile <- system.file(
    "libs",
    .Platform$r_arch,
    paste0("client", .Platform$dynlib.ext),
    package = "processx"
  )
  fake(load_client_lib, "dyn.load", function(...) stop("ooops"))
  expect_snapshot(error = TRUE, load_client_lib(sofile))
})

test_that("base64", {
  lib <- load_client_lib()
  enc <- lib$base64_encode(charToRaw("hello world!"))
  expect_equal(lib$base64_decode(enc), charToRaw("hello world!"))
})

test_that("write_fd", {
  do <- function() {
    lib <- asNamespace("callr")$load_client_lib()
    f1 <- tempfile()
    c1 <- processx::conn_create_file(f1, write = TRUE)
    lib$write_fd(processx::conn_get_fileno(c1), "hello world!\n")
    close(c1)
    readLines(f1)
  }

  ret <- callr::r(do)
  expect_equal(ret, "hello world!")
})

test_that("set_stdout, set_stderr", {
  # TODO why does this not work on windows, if `set_std{out,err}_file` work?
  # Also, `set_std{out,err}` work in `r_session`.
  # But this test crashes at the `set_stdout()` call.
  skip_on_os("windows")

  do <- function() {
    lib <- asNamespace("callr")$load_client_lib()
    f1 <- tempfile()
    f2 <- tempfile()
    c1 <- processx::conn_create_file(f1, write = TRUE)
    c2 <- processx::conn_create_file(f2, write = TRUE)
    lib$set_stdout(processx::conn_get_fileno(c1))
    lib$set_stderr(processx::conn_get_fileno(c2))
    cat("this is output")
    message("this is error")
    close(c1)
    close(c2)
    c(readLines(f1), readLines(f2))
  }

  ret <- callr::r(do)
  expect_equal(ret, c("this is output", "this is error"))
})

test_that("set_stdout_file, set_setderr_file", {
  do <- function() {
    lib <- asNamespace("callr")$load_client_lib()
    f1 <- tempfile()
    f2 <- tempfile()
    lib$set_stdout_file(f1)
    lib$set_stderr_file(f2)
    cat("this is output")
    message("this is error")
    c(readLines(f1), readLines(f2))
  }

  ret <- callr::r(do)
  expect_equal(ret, c("this is output", "this is error"))
})

test_that("init function of client lib is run", {
  pxlib <- r(function() {
    as.environment("tools:callr")$`__callr_data__`$pxlib
  })

  # File name should be `client.SOEXT` so that R can match the init
  # function from the name
  expect_true(grepl("^client\\.", basename(pxlib$.path)))

  # In case R removes the `dynamicLookup` field
  skip_on_cran()

  # Should be `FALSE` since processx disables dynamic lookup in the
  # init function
  expect_false(unclass(pxlib$.lib)$dynamicLookup)
})

test_that("CALLR_NO_TEMP_DLLS", {
  skip_on_cran()
  if (.Platform$OS.type != "windows") {
    skip("Windows only")
  }

  # If not set, then it should come from the temporary location
  withr::local_envvar(CALLR_NO_TEMP_DLLS = NA_character_)
  dlls <- callr::r(function() ps::ps_shared_libs())$path
  px <- grep("processx.*client.dll", dlls)
  cr <- grep("callr.*client.dll", dlls)
  expect_true(length(px) == 0)
  expect_true(length(cr) >= 1)

  # If set, then it should come from processx
  withr::local_envvar(CALLR_NO_TEMP_DLLS = "true")
  dlls <- callr::r(function() ps::ps_shared_libs())$path
  px <- grep("processx.*client.dll", dlls)
  cr <- grep("callr.*client.dll", dlls)
  expect_true(length(px) >= 1)
  expect_true(length(cr) == 0)
})

test_that("callr_tempdir honors CALLR_TMPDIR", {
  skip_if_not_installed("withr")

  withr::local_envvar(CALLR_TMPDIR = NA_character_)
  expect_identical(callr_tempdir(), tempdir())

  withr::local_envvar(CALLR_TMPDIR = "")
  expect_identical(callr_tempdir(), tempdir())

  tmp <- withr::local_tempfile()
  withr::local_envvar(CALLR_TMPDIR = tmp)
  expect_false(dir.exists(tmp))
  expect_identical(normalizePath(callr_tempdir()), normalizePath(tmp))
  expect_true(dir.exists(tmp))
})

test_that("callr_tempfile places files under CALLR_TMPDIR", {
  skip_if_not_installed("withr")

  tmp <- withr::local_tempfile()
  withr::local_envvar(CALLR_TMPDIR = tmp)

  f <- callr_tempfile("callr-utest-")
  expect_identical(
    normalizePath(dirname(f)),
    normalizePath(tmp)
  )
  expect_match(basename(f), "^callr-utest-")
})

test_that("r() works with CALLR_TMPDIR set", {
  skip_if_not_installed("withr")
  skip_in_covr()

  tmp <- withr::local_tempfile()
  withr::local_envvar(CALLR_TMPDIR = tmp)

  # The directory should not exist yet — callr_tempdir() creates it on
  # demand the first time r() needs a temp file.
  expect_false(dir.exists(tmp))
  expect_equal(callr::r(function() 1 + 1), 2)
  expect_true(dir.exists(tmp))
})

test_that("is_complete_expression", {
  skip_if_not_installed("withr")
  do_tests <- function() {
    expect_true(is_complete_expression(""))
    expect_true(is_complete_expression("1"))
    expect_true(is_complete_expression("1+1"))
    expect_true(is_complete_expression("foo + \n  bar"))
    expect_true(is_complete_expression("1 1"))

    expect_false(is_complete_expression("1+"))
    expect_false(is_complete_expression("1+1+"))
    expect_false(is_complete_expression("1+\n2+"))
  }

  do_tests()

  if (has_locale("de_DE")) {
    withr::with_envvar(c(LANGUAGE = "de_DE"), do_tests())
  }
})

test_that("default_repos", {
  skip_if_not_installed("withr")
  def <- "https://cloud.r-project.org"

  withr::with_options(
    list(repos = NULL),
    expect_equal(
      default_repos(),
      c(CRAN = def)
    )
  )

  withr::with_options(
    list(repos = character()),
    expect_equal(
      default_repos(),
      c(CRAN = def)
    )
  )

  withr::with_options(
    list(repos = list()),
    expect_equal(
      default_repos(),
      list(CRAN = def)
    )
  )

  withr::with_options(
    list(repos = c(foo = "bar")),
    expect_equal(
      default_repos(),
      c(foo = "bar", CRAN = def)
    )
  )

  withr::with_options(
    list(repos = list(foo = "bar")),
    expect_equal(
      default_repos(),
      list(foo = "bar", CRAN = def)
    )
  )

  withr::with_options(
    list(repos = c(foo = "bar", CRAN = "set")),
    expect_equal(
      default_repos(),
      c(foo = "bar", CRAN = "set")
    )
  )

  withr::with_options(
    list(repos = c(foo = "bar", CRAN = "@CRAN@")),
    expect_equal(
      default_repos(),
      c(foo = "bar", CRAN = def)
    )
  )
})

test_that("all figures in man/figures are needed", {
  skip_on_cran()
  skip_on_covr()
  pkg_dir <- test_package_root()
  figs <- dir(file.path(pkg_dir, "man", "figures"))
  readme <- file.path(pkg_dir, "README.md")
  readme_figs <- grep("man/figures/", readLines(readme), value = TRUE)
  readme_figs <- sub("^.*man/figures/(.*[.]svg).*$", "\\1", readme_figs)
  expect_equal(
    sort(figs),
    sort(readme_figs)
  )
})

test_that("regular use", {
  rs <- r_session$new()
  on.exit(rs$kill())

  expect_equal(rs$get_state(), "idle")

  ## Clean session
  expect_identical(rs$run(function() ls(.GlobalEnv)), character())

  ## Start a command
  rs$call(function() 42)

  ## Get result
  res <- read_next(rs)
  expect_equal(res$result, 42)
  expect_null(res$error)
  expect_equal(rs$get_state(), "idle")

  ## Run another command, with arguments
  rs$call(function(x, y) x + y, list(x = 42, y = 42))

  ## Get result
  res <- read_next(rs)
  expect_equal(res$result, 84)
  expect_equal(rs$get_state(), "idle")

  ## While session is idle the current call running time is NA
  rs$call(function() 42)
  expect_equal(
    is.na(rs$get_running_time()),
    c(total = FALSE, current = FALSE)
  )
  res <- read_next(rs)
  expect_equal(
    is.na(rs$get_running_time()),
    c(total = FALSE, current = TRUE)
  )
  expect_s3_class(rs$get_running_time(), "difftime")

  ## Close
  rs$close()
  expect_equal(rs$get_state(), "finished")
  expect_false(rs$is_alive())
})

test_that("run", {
  rs <- r_session$new()
  on.exit(rs$kill())

  expect_equal(rs$run_with_output(function() 42)$result, 42)
  expect_equal(rs$run_with_output(function() 42)$result, 42)
  expect_equal(
    rs$run_with_output(
      function(x, y) {
        x + y
      },
      list(x = 42, y = 42)
    )$result,
    84
  )

  ## Finish
  rs$close()
  expect_equal(rs$get_state(), "finished")
  expect_false(rs$is_alive())
})


test_that("get stdout/stderr from file", {
  rs <- r_session$new()
  on.exit(rs$kill())

  eol <- function(x) {
    paste0(x, if (.Platform$OS.type == "windows") "\r\n" else "\n")
  }

  for (i in 1:10) {
    res <- rs$run_with_output(function() {
      cat("foo\n")
      message("bar")
      42
    })
    expect_equal(
      res[c("result", "stdout", "stderr")],
      list(result = 42, stdout = eol("foo"), stderr = eol("bar"))
    )

    res <- rs$run_with_output(function() {
      cat("bar\n")
      message("foo")
      43
    })
    expect_equal(
      res[c("result", "stdout", "stderr")],
      list(result = 43, stdout = eol("bar"), stderr = eol("foo"))
    )
  }
  rs$close()
})

test_that("stdout/stderr from pipe", {
  skip_on_cran()
  opt <- r_session_options(stdout = "|", stderr = "|")
  rs <- r_session$new(opt)
  on.exit(rs$kill())

  ## Sometimes a NULL slips through....  this is bug to be fixed
  rs$read_output_lines()

  res <- rs$run_with_output(function() {
    cat("foo\n")
    message("bar")
    42
  })
  expect_equal(
    res[c("result", "stdout", "stderr")],
    list(result = 42, stdout = NULL, stderr = NULL)
  )

  res <- rs$run_with_output(function() {
    cat("bar\n")
    message("foo")
    43
  })
  expect_equal(
    res[c("result", "stdout", "stderr")],
    list(result = 43, stdout = NULL, stderr = NULL)
  )

  processx::poll(list(rs$get_output_connection()), 1000)
  expect_equal(rs$read_output_lines(n = 1), "foo")
  processx::poll(list(rs$get_output_connection()), 1000)
  expect_equal(rs$read_output_lines(n = 1), "bar")
  processx::poll(list(rs$get_error_connection()), 1000)
  expect_equal(rs$read_error_lines(n = 1), "bar")
  processx::poll(list(rs$get_error_connection()), 1000)
  expect_equal(rs$read_error_lines(n = 1), "foo")
  rs$close()
})

test_that("interrupt", {
  rs <- r_session$new()
  on.exit(rs$kill())

  rs$call(function() Sys.sleep(5))
  Sys.sleep(0.5)
  rs$interrupt()
  rs$poll_process(1000)
  res <- rs$read()
  expect_s3_class(res$error, "callr_timeout_error")
  rs$close()
})

test_that("messages", {
  f <- function() {
    x <- structure(
      list(code = 301, message = "ahoj"),
      class = c("callr_message", "condition")
    )
    signalCondition(x)
    22
  }

  msg <- NULL
  cb <- function(x) msg <<- x

  rs <- r_session$new()
  on.exit(rs$kill())

  withCallingHandlers(
    expect_silent(res <- rs$run_with_output(f)),
    callr_message = function(e) msg <<- e
  )
  expect_equal(res$result, 22)
  expect_equal(
    msg,
    structure(
      list(code = 301, message = "ahoj", muffle = "callr_r_session_muffle"),
      class = c("callr_message", "condition")
    )
  )
  rs$close()
})

test_that("messages with R objects", {
  obj <- list(a = 1, b = 2)
  f <- function(obj) {
    x <- structure(
      c(list(code = 301), obj),
      class = c("foobar_class", "callr_message", "condition")
    )
    signalCondition(x)
    22
  }

  msg <- NULL
  cb <- function(x) msg <<- x

  rs <- r_session$new()
  on.exit(rs$kill())

  withCallingHandlers(
    expect_silent(res <- rs$run_with_output(f, args = list(obj))),
    foobar_class = function(e) msg <<- e
  )
  expect_equal(res$result, 22)
  exp <- exp2 <- structure(
    list(code = 301, a = 1, b = 2),
    class = c("foobar_class", "callr_message", "condition")
  )
  exp2$muffle <- "callr_r_session_muffle"
  expect_equal(msg, exp2)
  rs$call(f, args = list(obj))
  rs$poll_process(2000)
  expect_equal(
    rs$read(),
    structure(
      list(code = 301, message = exp),
      class = "callr_session_result"
    )
  )
  rs$poll_process(2000)
  expect_equal(rs$read()$result, 22)
  rs$close()
})

test_that("run throws", {
  rs <- r_session$new()
  on.exit(rs$kill())
  expect_snapshot(error = TRUE, rs$run(function() stop("foobar")))
  rs$close()
})

test_that("exit", {
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)
  err <- tryCatch(
    res <- rs$run(function() q()),
    error = function(x) x
  )

  deadline <- Sys.time() + 3
  while (rs$is_alive() && Sys.time() < deadline) {
    Sys.sleep(0.05)
  }
  expect_true(Sys.time() < deadline)

  expect_false(rs$is_alive())
  expect_equal(rs$get_state(), "finished")
  rs$close()
})

test_that("crash", {
  skip_on_cran()
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)
  err <- tryCatch(
    rs$run(function() get("crash", asNamespace("callr"))()),
    error = function(e) e
  )
  expect_true(
    grepl("crashed with exit code", conditionMessage(err)) ||
      grepl("R session closed the process connection", conditionMessage(err)) ||
      grepl(
        "Invalid (uninitialized or closed?) connection object",
        conditionMessage(err),
        fixed = TRUE
      )
  )
  expect_false(rs$is_alive())
  expect_equal(rs$get_state(), "finished")
  rs$close()

  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)
  res <- rs$run_with_output(function() {
    cat("o\n")
    message("e")
    get("crash", asNamespace("callr"))()
  })
  expect_null(res$result)
  expect_s3_class(res$error, "error")

  ## This is a race, and sometimes we don't get the stdout/stderr
  ## on Windows
  if (os_platform() != "windows") {
    expect_equal(res$stdout, "o\n")
  }
  if (os_platform() != "windows") {
    expect_equal(substr(res$stderr, 1, 2), "e\n")
  }
  expect_false(rs$is_alive())
  expect_equal(rs$get_state(), "finished")
  rs$close()
})

test_that("custom load hook", {
  opts <- r_session_options(load_hook = quote(options(foobar = "baz")))
  rs <- r_session$new(opts)
  on.exit(rs$kill(), add = TRUE)

  res <- rs$run_with_output(function() getOption("foobar"))
  expect_null(res$error)
  expect_identical(res$result, "baz")
  expect_equal(res$stdout, "")
  expect_equal(res$stderr, "")
  rs$close()
})

test_that("traceback", {
  skip_if_not_installed("withr")
  withr::local_options(callr.traceback = TRUE)
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  do <- function() {
    f <- function() g()
    g <- function() stop("oops")
    f()
  }

  expect_snapshot(error = TRUE, rs$run(do))
  expect_output(tb <- rs$traceback(), "1: \"?f()\"?")
  expect_match(c(tb[[3]]), "f()", fixed = TRUE)
})

test_that("error in the load hook", {
  opts <- r_session_options(load_hook = quote(stop("oops")))
  expect_snapshot(
    error = TRUE,
    local({
      rs <- r_session$new(opts)
      on.exit(rs$kill(), add = TRUE)
    })
  )

  rs2 <- r_session$new(opts, wait = FALSE)
  on.exit(rs2$kill(), add = TRUE)

  processx::poll(list(rs2$get_poll_connection()), 3000)
  msg <- rs2$read()
  expect_true(msg$code %in% c(501L, 502L))
  expect_match(msg$stderr, "oops")
})

test_that("fds are not leaked", {
  skip_if_not_installed("ps")
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  old <- rs$run(function() ps::ps_num_fds())
  for (i in 1:10) {
    rs$run(function() 1 + 1)
  }
  new <- rs$run(function() ps::ps_num_fds())

  # Allow 2 new fds, just in case
  expect_true(new - old <= 2)
})

test_that("callr_message, then error", {
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  do <- function() {
    msg <- structure(
      list(message = "hi"),
      class = c("callr_message", "condition")
    )
    signalCondition(msg)
    signalCondition(msg)
    stop("nah-ah")
  }

  msg <- err <- NULL
  tryCatch(
    withCallingHandlers(
      rs$run(do),
      callr_message = function(m) msg <<- c(msg, list(m))
    ),
    error = function(e) err <<- e
  )

  expect_s3_class(msg[[1]], "callr_message")
  expect_equal(conditionMessage(msg[[1]]), "hi")
  expect_s3_class(msg[[2]], "callr_message")
  expect_equal(conditionMessage(msg[[2]]), "hi")

  expect_s3_class(err, "error")
  expect_match(conditionMessage(err), "nah-ah")

  expect_true(rs$is_alive())
  expect_equal(rs$get_state(), "idle")
  expect_identical(rs$read_error_lines(), character())

  rs$close()
})

test_that("message handlers", {
  skip_if_not_installed("withr")
  rs <- r_session$new()
  on.exit(rs$kill(), add = TRUE)

  do <- function() {
    msg <- structure(
      list(message = "hi"),
      class = c("myclass", "callr_message", "condition")
    )
    signalCondition(msg)
  }

  cond <- NULL
  withr::with_options(
    list(callr.condition_handler_myclass = function(x) {
      cond <<- x
    }),
    rs$run(do)
  )

  expect_s3_class(cond, "myclass")
  expect_equal(cond$message, "hi")

  rs$close()
})

test_that("large messages", {
  skip_if_not_installed("withr")
  rs <- r_session$new()
  on.exit(rs$close(), add = TRUE)

  do <- function() {
    msg <- structure(
      list(message = paste(1:150000, sep = " ")),
      class = c("myclass", "callr_message", "condition")
    )
    signalCondition(msg)
    for (i in 1:5) {
      msg <- structure(
        list(message = paste("message", i)),
        class = c("myclass", "callr_message", "condition")
      )
      signalCondition(msg)
    }
  }

  cond <- list()
  withr::with_options(
    list(callr.condition_handler_myclass = function(x) {
      cond <<- c(cond, list(x))
    }),
    rs$run(do)
  )

  expect_equal(length(cond), 6)
  expect_s3_class(cond[[1]], "myclass")
  expect_equal(cond[[1]]$message, paste(1:150000, sep = " "))
  for (i in 1:5) {
    expect_equal(cond[[i + 1]]$message, paste("message", i))
  }

  rs$close()
})

test_that("show option works", {
  expect_output(
    r(function() print("hello"), show = TRUE),
    "hello"
  )
  gc()
})

test_that("callbacks work", {
  out <- NULL
  r(function() cat("hello\n"), callback = function(x) out <<- x)
  expect_equal(out, "hello")
  gc()
})

test_that("show and callbacks at the same time", {
  out <- NULL

  expect_output(
    r(
      function() cat("hello\n"),
      show = TRUE,
      callback = function(x) out <<- x
    ),
    "hello"
  )

  expect_equal(out, "hello")
  gc()
})

test_that("repos is a list, #82", {
  skip_if_not_installed("withr")
  expect_true(withr::with_options(
    list(repos = list(CRAN = "https://cloud.r-project.org")),
    callr::r(function() inherits(getOption("repos"), "list"))
  ))
})

test_that("rcmd works", {
  expect_equal(rcmd("config", "CC")$status, 0)
  expect_match(rcmd("config", "CC")$stdout, ".")
  gc()
})

test_that("rcmd show works", {
  expect_output(rcmd("config", "CC", show = TRUE), ".")
  gc()
})

test_that("rcmd echo works", {
  skip_if_not_installed("withr")
  withr::local_options(width = 500)
  expect_output(rcmd("config", "CC", echo = TRUE), "config\\s+CC")
  gc()
})

test_that("rcmd_safe", {
  expect_equal(rcmd_safe("config", "CC")$status, 0)
  gc()
})

test_that("wd argument", {
  tmp <- tempfile(fileext = ".R")
  tmpout <- paste0(tmp, "out")
  cat("print(getwd())", file = tmp)

  mywd <- getwd()

  rcmd("BATCH", c(tmp, tmpout), wd = tempdir())

  expect_equal(mywd, getwd())
  expect_match(
    paste(readLines(tmpout), collapse = "\n"),
    basename(tempdir())
  )
  gc()
})

test_that("fail_on_status", {
  skip_if_not_installed("withr")
  rand <- tempfile()
  expect_error(
    withr::with_dir(
      tempdir(),
      rcmd("BATCH", rand, fail_on_status = TRUE)
    ),
    "System command .* failed|System command error",
    class = "system_command_status_error"
  )
  expect_silent(
    out <- withr::with_dir(
      tempdir(),
      rcmd("BATCH", rand, fail_on_status = FALSE)
    )
  )
  expect_true(out$status != 0)
  gc()
})

test_that("command is included in result", {
  res <- rcmd_safe("config", "CC")
  expect_false(is.null(res$command))
  expect_true(is.character(res$command))
  gc()
})

test_that("stderr -> stdout", {
  lib <- test_temp_dir()
  pkg <- test_temp_dir()
  file.copy(test_path("fixtures/D1"), file.path(pkg, "DESCRIPTION"))
  out <- rcmd("INSTALL", c("-l", lib, pkg))
  expect_match(out$stdout, "No man pages found", useBytes = TRUE)
  expect_match(out$stderr, "installing help indices")

  out2 <- rcmd("INSTALL", c("-l", lib, pkg), stderr = "2>&1")
  expect_equal(out2$status, 0L)
  expect_match(
    out2$stdout,
    "installing.*No man pages found.*testing if installed package"
  )
  expect_null(out2$stderr)

  out3 <- test_temp_file(create = FALSE)
  rcmd("INSTALL", c("-l", lib, pkg), stdout = out3, stderr = out3)
  expect_match(
    readChar(out3, nchars = file.info(out3)$size),
    "installing.*No man pages found.*testing if installed package"
  )
  gc()
})

test_that("cleans up temp files", {
  skip_on_cran()

  rc <- function() {
    library(callr)
    scriptfile <- tempfile(fileext = ".R")

    old <- dir(tempdir(), pattern = "^callr-")

    result <- callr::rcmd("config", "CC")

    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rc)
  expect_identical(out$result$status, 0L)
  expect_identical(out$new, character())
})

test_that("basic r", {
  expect_equal(r(function() 1 + 1), 2)
  expect_equal(r(function(x) 1 + x, list(5)), 6)
  gc()
})

test_that("the same R version is called", {
  expect_equal(r(function() R.version), R.version)
  gc()
})

test_that("standard output", {
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  r(function() cat("hello\n"), stdout = tmp)
  expect_equal(readLines(tmp), "hello")
  gc()
})

test_that("standard error", {
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  r(function() message("hello"), stderr = tmp)
  expect_equal(readLines(tmp), "hello")
  gc()
})

test_that("standard output and standard error", {
  tmp_out <- tempfile("stdout-")
  tmp_err <- tempfile("stderr-")
  on.exit(unlink(c(tmp_out, tmp_err)), add = TRUE)
  expect_silent(
    r(
      function() {
        cat("hello world!\n")
        message("hello again!")
      },
      stdout = tmp_out,
      stderr = tmp_err
    )
  )
  expect_equal(readLines(tmp_out), "hello world!")
  expect_equal(readLines(tmp_err), "hello again!")
  gc()
})

test_that("cmdargs argument", {
  o1 <- tempfile()
  o2 <- tempfile()
  on.exit(unlink(c(o1, o2)), add = TRUE)

  r(function() ls(), stdout = o1)
  r(function() ls(), stdout = o2, cmdargs = character())

  expect_true(length(readLines(o2)) > length(readLines(o1)))
  gc()
})

test_that("env", {
  expect_equal(
    r(function() Sys.getenv("CALLR_FOOBAR"), env = c(CALLR_FOOBAR = "indeed")),
    "indeed"
  )
  gc()
})

test_that("stdout and stderr in the same file", {
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)

  r(
    function() {
      cat("hello1\n")
      Sys.sleep(0.1)
      message("hello2")
      Sys.sleep(0.1)
      cat("hello3\n")
    },
    stdout = tmp,
    stderr = tmp
  )

  expect_equal(readLines(tmp), paste0("hello", 1:3))
  gc()
})

test_that("profiles are used as requested", {
  skip_if_not_installed("withr")
  do <- function(system, user) {
    tmp1 <- tempfile()
    tmp2 <- tempfile()
    on.exit(unlink(c(tmp1, tmp2)), add = TRUE)
    cat("Sys.setenv(FOO = 'bar')\n", file = tmp1)
    cat("Sys.setenv(NAH = 'doh')\n", file = tmp2)
    withr::with_envvar(list(R_PROFILE = tmp1, R_PROFILE_USER = tmp2), {
      res <- r(
        function() c(Sys.getenv("FOO", ""), Sys.getenv("NAH", "")),
        system_profile = system,
        user_profile = user
      )
    })
  }

  ## None
  res <- do(FALSE, FALSE)
  expect_equal(res, c("", ""))

  ## System
  res <- do(TRUE, FALSE)
  expect_equal(res, c("bar", ""))

  ## User
  res <- do(FALSE, TRUE)
  expect_equal(res, c("", "doh"))

  ## Both
  res <- do(TRUE, TRUE)
  expect_equal(res, c("bar", "doh"))
  gc()
})

test_that(".Renviron is used, but lib path is set over it", {
  skip_if_not_installed("withr")
  dir.create(tmp <- tempfile())
  on.exit(unlink(tmp, recursive = TRUE), add = TRUE)
  withr::with_dir(tmp, {
    ## Create .Renviron file
    dir.create("not")
    dir.create("yes")
    cat(
      "R_LIBS=\"",
      file.path(getwd(), "not"),
      "\"\n",
      sep = "",
      file = ".Renviron"
    )
    cat("FOO=bar\n", file = ".Renviron", append = TRUE)

    ## R CMD check sets R_ENVIRON and R_ENVIRON_USER to empty,
    ## so we need to recover that.
    withr::with_envvar(c(R_ENVIRON_USER = ".Renviron"), {
      res <- r(
        function() list(.libPaths(), Sys.getenv("FOO")),
        libpath = c(file.path(getwd(), "yes"), .libPaths())
      )
    })
  })

  expect_equal(basename(res[[1]][1]), "yes")
  expect_equal(res[[2]], "bar")
  gc()
})

test_that("errors are printed on stderr", {
  ## See https://github.com/r-lib/callr/issues/80
  f <- function() {
    print("send to stdout")
    message("send to stderr")
    stop("send to stderr 2")
  }

  expect_snapshot(error = TRUE, {
    r(f, stdout = out <- tempfile(), stderr = err <- tempfile())
  })
  on.exit(unlink(c(out, err), recursive = TRUE), add = TRUE)

  expect_false(any(grepl("send to stderr", readLines(out))))
  expect_true(any(grepl("send to stderr 2", readLines(err))))
  gc()
})

test_that("stdout and stderr are interleaved correctly", {
  f <- function() {
    cat("stdout", file = stdout())
    cat("stderr", file = stderr())
    cat("stdout2\n", file = stdout())
  }

  on.exit(unlink(out, recursive = TRUE), add = TRUE)

  r(f, stdout = out <- tempfile(), stderr = "2>&1")
  expect_equal(readLines(out), "stdoutstderrstdout2")
  unlink(out)

  r(f, stdout = out, stderr = out)
  expect_equal(readLines(out), "stdoutstderrstdout2")
  gc()
})

test_that("callr messages do not cause problems", {
  do <- function() {
    cnd <- structure(
      list(message = "foobar"),
      class = c("callr_message", "condition")
    )
    signalCondition(cnd)
    signalCondition(cnd)
    signalCondition(cnd)
    cat("stdout\n")
    message("stderr")
    "hi"
  }

  out <- tempfile()
  err <- tempfile()
  on.exit(unlink(c(out, err)), add = TRUE)
  ret <- callr::r(do, stdout = out, stderr = err, poll_connection = FALSE)

  expect_equal(ret, "hi")
  expect_equal(readLines(out), "stdout")
  expect_equal(readLines(err), "stderr")
})

test_that("cleans up temp files", {
  skip_on_cran()

  rsc <- function() {
    library(callr)
    old <- dir(tempdir(), pattern = "^callr-")

    result <- callr::r(function() 1 + 1)

    unloadNamespace("callr")

    new <- setdiff(dir(tempdir(), "^callr-"), old)

    list(result = result, new = new)
  }

  out <- r(rsc)
  expect_identical(out$result, 2)
  expect_identical(out$new, character())
})

test_that("local .Rprofile is loaded", {
  tmp <- tempfile()
  on.exit(unlink(tmp, recursive = TRUE), add = TRUE)
  dir.create(tmp)
  wd <- getwd()
  on.exit(setwd(wd), add = TRUE)
  setwd(tmp)
  cat("aa <- 123\n", file = ".Rprofile")
  out <- callr::r(function() aa)
  expect_equal(out, 123)
})

test_that("local .Rprofile is not loaded from actual wd", {
  tmp <- tempfile()
  on.exit(unlink(tmp, recursive = TRUE), add = TRUE)
  dir.create(tmp)
  wd <- getwd()
  on.exit(setwd(wd), add = TRUE)
  setwd(tmp)

  dir.create(wd2 <- tempfile())
  on.exit(unlink(wd2, recursive = TRUE), add = TRUE)
  cat("aa <- 123\n", file = ".Rprofile")
  out <- callr::r(function() ls(.GlobalEnv), wd = wd2)
  expect_equal(out, character())
})

test_that("local .Rprofile is not loaded recursively", {
  tmp <- tempfile()
  on.exit(unlink(tmp, recursive = TRUE), add = TRUE)
  dir.create(tmp)
  wd <- getwd()
  on.exit(setwd(wd), add = TRUE)
  setwd(tmp)

  expr <- quote({
    rprofile <- Sys.getenv("R_PROFILE_USER", "~/.Rprofile")
    if (file.exists(rprofile)) {
      source(rprofile)
    }
    rm(rprofile)
    aa <- 123
  })
  cat(deparse(expr), file = ".Rprofile", sep = "\n")
  out <- callr::r(function() aa)
  expect_equal(out, 123)
})

test_that("symbolic arguments are protected", {
  expect_equal(
    callr::r(function(x) x, list(x = quote(foobar))),
    quote(foobar)
  )
})

test_that(".Library", {
  expect_equal(
    .Library,
    r(function() .Library)
  )
  gc()
})

test_that(".Library.site", {
  expect_equal(
    .Library.site,
    r(function() .Library.site)
  )
  gc()
})

test_that(".libPaths()", {
  skip_if_not_installed("withr")
  dir.create(tmp <- tempfile())
  on.exit(unlink(tmp, recursive = TRUE))

  lp <- withr::with_libpaths(
    tmp,
    action = "prefix",
    r(function() {
      .libPaths()
    })
  )

  expect_true(normalizePath(tmp) %in% normalizePath(lp))
  gc()
})

test_that("if .Renviron overrides R_PROFILE", {
  ## But we still need to use the proper lib path, as set in the fake
  ## profile
  skip_in_covr()
  skip_if_not_installed("withr")

  cat("Sys.setenv(FOO='nope')\n", file = tmp_prof <- tempfile())
  cat("R_PROFILE=\"", tmp_prof, "\"\n", file = tmp_env <- tempfile(), sep = "")
  cat(
    "R_PROFILE_USER=\"",
    tmp_prof,
    "\"\n",
    file = tmp_env,
    sep = "",
    append = TRUE
  )

  cat("FOO=bar\n", file = tmp_env, sep = "", append = TRUE)

  dir.create(tmp_lib <- tempfile())

  on.exit(unlink(c(tmp_prof, tmp_env, tmp_lib), recursive = TRUE))

  lp <- withr::with_envvar(
    c(R_ENVIRON = tmp_env),
    withr::with_libpaths(
      tmp_lib,
      action = "prefix",
      r(
        function() list(.libPaths(), Sys.getenv("FOO"), Sys.getenv("R_PROFILE"))
      )
    )
  )

  expect_true(normalizePath(tmp_lib) %in% normalizePath(lp[[1]]))
  expect_equal(lp[[2]], "bar")
  gc()
})

test_that("libpath in system(), empty .Renviron", {
  # We remove the library with covr from the lib path, so this
  # cannot work in a subprocess.
  skip_in_covr()
  skip_if_not_installed("withr")

  dir.create(tmpdrop <- tempfile("drop"))
  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(c(tmpdrop, tmpkeep), recursive = TRUE), add = TRUE)

  tmpenv <- withr::local_tempfile()
  cat("", file = tmpenv)
  withr::local_envvar(c(R_ENVIRON_USER = tmpenv))

  withr::local_libpaths(tmpdrop, action = "prefix")

  test_paths(tmpdrop, tmpkeep)

  ## To close FDs
  gc()
})

test_that("libpath in system, R_LIBS in .Renviron", {
  # We remove the library with covr from the lib path, so this
  # cannot work in a subprocess.
  skip_in_covr()
  skip_if_not_installed("withr")

  dir.create(tmpdrop <- tempfile("drop"))
  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(c(tmpdrop, tmpkeep), recursive = TRUE), add = TRUE)

  tmpenv <- withr::local_tempfile()
  cat("R_LIBS=\"", tmpdrop, "\"\n", sep = "", file = tmpenv)
  withr::local_envvar(c(R_ENVIRON_USER = tmpenv))

  withr::local_libpaths(tmpdrop, action = "prefix")

  # Since we add tmpdrop in .Renviron, it will only be dropped by --vanilla
  test_paths(tmpdrop, tmpkeep, system_drop = NULL)

  ## To close FDs
  gc()
})

test_that("libpath in system, R_LIBS", {
  # We remove the library with covr from the lib path, so this
  # cannot work in a subprocess.
  skip_in_covr()
  skip_if_not_installed("withr")

  dir.create(tmpdrop <- tempfile("drop"))
  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(c(tmpdrop, tmpkeep), recursive = TRUE), add = TRUE)

  tmpenv <- withr::local_tempfile()
  cat("", file = tmpenv)
  withr::local_envvar(c(R_ENVIRON_USER = tmpenv, R_LIBS = tmpdrop))

  withr::local_libpaths(tmpdrop, action = "prefix")

  # R_LIBS is used by both R and R --vanilla, so it will not be dropped
  test_paths(tmpdrop, tmpkeep, system_drop = NULL, system_vanilla_drop = NULL)

  ## To close FDs
  gc()
})

test_that("libpath in system, R_LIBS and .Renviron", {
  # We remove the library with covr from the lib path, so this
  # cannot work in a subprocess.
  skip_in_covr()
  skip_if_not_installed("withr")

  dir.create(tmpdrop <- tempfile("drop"))
  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(c(tmpdrop, tmpkeep), recursive = TRUE), add = TRUE)

  tmpenv <- withr::local_tempfile()
  cat("R_LIBS=\"", tmpdrop, "\"\n", sep = "", file = tmpenv)
  withr::local_envvar(c(R_ENVIRON_USER = tmpenv, R_LIBS = tmpdrop))

  withr::local_libpaths(tmpdrop, action = "prefix")

  # R_LIBS is used by both R and R --vanilla, so it will not be dropped
  test_paths(tmpdrop, tmpkeep, system_drop = NULL, system_vanilla_drop = NULL)

  ## To close FDs
  gc()
})

test_that("libpath in system, if subprocess changes R_LIBS", {
  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(tmpkeep, recursive = TRUE), add = TRUE)

  rbin <- setup_r_binary_and_args(list())$bin
  rbin <- shQuote(rbin)

  f <- function(rbin, new) {
    Sys.setenv(R_LIBS = new)
    Sys.setenv(R_ENVIRON_USER = "no_such_file")
    system(
      paste(
        rbin,
        "--no-site-file --no-init-file --no-save --no-restore --slave",
        "-e \".libPaths()\""
      ),
      intern = TRUE
    )
  }

  out <- callr::r(f, list(rbin = rbin, new = tmpkeep))
  expect_true(any(grepl(basename(normalizePath(tmpkeep)), out)))

  ## Close FDs
  gc()
})

test_that("libpath in system, if subprocess changes R_LIBS #2", {
  if (.Platform$OS.type != "unix") {
    skip("Unix only")
  }

  dir.create(tmpkeep <- tempfile("keep"))
  on.exit(unlink(tmpkeep, recursive = TRUE), add = TRUE)

  rbin <- setup_r_binary_and_args(list())$bin

  f <- function(rbin, new) {
    Sys.setenv(R_LIBS = new)
    Sys.setenv(R_ENVIRON_USER = "no_such_file")
    env <- paste0("R_LIBS=", shQuote(new))
    tmp <- tempfile()
    on.exit(unlink(tmp), add = TRUE)
    system2(
      rbin,
      c(
        "--no-site-file",
        "--no-init-file",
        "--no-save",
        "--no-restore",
        "--slave",
        "-e",
        "'.libPaths()'"
      ),
      env = env,
      stdout = tmp
    )
    readLines(tmp)
  }

  out <- callr::r(f, list(rbin = rbin, new = tmpkeep))
  expect_true(any(grepl(basename(normalizePath(tmpkeep)), out)))

  ## Close FDs
  gc()
})

test_that("libpath = NULL keeps the subprocess library path of a fresh R session", {
  # See https://github.com/r-lib/callr/issues/255
  skip_in_covr()
  skip_if_not_installed("withr")

  dir.create(tmp_lib <- tempfile())
  dir.create(tmp_wd <- tempfile())
  on.exit(unlink(c(tmp_lib, tmp_wd), recursive = TRUE), add = TRUE)

  cat(
    sprintf(".libPaths(c(%s, .libPaths()))\n", deparse(tmp_lib)),
    file = file.path(tmp_wd, ".Rprofile")
  )

  # With libpath = NULL the subprocess respects .libPaths() set from the
  # project .Rprofile, instead of overwriting it with the parent's libpath.
  lp_null <- withr::with_dir(
    tmp_wd,
    r(
      function() .libPaths(),
      libpath = NULL,
      user_profile = "project"
    )
  )
  expect_true(normalizePath(tmp_lib) %in% normalizePath(lp_null))

  # Sanity check: with the default libpath, callr would overwrite the
  # libpath set in the project .Rprofile.
  lp_default <- withr::with_dir(
    tmp_wd,
    r(
      function() .libPaths(),
      user_profile = "project"
    )
  )
  expect_false(normalizePath(tmp_lib) %in% normalizePath(lp_default))

  gc()
})

test_that("setting profile/environ variables in 'env'", {
  # See https://github.com/r-lib/callr/issues/193

  skip_in_covr()

  profile <- tempfile()
  on.exit(unlink(profile), add = TRUE)
  cat("foo <- '11'\n", file = profile)

  envfile <- tempfile()
  on.exit(unlink(envfile), add = TRUE)
  cat("MY_ENV2=MILES2\n", file = envfile)

  ret <- callr::r(
    function() {
      c(
        Sys.getenv("MY_ENV"),
        Sys.getenv("R_PROFILE_USER"),
        exists("foo"),
        Sys.getenv("MY_ENV2")
      )
    },
    user_profile = TRUE,
    env = c(
      "R_PROFILE_USER" = profile,
      "R_ENVIRON_USER" = envfile,
      "MY_ENV" = "MILES"
    )
  )

  expect_equal(ret, c("MILES", profile, "TRUE", "MILES2"))
})

try_silently <- function(expr) {
  tryCatch(
    expr,
    error = function(x) "error",
    warning = function(x) "warning",
    message = function(x) "message"
  )
}

read_next <- function(x, timeout = 3000) {
  pr <- x$poll_process(timeout)
  if (any(pr == "ready")) {
    x$read()
  } else {
    stop("R session is not ready, timed out...")
  }
}

has_locale <- function(l) {
  skip_if_not_installed("withr")
  has <- TRUE
  tryCatch(
    withr::with_locale(c(LC_CTYPE = l), "foobar"),
    warning = function(w) has <<- FALSE,
    error = function(e) has <<- FALSE
  )
  has
}

test_paths <- function(
  callr_drop,
  callr_keep,
  system_drop = callr_drop,
  system_keep = callr_keep,
  system_vanilla_drop = system_drop,
  system_vanilla_keep = system_keep
) {
  # env vars we manipulate and need to restore in the child process
  envs <- c(
    "R_ENVIRON",
    "R_ENVIRON_USER",
    "R_PROFILE",
    "R_PROFILE_USER",
    "R_LIBS",
    "R_LIBS_USER",
    "R_LIBS_SITE"
  )

  # env vars that should not be set, in addition to the CALLR_*_BAK ones
  xenvs <- c(
    "CALLR_CHILD_R_LIBS",
    "CALLR_CHILD_R_LIBS_SITE",
    "CALLR_CHILD_R_LIBS_USER"
  )

  check_env <- function(subenv) {
    miss <- paste0("CALLR_", envs, "_BAK")
    expect_equal(Sys.getenv()[envs], subenv[envs])
    expect_false(any(miss %in% names(subenv)))
  }

  fc <- function() {
    lib <- normalizePath(.libPaths())
    list(env = Sys.getenv(), lib = lib)
  }

  out <- callr::r(fc, libpath = callr_keep)
  expect_equal(
    out$lib,
    unique(normalizePath(c(callr_keep, .Library.site, .Library)))
  )
  check_env(out$env)

  rbin <- setup_r_binary_and_args(list())$bin
  rbin <- shQuote(rbin)

  f1 <- function(rbin) {
    lib <- system(paste(rbin, "-q -e \".libPaths()\""), intern = TRUE)
    list(env = Sys.getenv(), lib = lib)
  }

  out <- callr::r(f1, list(rbin = rbin), libpath = system_keep)
  if (length(system_keep)) {
    expect_false(any(grepl(basename(normalizePath(system_keep)), out)))
  }
  if (length(system_drop)) {
    expect_false(any(grepl(basename(normalizePath(system_drop)), out)))
  }
  check_env(out$env)

  fvanilla <- function(rbin) {
    lib <- system(paste(rbin, "--vanilla -q -e \".libPaths()\""), intern = TRUE)
    list(env = Sys.getenv(), lib = lib)
  }

  outvanilla <- callr::r(
    fvanilla,
    list(rbin = rbin),
    libpath = system_vanilla_keep
  )
  if (length(system_vanilla_keep)) {
    expect_false(
      any(grepl(basename(normalizePath(system_vanilla_keep)), outvanilla))
    )
  }
  if (length(system_vanilla_drop)) {
    expect_false(
      any(grepl(basename(normalizePath(system_vanilla_drop)), outvanilla))
    )
  }
  check_env(out$env)
}

test_temp_file <- function(
  fileext = "",
  pattern = "test-file-",
  envir = parent.frame(),
  create = TRUE
) {
  skip_if_not_installed("withr")
  tmp <- tempfile(pattern = pattern, fileext = fileext)
  if (identical(envir, .GlobalEnv)) {
    message("Temporary files will _not_ be cleaned up")
  } else {
    withr::defer(
      try(unlink(tmp, recursive = TRUE, force = TRUE), silent = TRUE),
      envir = envir
    )
  }
  if (create) {
    cat("", file = tmp)
    normalizePath(tmp)
  } else {
    tmp
  }
}

test_temp_dir <- function(pattern = "test-dir-", envir = parent.frame()) {
  tmp <- test_temp_file(pattern = pattern, envir = envir, create = FALSE)
  dir.create(tmp, recursive = TRUE, showWarnings = FALSE)
  normalizePath(tmp)
}

expect_error <- function(..., class = "error") {
  testthat::expect_error(..., class = class)
}

test_package_root <- function() {
  skip_if_not_installed("rprojroot")
  x <- tryCatch(
    rprojroot::find_package_root_file(),
    error = function(e) NULL
  )

  if (!is.null(x)) {
    return(x)
  }

  pkg <- testthat::testing_package()
  x <- tryCatch(
    rprojroot::find_package_root_file(
      path = file.path("..", "..", "00_pkg_src", pkg)
    ),
    error = function(e) NULL
  )

  if (!is.null(x)) {
    return(x)
  }

  stop("Cannot find package root")
}

in_covr <- function() {
  Sys.getenv("R_COVR") == "true"
}

skip_in_covr <- function() {
  if (in_covr()) skip("In covr")
}

clean_envvars <- function() {
  c(R_DEFAULT_PACKAGES = "NULL", R_ENABLE_JIT = "0")
}

without_env <- function(f) {
  environment(f) <- .GlobalEnv
  f
}

expect_r_process_snapshot <- function(
  ...,
  interactive = TRUE,
  echo = TRUE,
  transform = NULL,
  variant = NULL
) {
  skip_if_not_installed("asciicast")
  skip_if_not_installed("withr")

  # Skip these tests on platforms where V8 is not available
  if (
    !R.Version()$arch %in% c("i386", "x86_64", "aarch64") &&
      !requireNamespace("asciicast", quietly = TRUE)
  ) {
    skip("No asciicast package")
  }

  # errors.R assumes non-interactive in testthat, but we don't want that
  withr::local_envvar(TESTTHAT = NA_character_)
  dots <- eval(substitute(alist(...)))
  nms <- names(dots)
  if (all(nms == "")) {
    code_pos <- rep(TRUE, length(dots))
  } else {
    code_pos <- nms == ""
  }
  code <- unlist(lapply(dots[code_pos], deparse))
  args <- dots[!code_pos]

  record_output <- asciicast::record_output
  output <- do.call(
    "record_output",
    c(list(code), args, interactive = interactive, echo = echo)
  )

  r_process <- function() writeLines(output)

  expect_snapshot(r_process(), transform = transform, variant = variant)
}

redact_srcref <- function(x) {
  sub("[ ]*at [-a-zA-Z0-9]+[.]R:[0-9]+:[0-9]+?", "", x)
}

redact_callr_rs_result <- function(x) {
  sub("done callr-rs-result-[a-f0-9]+", "done callr-rs-result-<id>", x)
}

fix_eol <- function(x) {
  gsub("\\r\\n", "\\n", x, fixed = TRUE)
}

test_that("r with timeout", {
  tic <- Sys.time()
  e <- tryCatch(
    r(function() Sys.sleep(5), timeout = 1),
    error = function(e) e
  )
  tac <- Sys.time()

  expect_true("callr_timeout_error" %in% class(e))
  expect_true(tac - tic < as.difftime(4, units = "secs"))
  gc()
})

# error is propagated, .Last.error is set

    Code
      r_process()
    Output
      > callr::r(function() 1 + "A", error = "error")
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      Type .Last.error to see the more details.
      > .Last.error
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      ---
      Backtrace:
      1. callr::r(function() 1 + "A", error = "error")
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e)
      2. global h(simpleError(msg, call))

# error is propagated, printed if non-interactive mode

    Code
      r_process()
    Output
      > callr::r(function() 1 + "A", error = "error")
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      ---
      Backtrace:
      1. callr::r(function() 1 + "A", error = "error")
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e)
      2. global h(simpleError(msg, call))
      Execution halted

# error stack is passed, .Last.error is set

    Code
      r_process()
    Output
      > callr::r(function() {
      +     f <- function() g()
      +     g <- function() 1 + "A"
      +     f()
      + }, error = "stack")
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      i With remote `$stack`, use `utils::debugger()` to debug it.
      Type .Last.error to see the more details.
      > .Last.error
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      i With remote `$stack`, use `utils::debugger()` to debug it.
      ---
      Backtrace:
      1. callr::r(function() {
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error_with_stack(remerr, output), parent = fix_msg(remer

# error behavior can be set using option

    Code
      r(function() 1 + "A")
    Condition
      Error:
      ! in callr subprocess.
      Caused by error:
      ! non-numeric argument to binary operator

---

    Code
      r(function() {
        f <- (function() g())
        g <- (function() 1 + "A")
        f()
      })
    Condition
      Error:
      ! in callr subprocess.
      Caused by error:
      ! non-numeric argument to binary operator

# parent errors

    Code
      err <- tryCatch(r(function() 1 + "A"), error = function(e) e)
      err$parent
    Output
      <simpleError in "1 + \"A\"": non-numeric argument to binary operator>

# parent errors, another level

    Code
      err <- tryCatch(callr::r(function() {
        withr::local_options(list(callr.error = "error"))
        callr::r(function() 1 + "A")
      }), error = function(e) e)
      err$parent
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e) ...
      2. global h(simpleError(msg, call))
    Code
      err$parent$parent
    Output
      <simpleError in "1 + \"A\"": non-numeric argument to binary operator>

# error traces are printed recursively

    Code
      r_process()
    Output
      > callr::r(function() callr::r(function() 1 + "a"))
      Error: 
      ! in callr subprocess.
      Caused by error: 
      ! in callr subprocess.
      Caused by error in `1 + "a"`:
      ! non-numeric argument to binary operator
      ---
      Backtrace:
      1. callr::r(function() callr::r(function() 1 + "a"))
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. callr::r(function() 1 + "a")
      2. callr:::get_result(output = out, options)
      3. base::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      4. | base::signalCondition(cond)
      5. global (function (e)
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e)
      2. global h(simpleError(msg, call))
      Execution halted

# errors in r_bg() are merged

    Code
      p$get_result()
    Condition
      Error:
      ! in callr subprocess.
      Caused by error:
      ! non-numeric argument to binary operator

# errors in r_process are merged

    Code
      p$get_result()
    Condition
      Error:
      ! in callr subprocess.
      Caused by error:
      ! non-numeric argument to binary operator

# errors in r_session$run() are merged

    Code
      rs$run(function() 1 + "A")
    Condition
      Error:
      ! in callr subprocess.
      Caused by error:
      ! non-numeric argument to binary operator

---

    Code
      rs$run(function() 1 + "A")
    Condition
      Error:
      ! in callr subprocess.
      Caused by error:
      ! non-numeric argument to binary operator

# errors in r_session$call() are merged

    Code
      rs$read()$error
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e) ...
      2. global h(simpleError(msg, call))

---

    Code
      rs$read()$error
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e) ...
      2. global h(simpleError(msg, call))

# child error is not modified

    Code
      err <- tryCatch(callr::r(function() stop("foobar")), error = function(e) e)
      err
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! foobar
      ---
      Subprocess backtrace:
      1. base::stop("foobar")
      2. | base::.handleSimpleError(function (e) ...
      3. global h(simpleError(msg, call))
    Code
      class(err)
    Output
      [1] "callr_status_error" "callr_error"        "rlib_error_3_0"    
      [4] "rlib_error"         "error"              "condition"         
    Code
      class(err$parent)
    Output
      [1] "simpleError" "error"       "condition"  

# new_callr_error, timeout

    Code
      r_process()
    Output
      > callr::r(function() Sys.sleep(3), timeout = 1/5)
      Error in `get_result(output = out, options)`:
      ! callr timed out
      Type .Last.error to see the more details.

---

    Code
      callr::r(function() Sys.sleep(3), timeout = 1 / 5)
    Condition
      Error:
      ! callr timed out

# interrupting an R session

    Code
      rs$read()
    Output
      $code
      [1] 200
      
      $message
      [1] "done callr-rs-result-<id>"
      
      $result
      NULL
      
      $stdout
      [1] ""
      
      $stderr
      [1] ""
      
      $error
      <callr_timeout_error/callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! callr subprocess interrupted
      Caused by error: 
      ! interrupt
      
      attr(,"class")
      [1] "callr_session_result"

# format.call_status_error

    Code
      format(err)
    Output
      [1] "Error: "                                  
      [2] "! in callr subprocess."                   
      [3] "Caused by error in `1 + \"\"`:"           
      [4] "! non-numeric argument to binary operator"
      [5] "Type .Last.error to see the more details."

---

    Code
      print(err)
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + ""`:
      ! non-numeric argument to binary operator
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e) ...
      2. global h(simpleError(msg, call))

---

    Code
      format(err)
    Output
      [1] "Error: "                                                     
      [2] "! in callr subprocess."                                      
      [3] "Caused by error in `1 + \"\"`:"                              
      [4] "! non-numeric argument to binary operator"                   
      [5] "i With remote `$stack`, use `utils::debugger()` to debug it."
      [6] "Type .Last.error to see the more details."                   

---

    Code
      print(err)
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + ""`:
      ! non-numeric argument to binary operator
      i With remote `$stack`, use `utils::debugger()` to debug it.

# format.call_status_error 2

    Code
      r_process()
    Output
      > withr::local_options(rlib_error_always_trace = TRUE)
      > err <- tryCatch(callr::r(function() 1 + ""), error = function(e) e)
      > writeLines(format(err, trace = TRUE))
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + ""`:
      ! non-numeric argument to binary operator
      ---
      Backtrace:
      1. base::tryCatch(callr::r(function() 1 + ""), error = function(e) e)
      2. base::tryCatchList(expr, classes, parentenv, handlers)
      3. base::tryCatchOne(expr, names, parentenv, handlers[[1L]])
      4. base::doTryCatch(return(expr), name, parentenv, handler)
      5. callr::r(function() 1 + "")
      6. callr:::get_result(output = out, options)
      7. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e)
      2. global h(simpleError(msg, call))

# stdout/stderr is printed on error

    Code
      r_process()
    Output
      > callr::r(function() {
      +     warning("I have a bad feeling about this")
      +     stop("told ya")
      + })
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! told ya
      i See `$stderr` for standard error.
      Type .Last.error to see the more details.
      > .Last.error
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! told ya
      i See `$stderr` for standard error.
      ---
      Backtrace:
      1. callr::r(function() {
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::stop("told ya")
      2. | base::.handleSimpleError(function (e)
      3. global h(simpleError(msg, call))
      > .Last.error$stderr
      [1] "Warning message:\nIn (function ()  : I have a bad feeling about this\n"

# stdout/stderr is printed on error 2

    Code
      r_process()
    Output
      > callr::r(function() {
      +     writeLines("Just some output")
      +     stop("told ya")
      + })
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! told ya
      i See `$stdout` for standard output.
      Type .Last.error to see the more details.
      > .Last.error
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! told ya
      i See `$stdout` for standard output.
      ---
      Backtrace:
      1. callr::r(function() {
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::stop("told ya")
      2. | base::.handleSimpleError(function (e)
      3. global h(simpleError(msg, call))
      > .Last.error$stdout
      [1] "Just some output\n"

# stdout/stderr is printed on error 3

    Code
      r_process()
    Output
      > callr::r(function() {
      +     writeLines("Just some output")
      +     warning("I have a bad feeling about this")
      +     stop("told ya")
      + })
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! told ya
      ---
      Standard output:
      Just some output
      ---
      Standard error:
      Warning message:
      In (function ()  : I have a bad feeling about this
      ---
      Backtrace:
      1. callr::r(function() {
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::stop("told ya")
      2. | base::.handleSimpleError(function (e)
      3. global h(simpleError(msg, call))
      Execution halted

# error is printed to file

    Code
      err$stderr
    Output
      [1] "Error in (function ()  : ouch\n"

---

    Code
      readLines(tmp)
    Output
      [1] "Error in (function ()  : ouch"

# errors are printed on stderr

    Code
      r(f, stdout = out <- tempfile(), stderr = err <- tempfile())
    Condition
      Error:
      ! ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! send to stderr 2

# run throws

    Code
      rs$run(function() stop("foobar"))
    Condition
      Error:
      ! ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! foobar

# traceback

    Code
      rs$run(do)
    Condition
      Error:
      ! ! in callr subprocess.
      Caused by error in `g()`:
      ! oops

# error in the load hook

    Code
      local({
        rs <- r_session$new(opts)
        on.exit(rs$kill(), add = TRUE)
      })
    Condition
      Error:
      ! ! callr subprocess failed: Failed to start R session

# r_bg can be killed

    Code
      x$get_result()
    Condition
      Error:
      ! ! callr subprocess failed: could not start R, exited with non-zero status, has crashed or was killed

# r_bg can get the error back

    Code
      x$get_result()
    Condition
      Error:
      ! ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator

# error is propagated, .Last.error is set

    Code
      r_process()
    Output
      > callr::r(function() 1 + "A", error = "error")
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      Type .Last.error to see the more details.
      > .Last.error
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      ---
      Backtrace:
      1. callr::r(function() 1 + "A", error = "error")
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e)
      2. global h(simpleError(msg, call))

# error is propagated, printed if non-interactive mode

    Code
      r_process()
    Output
      > callr::r(function() 1 + "A", error = "error")
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      ---
      Backtrace:
      1. callr::r(function() 1 + "A", error = "error")
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e)
      2. global h(simpleError(msg, call))
      Execution halted

# error stack is passed, .Last.error is set

    Code
      r_process()
    Output
      > callr::r(function() {
      +     f <- function() g()
      +     g <- function() 1 + "A"
      +     f()
      + }, error = "stack")
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      i With remote `$stack`, use `utils::debugger()` to debug it.
      Type .Last.error to see the more details.
      > .Last.error
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      i With remote `$stack`, use `utils::debugger()` to debug it.
      ---
      Backtrace:
      1. callr::r(function() {
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error_with_stack(remerr, output), parent = fix_msg(remer

# error behavior can be set using option

    Code
      callr::r(function() 1 + "A")
    Condition
      Error:
      ! ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator

---

    Code
      r_process()
    Output
      > {
      +     options(callr.error = "error")
      +     callr::r(function() 1 + "A")
      + }
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      Type .Last.error to see the more details.

---

    Code
      r_process()
    Output
      > {
      +     options(callr.error = "stack")
      +     callr::r(function() {
      +         f <- function() g()
      +         g <- function() 1 + "A"
      +         f()
      +     })
      + }
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      i With remote `$stack`, use `utils::debugger()` to debug it.
      Type .Last.error to see the more details.

# parent errors

    Code
      err <- tryCatch(r(function() 1 + "A"), error = function(e) e)
      err$parent
    Output
      <simpleError in "1 + \"A\"": non-numeric argument to binary operator>

# parent errors, another level

    Code
      err <- tryCatch(callr::r(function() {
        withr::local_options(list(callr.error = "error"))
        callr::r(function() 1 + "A")
      }), error = function(e) e)
      err$parent
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e) ...
      2. global h(simpleError(msg, call))
    Code
      err$parent$parent
    Output
      <simpleError in "1 + \"A\"": non-numeric argument to binary operator>

# error traces are printed recursively

    Code
      r_process()
    Output
      > callr::r(function() callr::r(function() 1 + "a"))
      Error: 
      ! in callr subprocess.
      Caused by error: 
      ! in callr subprocess.
      Caused by error in `1 + "a"`:
      ! non-numeric argument to binary operator
      ---
      Backtrace:
      1. callr::r(function() callr::r(function() 1 + "a"))
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. callr::r(function() 1 + "a")
      2. callr:::get_result(output = out, options)
      3. base::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      4. | base::signalCondition(cond)
      5. global (function (e)
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e)
      2. global h(simpleError(msg, call))
      Execution halted

# errors in r_bg() are merged

    Code
      p$get_result()
    Condition
      Error:
      ! ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator

# errors in r_process are merged

    Code
      p$get_result()
    Condition
      Error:
      ! ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator

# errors in r_session$run() are merged

    Code
      rs$run(function() 1 + "A")
    Condition
      Error:
      ! ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator

---

    Code
      rs$run(function() 1 + "A")
    Condition
      Error:
      ! ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator

# errors in r_session$call() are merged

    Code
      rs$read()$error
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e) ...
      2. global h(simpleError(msg, call))

---

    Code
      rs$read()$error
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + "A"`:
      ! non-numeric argument to binary operator
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e) ...
      2. global h(simpleError(msg, call))

# child error is not modified

    Code
      err <- tryCatch(callr::r(function() stop("foobar")), error = function(e) e)
      err
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! foobar
      ---
      Subprocess backtrace:
      1. base::stop("foobar")
      2. | base::.handleSimpleError(function (e) ...
      3. global h(simpleError(msg, call))
    Code
      class(err)
    Output
      [1] "callr_status_error" "callr_error"        "rlib_error_3_0"    
      [4] "rlib_error"         "error"              "condition"         
    Code
      class(err$parent)
    Output
      [1] "simpleError" "error"       "condition"  

# new_callr_error, timeout

    Code
      r_process()
    Output
      > callr::r(function() Sys.sleep(3), timeout = 1/5)
      Error in `get_result(output = out, options)`:
      ! callr timed out
      Type .Last.error to see the more details.

---

    Code
      callr::r(function() Sys.sleep(3), timeout = 1 / 5)
    Condition
      Error:
      ! ! callr timed out

# interrupting an R session

    Code
      rs$read()
    Output
      $code
      [1] 200
      
      $message
      [1] "done callr-rs-result-<id>"
      
      $result
      NULL
      
      $stdout
      [1] ""
      
      $stderr
      [1] ""
      
      $error
      <callr_timeout_error/callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! callr subprocess interrupted
      Caused by error: 
      ! interrupt
      
      attr(,"class")
      [1] "callr_session_result"

# format.call_status_error

    Code
      format(err)
    Output
      [1] "Error: "                                  
      [2] "! in callr subprocess."                   
      [3] "Caused by error in `1 + \"\"`:"           
      [4] "! non-numeric argument to binary operator"
      [5] "Type .Last.error to see the more details."

---

    Code
      print(err)
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + ""`:
      ! non-numeric argument to binary operator
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e) ...
      2. global h(simpleError(msg, call))

---

    Code
      format(err)
    Output
      [1] "Error: "                                                     
      [2] "! in callr subprocess."                                      
      [3] "Caused by error in `1 + \"\"`:"                              
      [4] "! non-numeric argument to binary operator"                   
      [5] "i With remote `$stack`, use `utils::debugger()` to debug it."
      [6] "Type .Last.error to see the more details."                   

---

    Code
      print(err)
    Output
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + ""`:
      ! non-numeric argument to binary operator
      i With remote `$stack`, use `utils::debugger()` to debug it.

# format.call_status_error 2

    Code
      r_process()
    Output
      > withr::local_options(rlib_error_always_trace = TRUE)
      > err <- tryCatch(callr::r(function() 1 + ""), error = function(e) e)
      > writeLines(format(err, trace = TRUE))
      Error: 
      ! in callr subprocess.
      Caused by error in `1 + ""`:
      ! non-numeric argument to binary operator
      ---
      Backtrace:
      1. base::tryCatch(callr::r(function() 1 + ""), error = function(e) e)
      2. base::tryCatchList(expr, classes, parentenv, handlers)
      3. base::tryCatchOne(expr, names, parentenv, handlers[[1L]])
      4. base::doTryCatch(return(expr), name, parentenv, handler)
      5. callr::r(function() 1 + "")
      6. callr:::get_result(output = out, options)
      7. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::.handleSimpleError(function (e)
      2. global h(simpleError(msg, call))

# stdout/stderr is printed on error

    Code
      r_process()
    Output
      > callr::r(function() {
      +     warning("I have a bad feeling about this")
      +     stop("told ya")
      + })
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! told ya
      i See `$stderr` for standard error.
      Type .Last.error to see the more details.
      > .Last.error
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! told ya
      i See `$stderr` for standard error.
      ---
      Backtrace:
      1. callr::r(function() {
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::stop("told ya")
      2. | base::.handleSimpleError(function (e)
      3. global h(simpleError(msg, call))
      > .Last.error$stderr
      [1] "Warning message:\nIn (function ()  : I have a bad feeling about this\n"

# stdout/stderr is printed on error 2

    Code
      r_process()
    Output
      > callr::r(function() {
      +     writeLines("Just some output")
      +     stop("told ya")
      + })
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! told ya
      i See `$stdout` for standard output.
      Type .Last.error to see the more details.
      > .Last.error
      <callr_error/rlib_error_3_0/rlib_error/error>
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! told ya
      i See `$stdout` for standard output.
      ---
      Backtrace:
      1. callr::r(function() {
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::stop("told ya")
      2. | base::.handleSimpleError(function (e)
      3. global h(simpleError(msg, call))
      > .Last.error$stdout
      [1] "Just some output\n"

# stdout/stderr is printed on error 3

    Code
      r_process()
    Output
      > callr::r(function() {
      +     writeLines("Just some output")
      +     warning("I have a bad feeling about this")
      +     stop("told ya")
      + })
      Error: 
      ! in callr subprocess.
      Caused by error in `(function () ...`:
      ! told ya
      ---
      Standard output:
      Just some output
      ---
      Standard error:
      Warning message:
      In (function ()  : I have a bad feeling about this
      ---
      Backtrace:
      1. callr::r(function() {
      2. callr:::get_result(output = out, options)
      3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]]))
      ---
      Subprocess backtrace:
      1. base::stop("told ya")
      2. | base::.handleSimpleError(function (e)
      3. global h(simpleError(msg, call))
      Execution halted

# error is printed to file

    Code
      err$stderr
    Output
      [1] "Error in (function ()  : ouch\n"

---

    Code
      readLines(tmp)
    Output
      [1] "Error in (function ()  : ouch"

# error for unknown options

    Code
      r_process_options(func = function() { }, foo = "bar")
    Condition
      Error:
      ! ! Unknown optioncharacter(0):'foo'

---

    Code
      r_process_options(func = function() { }, foo = "bar", bar = "foo")
    Condition
      Error:
      ! ! Unknown options:'foo' and 'bar'

# errors

    Code
      load_client_lib()
    Condition
      Error in `sofile_in_processx()`:
      ! Cannot find client file

# errors 2

    Code
      load_client_lib(sofile)
    Condition
      Error in `dyn.load()`:
      !  after ooops

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/r-session.R
\name{r_session_debug}
\alias{r_session_debug}
\title{Interactive debugging of persistent R sessions}
\description{
The \code{r_session$debug()} method is an interactive debugger to inspect
the stack of the background process after an error.
}
\details{
Note that on callr version 3.8.0 and above, you need to set the
\code{callr.traceback} option to \code{TRUE} (in the main process) to make
the subprocess dump the frames on error. This is because saving
the frames can be costly for large objects passed as arguments.

\verb{$debug()} starts a REPL (Read-Eval-Print-Loop), that evaluates R
expressions in the subprocess. It is similar to \code{\link[=browser]{browser()}} and
\code{\link[=debugger]{debugger()}} and also has some extra commands:
\itemize{
\item \code{.help} prints a short help message.
\item \code{.where} prints the complete stack trace of the error. (The same as
the \verb{$traceback()} method.
\item \verb{.inspect <n>} switches the "focus" to frame \verb{<n>}. Frame 0 is the
global environment, so \verb{.inspect 0} will switch back to that.
}

To exit the debugger, press the usual interrupt key, i.e. \code{CTRL+c} or
\code{ESC} in some GUIs.

Here is an example session that uses \verb{$debug()} (some output is omitted
for brevity):

\if{html}{\out{<div class="sourceCode">}}\preformatted{# ----------------------------------------------------------------------
> rs <- r_session$new()
> rs$run(function() knitr::knit("no-such-file"))
Error in rs_run(self, private, func, args) :
 callr subprocess failed: cannot open the connection

> rs$debug()
Debugging in process 87361, press CTRL+C (ESC) to quit. Commands:
  .where       -- print stack trace
  .inspect <n> -- inspect a frame, 0 resets to .GlobalEnv
  .help        -- print this message
  <cmd>        -- run <cmd> in frame or .GlobalEnv

3: file(con, "r")
2: readLines(input2, encoding = "UTF-8", warn = FALSE)
1: knitr::knit("no-such-file") at #1

RS 87361 > .inspect 1

RS 87361 (frame 1) > ls()
 [1] "encoding"  "envir"     "ext"       "in.file"   "input"     "input.dir"
 [7] "input2"    "ocode"     "oconc"     "oenvir"    "oopts"     "optc"
[13] "optk"      "otangle"   "out.purl"  "output"    "quiet"     "tangle"
[19] "text"

RS 87361 (frame 1) > input
[1] "no-such-file"

RS 87361 (frame 1) > file.exists(input)
[1] FALSE

RS 87361 (frame 1) > # <CTRL + C>
# ----------------------------------------------------------------------
}\if{html}{\out{</div>}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check.R
\name{convert_and_check_my_args}
\alias{convert_and_check_my_args}
\title{Convert and check function arguments}
\usage{
convert_and_check_my_args(options)
}
\arguments{
\item{options}{List of options.}
}
\description{
This function is used for all variants of \code{r} and \code{rcmd}. An argument
name is only used to refer to one kind of object, to make this possible.
}
\details{
The benefit of having a single \code{options} object is to avoid passing
around a lot of arguments all the time.

The benefit of making this object internal (i.e. that the \code{r}, etc.
functions have multiple arguments instead of a single \code{options} list),
is that documentation and usage is more user friendly (e.g. command-
completion works in the editor.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rcmd.R
\name{rcmd_safe_env}
\alias{rcmd_safe_env}
\title{\code{rcmd_safe_env} returns a set of environment variables that are
more appropriate for \code{\link[=rcmd_safe]{rcmd_safe()}}. It is exported to allow manipulating
these variables (e.g. add an extra one), before passing them to the
\code{\link[=rcmd]{rcmd()}} functions.}
\usage{
rcmd_safe_env()
}
\value{
A named character vector of environment variables.
}
\description{
It currently has the following variables:
\itemize{
\item \code{CYGWIN="nodosfilewarning"}: On Windows, do not warn about MS-DOS
style file names.
\item \code{R_TESTS=""} This variable is set by \verb{R CMD check}, and makes the
child R process load a startup file at startup, from the current
working directory, that is assumed to be the \verb{/test} directory
of the package being checked. If the current working directory is
changed to something else (as it typically is by \code{testthat}, then R
cannot start. Setting it to the empty string ensures that \code{callr} can
be used from unit tests.
\item \code{R_BROWSER="false"}: typically we don't want to start up a browser
from the child R process.
\item \code{R_PDFVIEWER="false"}: similarly for the PDF viewer.
}
}
\details{
Note that \code{callr} also sets the \code{R_ENVIRON}, \code{R_ENVIRON_USER},
\code{R_PROFILE} and \code{R_PROFILE_USER} environment variables
appropriately, unless these are set by the user in the \code{env} argument
of the \code{r}, etc. calls.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rcmd-bg.R
\name{rcmd_bg}
\alias{rcmd_bg}
\title{Run an \verb{R CMD} command in the background}
\usage{
rcmd_bg(
  cmd,
  cmdargs = character(),
  libpath = .libPaths(),
  stdout = "|",
  stderr = "|",
  poll_connection = TRUE,
  repos = default_repos(),
  system_profile = FALSE,
  user_profile = "project",
  env = rcmd_safe_env(),
  wd = ".",
  supervise = FALSE,
  ...
)
}
\arguments{
\item{cmd}{Command to run. See \code{R --help} from the command
line for the various commands. In the current version of R (3.2.4)
these are: \code{BATCH}, \code{COMPILE}, \code{SHLIB}, \code{INSTALL}, \code{REMOVE}, \code{build},
\code{check}, \code{LINK}, \code{Rprof}, \code{Rdconv}, \code{Rd2pdf}, \code{Rd2txt}, \code{Stangle},
\code{Sweave}, \code{Rdiff}, \code{config}, \code{javareconf}, \code{rtags}.}

\item{cmdargs}{Command line arguments.}

\item{libpath}{The library path. If \code{NULL}, then the library path
is not modified at all in the subprocess. This is useful for
subprocesses that should use the library path of a fresh R session,
e.g. as set up by a project \code{.Rprofile}.}

\item{stdout}{Optionally a file name to send the standard output to.}

\item{stderr}{Optionally a file name to send the standard error to.
It may be the same as \code{stdout}, in which case standard error is
redirected to standard output. It can also be the special string
\code{"2>&1"}, in which case standard error will be redirected to standard
output.}

\item{poll_connection}{Whether to have a control connection to
the process. This is used to transmit messages from the subprocess
to the parent.}

\item{repos}{The \code{repos} option. If \code{NULL}, then no
\code{repos} option is set. This options is only used if
\code{user_profile} or \code{system_profile} is set \code{FALSE},
as it is set using the system or the user profile.}

\item{system_profile}{Whether to use the system profile file.}

\item{user_profile}{Whether to use the user's profile file.
If this is \code{"project"}, then only the profile from the working
directory is used, but the \code{R_PROFILE_USER} environment variable
and the user level profile are not. See also "Security considerations"
below.}

\item{env}{Environment variables to set for the child process.}

\item{wd}{Working directory to use for running the command. Defaults
to the current working directory.}

\item{supervise}{Whether to register the process with a supervisor. If \code{TRUE},
the supervisor will ensure that the process is killed when the R process
exits.}

\item{...}{Extra arguments are passed to the \link[processx:process]{processx::process}
constructor.}
}
\value{
It returns a \link{process} object.
}
\description{
The child process is started in the background, and the function
return immediately.
}
\section{Security considerations}{


\code{callr} makes a copy of the user's \code{.Renviron} file and potentially of
the local or user \code{.Rprofile}, in the session temporary
directory. Avoid storing sensitive information such as passwords, in
your environment file or your profile, otherwise this information will
get scattered in various files, at least temporarily, until the
subprocess finishes. You can use the keyring package to avoid passwords
in plain files.
}

\seealso{
Other R CMD commands:
\code{\link[=rcmd]{rcmd()}},
\code{\link[=rcmd_copycat]{rcmd_copycat()}}
}
\concept{R CMD commands}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/options.R
\name{rcmd_process_options}
\alias{rcmd_process_options}
\title{Create options for an \link{rcmd_process} object}
\usage{
rcmd_process_options(...)
}
\arguments{
\item{...}{Options to override, named arguments.}
}
\value{
A list of options.

\code{rcmd_process_options()} creates a set of options to initialize a new
object from the \code{rcmd_process} class. Its arguments must be named, the
names are used as option names. The options correspond to (some of)
the arguments of the \code{\link[=rcmd]{rcmd()}} function. At least the \code{cmd} option must
be specified, to select the \verb{R CMD} subcommand to run. Typically
\code{cmdargs} is specified as well, to supply more arguments to \verb{R CMD}.
}
\description{
Create options for an \link{rcmd_process} object
}
\examples{
## List all options and their default values:
rcmd_process_options()
}

% Generated by roxygen2: do not edit by hand % Please edit documentation in R/rscript.R \name{rscript_process} \alias{rscript_process} \title{External \code{Rscript} process} \description{ An \verb{Rscript script.R} command that runs in the background. This is an R6 class that extends the \link[processx:process]{processx::process} class. } \examples{ \dontshow{if (FALSE) withAutoprint(\{ # examplesIf} options <- rscript_process_options(script = "script.R") rp <- rscript_process$new(options) rp$wait() rp$read_output_lines() \dontshow{\}) # examplesIf} } \section{Super class}{ \code{\link[processx:process]{processx::process}} -> \code{rscript_process} } \section{Methods}{ \subsection{Public methods}{ \itemize{ \item \href{#method-rscript_process-initialize}{\code{rscript_process$new()}} \item \href{#method-rscript_process-cleanup}{\code{rscript_process$cleanup()}} \item \href{#method-rscript_process-finalize}{\code{rscript_process$finalize()}} \item \href{#method-rscript_process-clone}{\code{rscript_process$clone()}} } } \if{html}{\out{
Inherited methods

- `processx::process$as_ps_handle()`
- `processx::process$format()`
- `processx::process$get_cmdline()`
- `processx::process$get_cpu_times()`
- `processx::process$get_end_time()`
- `processx::process$get_error_connection()`
- `processx::process$get_error_file()`
- `processx::process$get_exe()`
- `processx::process$get_exit_status()`
- `processx::process$get_input_connection()`
- `processx::process$get_input_file()`
- `processx::process$get_memory_info()`
- `processx::process$get_name()`
- `processx::process$get_output_connection()`
- `processx::process$get_output_file()`
- `processx::process$get_pid()`
- `processx::process$get_poll_connection()`
- `processx::process$get_result()`
- `processx::process$get_start_time()`
- `processx::process$get_status()`
- `processx::process$get_username()`
- `processx::process$get_wd()`
- `processx::process$has_error_connection()`
- `processx::process$has_input_connection()`
- `processx::process$has_output_connection()`
- `processx::process$has_poll_connection()`
- `processx::process$interrupt()`
- `processx::process$is_alive()`
- `processx::process$is_incomplete_error()`
- `processx::process$is_incomplete_output()`
- `processx::process$is_supervised()`
- `processx::process$kill()`
- `processx::process$kill_tree()`
- `processx::process$poll_io()`
- `processx::process$print()`
- `processx::process$read_all_error()`
- `processx::process$read_all_error_lines()`
- `processx::process$read_all_output()`
- `processx::process$read_all_output_lines()`
- `processx::process$read_error()`
- `processx::process$read_error_bytes()`
- `processx::process$read_error_lines()`
- `processx::process$read_output()`
- `processx::process$read_output_bytes()`
- `processx::process$read_output_lines()`
- `processx::process$resume()`
- `processx::process$signal()`
- `processx::process$supervise()`
- `processx::process$suspend()`
- `processx::process$wait()`
- `processx::process$write_input()`

}} \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-rscript_process-initialize}{}}} \subsection{\code{rscript_process$new()}}{ Create a new \code{Rscript} process. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{rscript_process$new(options)} \if{html}{\out{
}} } \subsection{Arguments}{ \if{html}{\out{
}} \describe{ \item{\code{options}}{A list of options created via \code{\link[=rscript_process_options]{rscript_process_options()}}.} } \if{html}{\out{
}} } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-rscript_process-cleanup}{}}} \subsection{\code{rscript_process$cleanup()}}{ Delete the temporary files created for this \code{Rscript} process. Only call this method if you are sure that the process is done. If you don't call this method explicitly, the temporary files will be deleted when the process object is garbage collected. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{rscript_process$cleanup()} \if{html}{\out{
}} } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-rscript_process-finalize}{}}} \subsection{\code{rscript_process$finalize()}}{ Clean up after an \code{Rscript} process, remove temporary files. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{rscript_process$finalize()} \if{html}{\out{
}} } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-rscript_process-clone}{}}} \subsection{\code{rscript_process$clone()}}{ The objects of this class are cloneable with this method. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{rscript_process$clone(deep = FALSE)} \if{html}{\out{
}} } \subsection{Arguments}{ \if{html}{\out{
}} \describe{ \item{\code{deep}}{Whether to make a deep clone.} } \if{html}{\out{
}} } } }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/error.R
\name{new_callr_crash_error}
\alias{new_callr_crash_error}
\title{Create an error object}
\usage{
new_callr_crash_error(out, msg = NULL)
}
\arguments{
\item{out}{The object returned by \code{\link[=run]{run()}}.}

\item{msg}{An extra message to add to the error message.}
}
\description{
There are two kinds of errors, both have class \code{callr_error}:
\enumerate{
\item the first one is thrown after a timeout: \code{callr_timeout_error}.
\item the second one is thrown after an R error (in the other session):
\code{callr_status_error}.
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/r-session.R
\name{r_session_options}
\alias{r_session_options}
\title{Create options for an \link{r_session} object}
\usage{
r_session_options(...)
}
\arguments{
\item{...}{Options to override, named arguments.}
}
\value{
Named list of options.

The current options are:
\itemize{
\item \code{libpath}: Library path for the subprocess. By default the same as the
\emph{current} library path. I.e. \emph{not} necessarily the library path of
a fresh R session.) If \code{NULL}, then the library path is not modified
at all in the subprocess, which is useful for subprocesses that should
use the library path of a fresh R session, e.g. as set up by a project
\code{.Rprofile}.
\item \code{repos}: \code{repos} option for the subprocess. By default the current
value of the main process.
\item \code{stdout}: Standard output of the sub-process. This can be \code{NULL} or
a pipe: \code{"|"}. If it is a pipe then the output of the subprocess is
not included in the responses, but you need to poll and read it
manually. This is for experts. Note that this option is not used
for the startup phase that currently always runs with \code{stdout = "|"}.
\item \code{stderr}: Similar to \code{stdout}, but for the standard error. Like
\code{stdout}, it is not used for the startup phase, which runs with
\code{stderr = "|"}.
\item \code{error}: See 'Error handling' in \code{\link[=r]{r()}}.
\item \code{cmdargs}: See the same argument of \code{\link[=r]{r()}}. (Its default might be
different, though.)
\item \code{system_profile}: See the same argument of \code{\link[=r]{r()}}.
\item \code{user_profile}: See the same argument of \code{\link[=r]{r()}}.
\item \code{env}: See the same argument of \code{\link[=r]{r()}}.
\item \code{load_hook}: \code{NULL}, or code (quoted) to run in the sub-process
at start up. (I.e. not for every single \code{run()} call.)
\item \code{extra}: List of extra arguments to pass to \link[processx:process]{processx::process}.
}

Call \code{r_session_options()} to see the default values.
\code{r_session_options()} might contain undocumented entries, you cannot
change these.
}
\description{
Create options for an \link{r_session} object
}
\examples{
r_session_options()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/result.R
\name{get_result}
\alias{get_result}
\title{Read the result object from the output file, or the error}
\usage{
get_result(output, options)
}
\arguments{
\item{output}{List of the output object from \code{\link[=run]{run()}} and
the name of the result file to read. For the error file,
\code{.error} is appended to this.}

\item{options}{The context, including all parameters.}
}
\value{
If no error happened, the result is returned. Otherwise
we handle the error.
}
\description{
Even if an error happens, the output file might still exist,
because \code{\link[=saveRDS]{saveRDS()}} creates the file before evaluating its object
argument. So we need to check for the error file to decide
if an error happened.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/options.R
\name{rscript_process_options}
\alias{rscript_process_options}
\title{Create options for an \link{rscript_process} object}
\usage{
rscript_process_options(...)
}
\arguments{
\item{...}{Options to override, named arguments.}
}
\value{
A list of options.

\code{rscript_process_options()} creates a set of options to initialize a new
object from the \code{rscript_process} class. Its arguments must be named,
the names are used as option names. The options correspond to (some of)
the arguments of the \code{\link[=rscript]{rscript()}} function. At least the \code{script} option
must be specified, the script file to run.
}
\description{
Create options for an \link{rscript_process} object
}
\examples{
## List all options and their default values:
rscript_process_options()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{supported_archs}
\alias{supported_archs}
\title{Find supported sub-architectures for the current R installation}
\usage{
supported_archs()
}
\value{
Character vector of supported architectures. If the
current R build is not a multi-architecture build, then an empty
string scalar is returned.
}
\description{
This function uses a heuristic, which might fail, so its result
should be taken as a best guess.
}
\examples{
supported_archs()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/eval-bg.R
\name{r_bg}
\alias{r_bg}
\title{Evaluate an expression in another R session, in the background}
\usage{
r_bg(
  func,
  args = list(),
  libpath = .libPaths(),
  repos = default_repos(),
  stdout = "|",
  stderr = "|",
  poll_connection = TRUE,
  error = getOption("callr.error", "error"),
  cmdargs = c("--slave", "--no-save", "--no-restore"),
  system_profile = FALSE,
  user_profile = "project",
  env = rcmd_safe_env(),
  supervise = FALSE,
  package = NULL,
  arch = "same",
  ...
)
}
\arguments{
\item{func}{Function object to call in the new R process.
The function should be self-contained and only refer to
other functions and use variables explicitly from other packages
using the \code{::} notation. By default the environment of the function
is set to \code{.GlobalEnv} before passing it to the child process.
(See the \code{package} option if you want to keep the environment.)
Because of this, it is good practice to create an anonymous
function and pass that to \code{callr}, instead of passing
a function object from a (base or other) package. In particular

\if{html}{\out{<div class="sourceCode">}}\preformatted{r(.libPaths)
}\if{html}{\out{</div>}}

does not work, because \code{.libPaths} is defined in a special
environment, but

\if{html}{\out{<div class="sourceCode">}}\preformatted{r(function() .libPaths())
}\if{html}{\out{</div>}}

works just fine.}

\item{args}{Arguments to pass to the function. Must be a list.}

\item{libpath}{The library path. If \code{NULL}, then the library path
is not modified at all in the subprocess. This is useful for
subprocesses that should use the library path of a fresh R session,
e.g. as set up by a project \code{.Rprofile}.}

\item{repos}{The \code{repos} option. If \code{NULL}, then no
\code{repos} option is set. This options is only used if
\code{user_profile} or \code{system_profile} is set \code{FALSE},
as it is set using the system or the user profile.}

\item{stdout}{The name of the file the standard output of
the child R process will be written to.
If the child process runs with the \code{--slave} option (the default),
then the commands are not echoed and will not be shown
in the standard output. Also note that you need to call \code{print()}
explicitly to show the output of the command(s).
IF \code{NULL}, then standard output is not returned, but
it is recorded and included in the error object if an error happens.
Various special values for this argument such as \code{"|"} are explained
in the \code{stdout} argument of \link[processx:process]{processx::process}.}

\item{stderr}{The name of the file the standard error of
the child R process will be written to.
In particular \code{message()} sends output to the standard
error. If nothing was sent to the standard error, then this file
will be empty. This argument can be the same file as \code{stdout},
in which case they will be correctly interleaved. If this is the
string \code{"2>&1"}, then standard error is redirected to standard output.
IF \code{NULL}, then standard output is not returned, but
it is recorded and included in the error object if an error happens.
Various special values for this argument such as \code{"|"} are explained
in the \code{stdout} argument of \link[processx:process]{processx::process}.}

\item{poll_connection}{Whether to have a control connection to
the process. This is used to transmit messages from the subprocess
to the main process.}

\item{error}{What to do if the remote process throws an error.
See details below.}

\item{cmdargs}{Command line arguments to pass to the R process.
Note that \code{c("-f", rscript)} is appended to this, \code{rscript}
is the name of the script file to run. This contains a call to the
supplied function and some error handling code.}

\item{system_profile}{Whether to use the system profile file.}

\item{user_profile}{Whether to use the user's profile file.
If this is \code{"project"}, then only the profile from the working
directory is used, but the \code{R_PROFILE_USER} environment variable
and the user level profile are not. See also "Security considerations"
below.}

\item{env}{Environment variables to set for the child process.}

\item{supervise}{Whether to register the process with a supervisor. If \code{TRUE},
the supervisor will ensure that the process is killed when the R process
exits.}

\item{package}{Whether to keep the environment of \code{func} when passing
it to the other package. Possible values are:
\itemize{
\item \code{NULL} (the default): equivalent to \code{TRUE} if \code{func} inherits from
\code{"crate"} (i.e. was created with \code{carrier::crate()}), and \code{FALSE}
otherwise.
\item \code{FALSE}: reset the environment to \code{.GlobalEnv}.
\item \code{TRUE}: keep the environment as is.
\item \code{pkg}: set the environment to the \code{pkg} package namespace.
}}

\item{arch}{Architecture to use in the child process, for multi-arch
builds of R. By default the same as the main process. See
\code{\link[=supported_archs]{supported_archs()}}. If it contains a forward or backward slash
character, then it is taken as the path to the R executable.
Note that on Windows you need the path to \code{Rterm.exe}.}

\item{...}{Extra arguments are passed to the \link[processx:process]{processx::process}
constructor.}
}
\value{
An \code{r_process} object, which inherits from \link{process},
so all \code{process} methods can be called on it, and in addition it also
has a \code{get_result()} method to collect the result.
}
\description{
Starts evaluating an R function call in a background R process, and
returns immediately.
Use \code{p$get_result()} to collect the result or to throw an error
if the background computation failed.
}
\section{Draining standard output and error}{
With the default \code{stdout = "|"} and \code{stderr = "|"}, the child process
writes its output and error streams into OS pipes with a small fixed
buffer (typically 64 KB or less). If nothing drains these pipes, a
chatty child fills the buffer and then blocks on the next \code{write()}.
The child will not
terminate until the parent reads from the pipes, so \code{p$is_alive()} will
keep returning \code{TRUE} even though the work appears to be done.

To avoid this:
\itemize{
\item Pass a filename to \code{stdout} / \code{stderr} to redirect output to files, or
\item pass \code{NULL} to discard it, or
\item periodically call \code{p$read_output()} and \code{p$read_error()} (or
\code{p$read_all_output()} etc.) to drain the pipes while the process is
running.
}
}

\section{Security considerations}{


\code{callr} makes a copy of the user's \code{.Renviron} file and potentially of
the local or user \code{.Rprofile}, in the session temporary
directory. Avoid storing sensitive information such as passwords, in
your environment file or your profile, otherwise this information will
get scattered in various files, at least temporarily, until the
subprocess finishes. You can use the keyring package to avoid passwords
in plain files.
}

\examples{
\dontshow{if (FALSE) withAutoprint(\{ # examplesIf}
rx <- r_bg(function() 1 + 2)

# wait until it is done
rx$wait()
rx$is_alive()
rx$get_result()
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rscript.R
\name{rscript}
\alias{rscript}
\title{Run an R script}
\usage{
rscript(
  script,
  cmdargs = character(),
  libpath = .libPaths(),
  repos = default_repos(),
  stdout = NULL,
  stderr = NULL,
  poll_connection = TRUE,
  echo = FALSE,
  show = TRUE,
  callback = NULL,
  block_callback = NULL,
  spinner = FALSE,
  system_profile = FALSE,
  user_profile = "project",
  env = rcmd_safe_env(),
  timeout = Inf,
  wd = ".",
  fail_on_status = TRUE,
  color = TRUE,
  ...
)
}
\arguments{
\item{script}{Path of the script to run.}

\item{cmdargs}{Command line arguments.}

\item{libpath}{The library path. If \code{NULL}, then the library path
is not modified at all in the subprocess. This is useful for
subprocesses that should use the library path of a fresh R session,
e.g. as set up by a project \code{.Rprofile}.}

\item{repos}{The \code{repos} option. If \code{NULL}, then no
\code{repos} option is set. This options is only used if
\code{user_profile} or \code{system_profile} is set \code{FALSE},
as it is set using the system or the user profile.}

\item{stdout}{Optionally a file name to send the standard output to.}

\item{stderr}{Optionally a file name to send the standard error to.
It may be the same as \code{stdout}, in which case standard error is
redirected to standard output. It can also be the special string
\code{"2>&1"}, in which case standard error will be redirected to standard
output.}

\item{poll_connection}{Whether to have a control connection to
the process. This is used to transmit messages from the subprocess
to the parent.}

\item{echo}{Whether to echo the complete command run by \code{rcmd}.}

\item{show}{Logical, whether to show the standard output on the screen
while the child process is running. Note that this is independent
of the \code{stdout} and \code{stderr} arguments. The standard
error is not shown currently.}

\item{callback}{A function to call for each line of the standard
output and standard error from the child process. It works together
with the \code{show} option; i.e. if \code{show = TRUE}, and a
callback is provided, then the output is shown of the screen, and the
callback is also called.}

\item{block_callback}{A function to call for each block of the standard
output and standard error. This callback is not line oriented, i.e.
multiple lines or half a line can be passed to the callback.}

\item{spinner}{Whether to show a calming spinner on the screen while
the child R session is running. By default it is shown if
\code{show = TRUE} and the R session is interactive.}

\item{system_profile}{Whether to use the system profile file.}

\item{user_profile}{Whether to use the user's profile file.
If this is \code{"project"}, then only the profile from the working
directory is used, but the \code{R_PROFILE_USER} environment variable
and the user level profile are not. See also "Security considerations"
below.}

\item{env}{Environment variables to set for the child process.}

\item{timeout}{Timeout for the function call to finish. It can be a
\link[base:difftime]{base::difftime} object, or a real number, meaning seconds.
If the process does not finish before the timeout period expires,
then a \code{system_command_timeout_error} error is thrown. \code{Inf}
means no timeout.}

\item{wd}{Working directory to use for running the command. Defaults
to the current working directory.}

\item{fail_on_status}{Whether to throw an R error if the command returns
with a non-zero status code. By default no error is thrown.}

\item{color}{Whether to use terminal colors in the child process,
assuming they are active in the parent process.}

\item{...}{Extra arguments are passed to \code{\link[processx:run]{processx::run()}}.}
}
\description{
It uses the \code{Rscript} program corresponding to the current R version,
to run the script. It streams \code{stdout} and \code{stderr} of the process.
}
\section{Security considerations}{


\code{callr} makes a copy of the user's \code{.Renviron} file and potentially of
the local or user \code{.Rprofile}, in the session temporary
directory. Avoid storing sensitive information such as passwords, in
your environment file or your profile, otherwise this information will
get scattered in various files, at least temporarily, until the
subprocess finishes. You can use the keyring package to avoid passwords
in plain files.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/r-process.R
\name{r_process}
\alias{r_process}
\title{External R Process}
\description{
An R process that runs in the background. This is an R6 class that
extends the \link[processx:process]{processx::process} class. The process starts in the
background, evaluates an R function call, and then quits.
}
\examples{
\dontshow{if (FALSE) withAutoprint(\{ # examplesIf}
## List all options and their default values:
r_process_options()

## Start an R process in the background, wait for it, get result
opts <- r_process_options(func = function() 1 + 1)
rp <- r_process$new(opts)
rp$wait()
rp$get_result()
\dontshow{\}) # examplesIf}
}
\section{Super class}{
\code{\link[processx:process]{processx::process}} -> \code{r_process}
}
\section{Methods}{
\subsection{Public methods}{
  \itemize{
    \item \href{#method-r_process-initialize}{\code{r_process$new()}}
    \item \href{#method-r_process-get_result}{\code{r_process$get_result()}}
    \item \href{#method-r_process-cleanup}{\code{r_process$cleanup()}}
    \item \href{#method-r_process-finalize}{\code{r_process$finalize()}}
    \item \href{#method-r_process-clone}{\code{r_process$clone()}}
  }
}
\if{html}{\out{<details><summary>Inherited methods</summary>
<ul>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="as_ps_handle"><a href='../../processx/html/process.html#method-process-as_ps_handle'><code>processx::process$as_ps_handle()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="format"><a href='../../processx/html/process.html#method-process-format'><code>processx::process$format()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_cmdline"><a href='../../processx/html/process.html#method-process-get_cmdline'><code>processx::process$get_cmdline()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_cpu_times"><a href='../../processx/html/process.html#method-process-get_cpu_times'><code>processx::process$get_cpu_times()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_end_time"><a href='../../processx/html/process.html#method-process-get_end_time'><code>processx::process$get_end_time()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_error_connection"><a href='../../processx/html/process.html#method-process-get_error_connection'><code>processx::process$get_error_connection()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_error_file"><a href='../../processx/html/process.html#method-process-get_error_file'><code>processx::process$get_error_file()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_exe"><a href='../../processx/html/process.html#method-process-get_exe'><code>processx::process$get_exe()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_exit_status"><a href='../../processx/html/process.html#method-process-get_exit_status'><code>processx::process$get_exit_status()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_input_connection"><a href='../../processx/html/process.html#method-process-get_input_connection'><code>processx::process$get_input_connection()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_input_file"><a href='../../processx/html/process.html#method-process-get_input_file'><code>processx::process$get_input_file()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_memory_info"><a href='../../processx/html/process.html#method-process-get_memory_info'><code>processx::process$get_memory_info()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_name"><a href='../../processx/html/process.html#method-process-get_name'><code>processx::process$get_name()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_output_connection"><a href='../../processx/html/process.html#method-process-get_output_connection'><code>processx::process$get_output_connection()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_output_file"><a href='../../processx/html/process.html#method-process-get_output_file'><code>processx::process$get_output_file()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_pid"><a href='../../processx/html/process.html#method-process-get_pid'><code>processx::process$get_pid()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_poll_connection"><a href='../../processx/html/process.html#method-process-get_poll_connection'><code>processx::process$get_poll_connection()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_start_time"><a href='../../processx/html/process.html#method-process-get_start_time'><code>processx::process$get_start_time()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_status"><a href='../../processx/html/process.html#method-process-get_status'><code>processx::process$get_status()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_username"><a href='../../processx/html/process.html#method-process-get_username'><code>processx::process$get_username()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="get_wd"><a href='../../processx/html/process.html#method-process-get_wd'><code>processx::process$get_wd()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="has_error_connection"><a href='../../processx/html/process.html#method-process-has_error_connection'><code>processx::process$has_error_connection()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="has_input_connection"><a href='../../processx/html/process.html#method-process-has_input_connection'><code>processx::process$has_input_connection()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="has_output_connection"><a href='../../processx/html/process.html#method-process-has_output_connection'><code>processx::process$has_output_connection()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="has_poll_connection"><a href='../../processx/html/process.html#method-process-has_poll_connection'><code>processx::process$has_poll_connection()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="interrupt"><a href='../../processx/html/process.html#method-process-interrupt'><code>processx::process$interrupt()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="is_alive"><a href='../../processx/html/process.html#method-process-is_alive'><code>processx::process$is_alive()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="is_incomplete_error"><a href='../../processx/html/process.html#method-process-is_incomplete_error'><code>processx::process$is_incomplete_error()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="is_incomplete_output"><a href='../../processx/html/process.html#method-process-is_incomplete_output'><code>processx::process$is_incomplete_output()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="is_supervised"><a href='../../processx/html/process.html#method-process-is_supervised'><code>processx::process$is_supervised()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="kill"><a href='../../processx/html/process.html#method-process-kill'><code>processx::process$kill()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="kill_tree"><a href='../../processx/html/process.html#method-process-kill_tree'><code>processx::process$kill_tree()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="poll_io"><a href='../../processx/html/process.html#method-process-poll_io'><code>processx::process$poll_io()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="print"><a href='../../processx/html/process.html#method-process-print'><code>processx::process$print()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="read_all_error"><a href='../../processx/html/process.html#method-process-read_all_error'><code>processx::process$read_all_error()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="read_all_error_lines"><a href='../../processx/html/process.html#method-process-read_all_error_lines'><code>processx::process$read_all_error_lines()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="read_all_output"><a href='../../processx/html/process.html#method-process-read_all_output'><code>processx::process$read_all_output()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="read_all_output_lines"><a href='../../processx/html/process.html#method-process-read_all_output_lines'><code>processx::process$read_all_output_lines()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="read_error"><a href='../../processx/html/process.html#method-process-read_error'><code>processx::process$read_error()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="read_error_bytes"><a href='../../processx/html/process.html#method-process-read_error_bytes'><code>processx::process$read_error_bytes()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="read_error_lines"><a href='../../processx/html/process.html#method-process-read_error_lines'><code>processx::process$read_error_lines()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="read_output"><a href='../../processx/html/process.html#method-process-read_output'><code>processx::process$read_output()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="read_output_bytes"><a href='../../processx/html/process.html#method-process-read_output_bytes'><code>processx::process$read_output_bytes()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="read_output_lines"><a href='../../processx/html/process.html#method-process-read_output_lines'><code>processx::process$read_output_lines()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="resume"><a href='../../processx/html/process.html#method-process-resume'><code>processx::process$resume()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="signal"><a href='../../processx/html/process.html#method-process-signal'><code>processx::process$signal()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="supervise"><a href='../../processx/html/process.html#method-process-supervise'><code>processx::process$supervise()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="suspend"><a href='../../processx/html/process.html#method-process-suspend'><code>processx::process$suspend()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="wait"><a href='../../processx/html/process.html#method-process-wait'><code>processx::process$wait()</code></a></span></li>
  <li><span class="pkg-link" data-pkg="processx" data-topic="process" data-id="write_input"><a href='../../processx/html/process.html#method-process-write_input'><code>processx::process$write_input()</code></a></span></li>
</ul>
</details>}}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-r_process-initialize"></a>}}
\if{latex}{\out{\hypertarget{method-r_process-initialize}{}}}
\subsection{\code{r_process$new()}}{
  Start a new R process in the background.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{r_process$new(options)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{options}}{A list of options created via \code{\link[=r_process_options]{r_process_options()}}.}
    }
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    A new \code{r_process} object.
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-r_process-get_result"></a>}}
\if{latex}{\out{\hypertarget{method-r_process-get_result}{}}}
\subsection{\code{r_process$get_result()}}{
  Return the result, an R object, from a finished
background R process. If the process has not finished yet, it throws
an error. (You can use \code{wait()} method (see \link[processx:process]{processx::process}) to
wait for the process to finish, optionally with a timeout.) You can
also use \code{\link[processx:poll]{processx::poll()}} to wait for the end of the process,
together with other processes or events.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{r_process$get_result()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The return value of the R expression evaluated in the R
process.
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-r_process-cleanup"></a>}}
\if{latex}{\out{\hypertarget{method-r_process-cleanup}{}}}
\subsection{\code{r_process$cleanup()}}{
  Delete the temporary files created for this R process.
Only call this if you are sure that the process is done and you
don't need the result anymore. If you don't call this method
explicitly, the temporary files will be deleted when the process
object is garbage collected.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{r_process$cleanup()}
    \if{html}{\out{</div>}}
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-r_process-finalize"></a>}}
\if{latex}{\out{\hypertarget{method-r_process-finalize}{}}}
\subsection{\code{r_process$finalize()}}{
  Clean up temporary files once an R process has finished and its
handle is garbage collected.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{r_process$finalize()}
    \if{html}{\out{</div>}}
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-r_process-clone"></a>}}
\if{latex}{\out{\hypertarget{method-r_process-clone}{}}}
\subsection{\code{r_process$clone()}}{
  The objects of this class are cloneable with this method.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{r_process$clone(deep = FALSE)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{deep}}{Whether to make a deep clone.}
    }
    \if{html}{\out{</div>}}
  }
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{default_repos}
\alias{default_repos}
\title{Default value for the \code{repos} option in callr subprocesses}
\usage{
default_repos()
}
\value{
Named character vector, the default value of the \code{repos}
option in callr subprocesses.
}
\description{
callr sets the \code{repos} option in subprocesses, to make sure that
a CRAN mirror is set up. This is because the subprocess cannot bring
up the menu of CRAN mirrors for the user to choose from.
}
\examples{
default_repos()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rcmd.R
\name{rcmd_copycat}
\alias{rcmd_copycat}
\title{Call and \verb{R CMD} command, while mimicking the current R session}
\usage{
rcmd_copycat(
  cmd,
  cmdargs = character(),
  libpath = .libPaths(),
  repos = getOption("repos"),
  env = character(),
  ...
)
}
\arguments{
\item{cmd}{Command to run. See \code{R --help} from the command
line for the various commands. In the current version of R (3.2.4)
these are: \code{BATCH}, \code{COMPILE}, \code{SHLIB}, \code{INSTALL}, \code{REMOVE}, \code{build},
\code{check}, \code{LINK}, \code{Rprof}, \code{Rdconv}, \code{Rd2pdf}, \code{Rd2txt}, \code{Stangle},
\code{Sweave}, \code{Rdiff}, \code{config}, \code{javareconf}, \code{rtags}.}

\item{cmdargs}{Command line arguments.}

\item{libpath}{The library path. If \code{NULL}, then the library path
is not modified at all in the subprocess. This is useful for
subprocesses that should use the library path of a fresh R session,
e.g. as set up by a project \code{.Rprofile}.}

\item{repos}{The \code{repos} option. If \code{NULL}, then no
\code{repos} option is set. This options is only used if
\code{user_profile} or \code{system_profile} is set \code{FALSE},
as it is set using the system or the user profile.}

\item{env}{Environment variables to set for the child process.}

\item{...}{Additional arguments are passed to \code{\link[=rcmd]{rcmd()}}.}
}
\description{
This function is similar to \code{\link[=rcmd]{rcmd()}}, but it has slightly different
defaults:
\itemize{
\item The \code{repos} options is unchanged.
\item No extra environment variables are defined.
}
}
\section{Security considerations}{


\code{callr} makes a copy of the user's \code{.Renviron} file and potentially of
the local or user \code{.Rprofile}, in the session temporary
directory. Avoid storing sensitive information such as passwords, in
your environment file or your profile, otherwise this information will
get scattered in various files, at least temporarily, until the
subprocess finishes. You can use the keyring package to avoid passwords
in plain files.
}

\seealso{
Other R CMD commands:
\code{\link[=rcmd]{rcmd()}},
\code{\link[=rcmd_bg]{rcmd_bg()}}
}
\concept{R CMD commands}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hook.R
\name{add_hook}
\alias{add_hook}
\title{Add a user hook to be executed before launching an R subprocess}
\usage{
add_hook(...)
}
\arguments{
\item{...}{Named argument specifying a hook function to add, or \code{NULL} to
delete the named hook.}
}
\value{
\code{add_hook} is called for its side-effects.
}
\description{
This function allows users of \code{callr} to specify functions that get invoked
whenever an R session is launched. The function can modify the environment
variables and command line arguments.
}
\details{
The prototype of the hook function is \verb{function (options)}, and it is
expected to return the modified \code{options}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/callr-package.R
\docType{package}
\name{callr-package}
\alias{callr}
\alias{callr-package}
\title{Call R from R}
\description{
It is sometimes useful to perform a computation in a separate
R process, without affecting the current R process at all.  This
packages does exactly that.
}
\section{callr}{
\subsection{Features}{
\itemize{
\item Calls an R function, with arguments, in a subprocess.
\item Copies function arguments to the subprocess and copies the return value of the function back, seamlessly.
\item Copies error objects back from the subprocess, including a stack trace.
\item Shows and/or collects the standard output and standard error of the subprocess.
\item Supports both one-off and persistent R subprocesses.
\item Calls the function synchronously or asynchronously (in the background).
\item Can call \verb{R CMD} commands, synchronously or asynchronously.
\item Can call R scripts, synchronously or asynchronously.
\item Provides extensible \code{r_process}, \code{rcmd_process} and \code{rscript_process} R6 classes, based on \code{processx::process}.
\item Emits \href{https://opentelemetry.io/}{OpenTelemetry} traces for every R subprocess and propagates trace context across the process boundary.
}
}

\subsection{Installation}{

Install the stable version from CRAN:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{install.packages("callr")
}\if{html}{\out{</div>}}

Install the development version from GitHub:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{pak::pak("r-lib/callr")
}\if{html}{\out{</div>}}
}

\subsection{Synchronous, one-off R processes}{

Use \code{r()} to run an R function in a new R process.
The results are passed back seamlessly:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{callr::r(function() var(iris[, 1:4]))
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#>              Sepal.Length Sepal.Width Petal.Length Petal.Width                  
#> Sepal.Length    0.6856935  -0.0424340    1.2743154   0.5162707                  
#> Sepal.Width    -0.0424340   0.1899794   -0.3296564  -0.1216394                  
#> Petal.Length    1.2743154  -0.3296564    3.1162779   1.2956094                  
#> Petal.Width     0.5162707  -0.1216394    1.2956094   0.5810063                  
</pre></div>
}}

\subsection{Passing arguments}{

You can pass arguments to the function by setting \code{args} to the list of arguments.
This is often necessary as these arguments are explicitly copied to the child process, whereas the evaluated function cannot refer to variables in the parent.
For example, the following does not work:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{mycars <- cars
callr::r(function() summary(mycars))
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> Error:                                                                          
#> ! in callr subprocess.                                                          
#> Caused by error in `(function () ...`:                                          
#> ! object 'mycars' not found                                                     
#> Type .Last.error to see the more details.                                       
</pre></div>
}}


But this does:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{mycars <- cars
callr::r(function(x) summary(x), args = list(mycars))
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#>      speed           dist                                                       
#>  Min.   : 4.0   Min.   :  2.00                                                  
#>  1st Qu.:12.0   1st Qu.: 26.00                                                  
#>  Median :15.0   Median : 36.00                                                  
#>  Mean   :15.4   Mean   : 42.98                                                  
#>  3rd Qu.:19.0   3rd Qu.: 56.00                                                  
#>  Max.   :25.0   Max.   :120.00                                                  
</pre></div>
}}


Note that the arguments will be serialized and saved to a file, so if they are large R objects, it might take a long time for the child process to start up.
}

\subsection{Using packages}{

You can use any R package in the child process, just make sure to refer to it explicitly with the \code{::} operator.
For example, the following code creates an \href{https://github.com/igraph/rigraph}{igraph} graph in the child, and calculates some metrics of it.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{callr::r(function() \{ g <- igraph::sample_gnp(1000, 4/1000); igraph::diameter(g) \})
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> [1] 11                                                                          
</pre></div>
}}

}

\subsection{Error handling}{

callr copies errors from the child process back to the main R session:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{callr::r(function() 1 + "A")
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> Error:                                                                          
#> ! in callr subprocess.                                                          
#> Caused by error in `1 + "A"`:                                                   
#> ! non-numeric argument to binary operator                                       
#> Type .Last.error to see the more details.                                       
</pre></div>
callr sets the `.Last.error` variable, and after an error you can inspect this for more details about the error, including stack traces both from the main R process and the subprocess.
}}


\if{html}{\out{<div class="sourceCode r">}}\preformatted{.Last.error
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> Error:                                                                          
#> ! in callr subprocess.                                                          
#> Caused by error in `1 + "A"`:                                                   
#> ! non-numeric argument to binary operator                                       
#> ---                                                                             
#> Backtrace:                                                                      
#> 1. callr::r(function() 1 + "A")                                                 
#> 2. callr:::get_result(output = out, options)                                    
#> 3. callr:::throw(callr_remote_error(remerr, output), parent = fix_msg(remerr[[3]
#> ]))                                                                             
#> ---                                                                             
#> Subprocess backtrace:                                                           
#> 1. base::.handleSimpleError(function (e)                                        
#> 2. global h(simpleError(msg, call))                                             
</pre></div>
}}


The error objects has two parts.
The first belongs to the main process, and the second belongs to the subprocess.

\code{.Last.error} also includes a stack trace, that includes both the main R process and the subprocess:

The top part of the trace contains the frames in the main process, and the bottom part contains the frames in the subprocess, starting with the anonymous function.
}

\subsection{Standard output and error}{

By default, the standard output and error of the child is lost, but you can request callr to redirect them to files, and then inspect the files in the parent:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{x <- callr::r(function() \{ print("hello world!"); message("hello again!") \},
  stdout = "/tmp/out", stderr = "/tmp/err"
)
readLines("/tmp/out")
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> [1] "[1] \\"hello world!\\""                                                      
</pre></div>
}}


\if{html}{\out{<div class="sourceCode r">}}\preformatted{readLines("/tmp/err")
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> [1] "hello again!"                                                              
</pre></div>
}}


With the \code{stdout} option, the standard output is collected and can be examined once the child process finished.
The \code{show = TRUE} options will also show the output of the child, as it is printed, on the console of the parent.
}

}

\subsection{Background R processes}{

\code{r_bg()} is similar to \code{r()} but it starts the R process in the background.
It returns an \code{r_process} R6 object, that provides a rich API:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{rp <- callr::r_bg(function() Sys.sleep(.2))
rp
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> PROCESS 'R', running, pid 93508.                                                
</pre></div>
}}


This is a list of all \code{r_process} methods:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{ls(rp)
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#>  [1] "as_ps_handle"          "clone"                 "finalize"                 
#>  [4] "format"                "get_cmdline"           "get_cpu_times"            
#>  [7] "get_error_connection"  "get_error_file"        "get_exe"                  
#> [10] "get_exit_status"       "get_input_connection"  "get_input_file"           
#> [13] "get_memory_info"       "get_name"              "get_output_connection"    
#> [16] "get_output_file"       "get_pid"               "get_poll_connection"      
#> [19] "get_result"            "get_start_time"        "get_status"               
#> [22] "get_username"          "get_wd"                "has_error_connection"     
#> [25] "has_input_connection"  "has_output_connection" "has_poll_connection"      
#> [28] "initialize"            "interrupt"             "is_alive"                 
#> [31] "is_incomplete_error"   "is_incomplete_output"  "is_supervised"            
#> [34] "kill"                  "kill_tree"             "poll_io"                  
#> [37] "print"                 "read_all_error"        "read_all_error_lines"     
#> [40] "read_all_output"       "read_all_output_lines" "read_error"               
#> [43] "read_error_lines"      "read_output"           "read_output_lines"        
#> [46] "resume"                "signal"                "supervise"                
#> [49] "suspend"               "wait"                  "write_input"              
</pre></div>
}}


These include all methods of the \code{processx::process} superclass and the new \code{get_result()} method, to retrieve the R object returned by the function call.
Some of the handiest methods are:
\itemize{
\item \code{get_exit_status()} to query the exit status of a finished process.
\item \code{get_result()} to collect the return value of the R function call.
\item \code{interrupt()} to send an interrupt to the process. This is equivalent to a \code{CTRL+C} key press, and the R process might ignore it.
\item \code{is_alive()} to check if the process is alive.
\item \code{kill()} to terminate the process.
\item \code{poll_io()} to wait for any standard output, standard error, or the completion of the process, with a timeout.
\item \verb{read_*()} to read the standard output or error.
\item \code{suspend()} and \code{resume()} to stop and continue a process.
\item \code{wait()} to wait for the completion of the process, with a timeout.
}
}

\subsection{Multiple background R processes and \code{poll()}}{

Multiple background R processes are best managed with the \code{processx::poll()} function that waits for events (standard output/error or termination) from multiple processes.
It returns as soon as one process has generated an event, or if its timeout has expired.
The timeout is in milliseconds.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{rp1 <- callr::r_bg(function() \{ Sys.sleep(1/2); "1 done" \})
rp2 <- callr::r_bg(function() \{ Sys.sleep(1/1000); "2 done" \})
processx::poll(list(rp1, rp2), 1000)
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> [[1]]                                                                           
#>   output    error  process                                                      
#> "silent" "silent" "silent"                                                      
#>                                                                                 
#> [[2]]                                                                           
#>  output   error process                                                         
#> "ready" "ready" "ready"                                                         
#>                                                                                 
</pre></div>
}}


\if{html}{\out{<div class="sourceCode r">}}\preformatted{rp2$get_result()
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> [1] "2 done"                                                                    
</pre></div>
}}


\if{html}{\out{<div class="sourceCode r">}}\preformatted{processx::poll(list(rp1), 1000)
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> [[1]]                                                                           
#>  output   error process                                                         
#> "ready" "ready" "ready"                                                         
#>                                                                                 
</pre></div>
}}


\if{html}{\out{<div class="sourceCode r">}}\preformatted{rp1$get_result()
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> [1] "1 done"                                                                    
</pre></div>
}}

}

\subsection{Persistent R sessions}{

\code{r_session} is another \code{processx::process} subclass that represents a persistent background R session:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{rs <- callr::r_session$new()
rs
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> R SESSION, alive, idle, pid 93547.                                              
</pre></div>
}}


\code{r_session$run()} is a synchronous call, that works similarly to \code{r()}, but uses the persistent session.
\code{r_session$call()} starts the function call and returns immediately.
The \code{r_session$poll_process()} method or \code{processx::poll()} can then be used to wait for the completion or other events from one or more R sessions, R processes or other \code{processx::process} objects.

Once an R session is done with an asynchronous computation, its \code{poll_process()} method returns \code{"ready"} and the \code{r_session$read()} method can read out the result.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{rs <- callr::r_session$new()
rs$run(function() runif(10))
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#>  [1] 0.9610059 0.1697476 0.4644942 0.7274561 0.5235966 0.2661597 0.6214701      
#>  [8] 0.9156920 0.5577677 0.8844519                                              
</pre></div>
}}


\if{html}{\out{<div class="sourceCode r">}}\preformatted{rs$call(function() rnorm(10))
rs
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> R SESSION, alive, busy, pid 93551.                                              
</pre></div>
}}


\if{html}{\out{<div class="sourceCode r">}}\preformatted{rs$poll_process(2000)
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> [1] "ready"                                                                     
</pre></div>
}}


\if{html}{\out{<div class="sourceCode r">}}\preformatted{rs$read()
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> $code                                                                           
#> [1] 200                                                                         
#>                                                                                 
#> $message                                                                        
#> [1] "done callr-rs-result-16cf57f352725"                                        
#>                                                                                 
#> $result                                                                         
#>  [1]  0.6357407  0.3347589  1.1821022  1.1821849  1.8102056 -0.6755208          
#>  [7] -0.7085879  1.3591706  0.8677449 -0.5669537                                
#>                                                                                 
#> $stdout                                                                         
#> [1] ""                                                                          
#>                                                                                 
#> $stderr                                                                         
#> [1] ""                                                                          
#>                                                                                 
#> $error                                                                          
#> NULL                                                                            
#>                                                                                 
#> attr(,"class")                                                                  
#> [1] "callr_session_result"                                                      
</pre></div>
}}

}

\subsection{Running \verb{R CMD} commands}{

The \code{rcmd()} function calls an \verb{R CMD} command.
For example, you can call \verb{R CMD INSTALL}, \verb{R CMD check} or \verb{R CMD config} this way:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{callr::rcmd("config", "CC")
}\if{html}{\out{</div>}}\if{html}{\out{
<div class="asciicast" style="color: #B9C0CB;font-family: 'Fira Code',Monaco,Consolas,Menlo,'Bitstream Vera Sans Mono','Powerline Symbols',monospace;line-height: 1.300000"><pre>
#> $status                                                                         
#> [1] 0                                                                           
#>                                                                                 
#> $stdout                                                                         
#> [1] "clang -arch arm64 -std=gnu2x\\n"                                            
#>                                                                                 
#> $stderr                                                                         
#> [1] ""                                                                          
#>                                                                                 
#> $timeout                                                                        
#> [1] FALSE                                                                       
#>                                                                                 
#> $command                                                                        
#> [1] "/Library/Frameworks/R.framework/Versions/4.5-arm64/Resources/bin/R"        
#> [2] "CMD"                                                                       
#> [3] "config"                                                                    
#> [4] "CC"                                                                        
#>                                                                                 
</pre></div>
}}


This returns a list with three components: the standard output, the standard error, and the exit (status) code of the \verb{R CMD} command.
}

\subsection{Observability}{

callr is instrumented with \href{https://opentelemetry.io/}{OpenTelemetry}.
When an OpenTelemetry SDK (such as \href{https://otelsdk.r-lib.org}{otelsdk}) is loaded and configured, callr emits spans for every R subprocess it starts and propagates the W3C \code{traceparent} header into the subprocess, so spans created inside the child become children of the parent span.
No code changes are needed in callr-using code — the existing entry points start emitting telemetry as soon as an SDK is configured.

See \code{vignette("opentelemetry", package = "callr")} for what callr emits, how subprocess context propagation works, and how to test your own instrumentation on top of it.
}

\subsection{Configuration}{
\subsection{Environment variables}{
\itemize{
\item \code{CALLR_NO_TEMP_DLLS}: If \code{true}, then callr does not use a temporary
directory to copy the client DLL files from, in the subprocess. By
default callr copies the DLL file that drives the callr subprocess into
a temporary directory and loads it from there. This is mainly to avoid
locking a DLL file in the package library, on Windows. If this default
causes issues for you, set it to \code{true}, and then callr will use the DLL
file from the installed processx package. See also
https://github.com/r-lib/callr/issues/273.
\item \code{CALLR_TMPDIR}: If set to a non-empty path, callr writes its auxiliary
temporary files into this directory instead of the session's \code{tempdir()}.
The directory is created if it does not exist. The value is read on each
use, so it can be changed at run time via \code{Sys.setenv()}. Note that paths
cached at package load time (the package's own \verb{callr-env-} file and the
client DLL location) only honor this setting if the variable was set
before \code{callr} was loaded, typically by exporting it in the shell or via
\code{.Renviron}. See also https://github.com/r-lib/callr/issues/172.
}
}

}

\subsection{Code of Conduct}{

Please note that the callr project is released with a
\href{https://callr.r-lib.org/CODE_OF_CONDUCT.html}{Contributor Code of Conduct}.
By contributing to this project, you agree to abide by its terms.
}
}

\seealso{
Useful links:
\itemize{
  \item \url{https://callr.r-lib.org}
  \item \url{https://github.com/r-lib/callr}
  \item Report bugs at \url{https://github.com/r-lib/callr/issues}
}

}
\author{
\strong{Maintainer}: Gábor Csárdi \email{csardi.gabor@gmail.com} (\href{https://orcid.org/0000-0001-7098-9676}{ORCID}) [copyright holder]

Authors:
\itemize{
  \item Gábor Csárdi \email{csardi.gabor@gmail.com} (\href{https://orcid.org/0000-0001-7098-9676}{ORCID}) [copyright holder]
  \item Winston Chang
}

Other contributors:
\itemize{
  \item Posit Software, PBC (\href{https://ror.org/03wc8by49}{ROR}) [copyright holder, funder]
  \item Ascent Digital Services [copyright holder, funder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand % Please edit documentation in R/r-session.R \name{r_session} \alias{r_session} \title{External R Session} \description{ A permanent R session that runs in the background. This is an R6 class that extends the \link[processx:process]{processx::process} class. The process is started at the creation of the object, and then it can be used to evaluate R function calls, one at a time. } \examples{ \dontshow{if (FALSE) withAutoprint(\{ # examplesIf} rs <- r_session$new() rs$run(function() 1 + 2) rs$call(function() Sys.sleep(1)) rs$get_state() rs$poll_process(-1) rs$get_state() rs$read() \dontshow{\}) # examplesIf} } \section{Super class}{ \code{\link[processx:process]{processx::process}} -> \code{r_session} } \section{Public fields}{ \if{html}{\out{
}} \describe{ \item{\code{status}}{Status codes returned by \code{read()}.} } \if{html}{\out{
}} } \section{Methods}{ \subsection{Public methods}{ \itemize{ \item \href{#method-r_session-initialize}{\code{r_session$new()}} \item \href{#method-r_session-run}{\code{r_session$run()}} \item \href{#method-r_session-run_with_output}{\code{r_session$run_with_output()}} \item \href{#method-r_session-call}{\code{r_session$call()}} \item \href{#method-r_session-poll_process}{\code{r_session$poll_process()}} \item \href{#method-r_session-get_state}{\code{r_session$get_state()}} \item \href{#method-r_session-get_running_time}{\code{r_session$get_running_time()}} \item \href{#method-r_session-read}{\code{r_session$read()}} \item \href{#method-r_session-close}{\code{r_session$close()}} \item \href{#method-r_session-traceback}{\code{r_session$traceback()}} \item \href{#method-r_session-debug}{\code{r_session$debug()}} \item \href{#method-r_session-attach}{\code{r_session$attach()}} \item \href{#method-r_session-print}{\code{r_session$print()}} \item \href{#method-r_session-cleanup}{\code{r_session$cleanup()}} \item \href{#method-r_session-finalize}{\code{r_session$finalize()}} \item \href{#method-r_session-clone}{\code{r_session$clone()}} } } \if{html}{\out{
Inherited methods

- `processx::process$as_ps_handle()`
- `processx::process$format()`
- `processx::process$get_cmdline()`
- `processx::process$get_cpu_times()`
- `processx::process$get_end_time()`
- `processx::process$get_error_connection()`
- `processx::process$get_error_file()`
- `processx::process$get_exe()`
- `processx::process$get_exit_status()`
- `processx::process$get_input_connection()`
- `processx::process$get_input_file()`
- `processx::process$get_memory_info()`
- `processx::process$get_name()`
- `processx::process$get_output_connection()`
- `processx::process$get_output_file()`
- `processx::process$get_pid()`
- `processx::process$get_poll_connection()`
- `processx::process$get_result()`
- `processx::process$get_start_time()`
- `processx::process$get_status()`
- `processx::process$get_username()`
- `processx::process$get_wd()`
- `processx::process$has_error_connection()`
- `processx::process$has_input_connection()`
- `processx::process$has_output_connection()`
- `processx::process$has_poll_connection()`
- `processx::process$interrupt()`
- `processx::process$is_alive()`
- `processx::process$is_incomplete_error()`
- `processx::process$is_incomplete_output()`
- `processx::process$is_supervised()`
- `processx::process$kill()`
- `processx::process$kill_tree()`
- `processx::process$poll_io()`
- `processx::process$read_all_error()`
- `processx::process$read_all_error_lines()`
- `processx::process$read_all_output()`
- `processx::process$read_all_output_lines()`
- `processx::process$read_error()`
- `processx::process$read_error_bytes()`
- `processx::process$read_error_lines()`
- `processx::process$read_output()`
- `processx::process$read_output_bytes()`
- `processx::process$read_output_lines()`
- `processx::process$resume()`
- `processx::process$signal()`
- `processx::process$supervise()`
- `processx::process$suspend()`
- `processx::process$wait()`
- `processx::process$write_input()`

}} \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-initialize}{}}} \subsection{\code{r_session$new()}}{ creates a new R background process. It can wait for the process to start up (\code{wait = TRUE}), or return immediately, i.e. before the process is actually ready to run. In the latter case you may call the \code{poll_process()} method to make sure it is ready. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$new(options = r_session_options(), wait = TRUE, wait_timeout = 3000)} \if{html}{\out{
}} } \subsection{Arguments}{ \if{html}{\out{
}} \describe{ \item{\code{options}}{A list of options created via \code{\link[=r_session_options]{r_session_options()}}.} \item{\code{wait}}{Whether to wait for the R process to start and be ready for running commands.} \item{\code{wait_timeout}}{Timeout for waiting for the R process to start, in milliseconds.} } \if{html}{\out{
}} } \subsection{Returns}{ An \code{r_session} object. } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-run}{}}} \subsection{\code{r_session$run()}}{ Similar to \code{\link[=r]{r()}}, but runs the function in a permanent background R session. It throws an error if the function call generated an error in the child process. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$run(func, args = list(), package = NULL)} \if{html}{\out{
}} } \subsection{Arguments}{ \if{html}{\out{
}} \describe{ \item{\code{func}}{Function object to call in the background R process. Please read the notes for the similar argument of \code{\link[=r]{r()}}.} \item{\code{args}}{Arguments to pass to the function. Must be a list.} \item{\code{package}}{Whether to keep the environment of \code{func} when passing it to the other package. Possible values are: \itemize{ \item \code{NULL} (the default): equivalent to \code{TRUE} if \code{func} inherits from \code{"crate"} (i.e. was created with \code{carrier::crate()}), and \code{FALSE} otherwise. \item \code{FALSE}: reset the environment to \code{.GlobalEnv}. \item \code{TRUE}: keep the environment as is. \item \code{pkg}: set the environment to the \code{pkg} package namespace. }} } \if{html}{\out{
}} } \subsection{Returns}{ The return value of the R expression. } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-run_with_output}{}}} \subsection{\code{r_session$run_with_output()}}{ Similar to \verb{$run()}, but returns the standard output and error of the child process as well. It does not throw on errors, but returns a non-\code{NULL} \code{error} member in the result list. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$run_with_output(func, args = list(), package = NULL)} \if{html}{\out{
}} } \subsection{Arguments}{ \if{html}{\out{
}} \describe{ \item{\code{func}}{Function object to call in the background R process. Please read the notes for the similar argument of \code{\link[=r]{r()}}.} \item{\code{args}}{Arguments to pass to the function. Must be a list.} \item{\code{package}}{Whether to keep the environment of \code{func} when passing it to the other package. Possible values are: \itemize{ \item \code{NULL} (the default): equivalent to \code{TRUE} if \code{func} inherits from \code{"crate"} (i.e. was created with \code{carrier::crate()}), and \code{FALSE} otherwise. \item \code{FALSE}: reset the environment to \code{.GlobalEnv}. \item \code{TRUE}: keep the environment as is. \item \code{pkg}: set the environment to the \code{pkg} package namespace. }} } \if{html}{\out{
}} } \subsection{Returns}{ A list with the following entries. \itemize{ \item \code{result}: The value returned by \code{func}. On error this is \code{NULL}. \item \code{stdout}: The standard output of the process while evaluating \item \code{stderr}: The standard error of the process while evaluating the \code{func} call. \item \code{error}: On error it contains an error object, that contains the error thrown in the subprocess. Otherwise it is \code{NULL}. \item \code{code}, \code{message}: These fields are used by call internally and you can ignore them. } } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-call}{}}} \subsection{\code{r_session$call()}}{ Starts running a function in the background R session, and returns immediately. To check if the function is done, call the \code{poll_process()} method. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$call(func, args = list(), package = NULL)} \if{html}{\out{
}} } \subsection{Arguments}{ \if{html}{\out{
}} \describe{ \item{\code{func}}{Function object to call in the background R process. Please read the notes for the similar argument of \code{\link[=r]{r()}}.} \item{\code{args}}{Arguments to pass to the function. Must be a list.} \item{\code{package}}{Whether to keep the environment of \code{func} when passing it to the other package. Possible values are: \itemize{ \item \code{NULL} (the default): equivalent to \code{TRUE} if \code{func} inherits from \code{"crate"} (i.e. was created with \code{carrier::crate()}), and \code{FALSE} otherwise. \item \code{FALSE}: reset the environment to \code{.GlobalEnv}. \item \code{TRUE}: keep the environment as is. \item \code{pkg}: set the environment to the \code{pkg} package namespace. }} } \if{html}{\out{
}} } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-poll_process}{}}} \subsection{\code{r_session$poll_process()}}{ Poll the R session with a timeout. If the session has finished the computation, it returns with \code{"ready"}. If the timeout is reached, it returns with \code{"timeout"}. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$poll_process(timeout)} \if{html}{\out{
}} } \subsection{Arguments}{ \if{html}{\out{
}} \describe{ \item{\code{timeout}}{Timeout period in milliseconds.} } \if{html}{\out{
}} } \subsection{Returns}{ Character string \code{"ready"} or \code{"timeout"}. } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-get_state}{}}} \subsection{\code{r_session$get_state()}}{ Return the state of the R session. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$get_state()} \if{html}{\out{
}} } \subsection{Returns}{ Possible values: \itemize{ \item \code{"starting"}: starting up, \item \code{"idle"}: ready to compute, \item \code{"busy"}: computing right now, \item \code{"finished"}: the R process has finished. } } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-get_running_time}{}}} \subsection{\code{r_session$get_running_time()}}{ Returns the elapsed time since the R process has started, and the elapsed time since the current computation has started. The latter is \code{NA} if there is no active computation. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$get_running_time()} \if{html}{\out{
}} } \subsection{Returns}{ Named vector of \code{POSIXct} objects. The names are \code{"total"} and \code{"current"}. } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-read}{}}} \subsection{\code{r_session$read()}}{ Reads an event from the child process, if there is one available. Events might signal that the function call has finished, or they can be progress report events. This is a low level function that you only need to use if you want to process events (messages) from the R session manually. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$read()} \if{html}{\out{
}} } \subsection{Returns}{ \code{NULL} if no events are available. Otherwise a named list, which is also a \code{callr_session_result} object. The list always has a \code{code} entry which is the type of the event. See also \code{r_session$public_fields$status} for symbolic names of the event types. \itemize{ \item \code{200}: (\code{DONE}) The computation is done, and the event includes the result, in the same form as for the \code{run()} method. \item \code{201}: (\code{STARTED}) An R session that was in 'starting' state is ready to go. \item \code{202}: (\code{ATTACH_DONE}) Used by the \code{attach()} method. \item \code{301}: (\code{MSG}) A message from the subprocess. The message is a condition object with class \code{callr_message}. (It typically has other classes, e.g. \code{cli_message} for output from the cli package.) \item \code{500}: (\code{EXITED}) The R session finished cleanly. This means that the evaluated expression quit R. \item \code{501}: (\code{CRASHED}) The R session crashed or was killed. \item \code{502}: (\code{CLOSED}) The R session closed its end of the connection that callr uses for communication. } } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-close}{}}} \subsection{\code{r_session$close()}}{ Terminate the current computation and the R process. The session object will be in \code{"finished"} state after this. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$close(grace = 1000)} \if{html}{\out{
}} } \subsection{Arguments}{ \if{html}{\out{
}} \describe{ \item{\code{grace}}{Grace period in milliseconds, to wait for the subprocess to exit cleanly, after its standard input is closed. If the process is still running after this period, it will be killed.} } \if{html}{\out{
}} } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-traceback}{}}} \subsection{\code{r_session$traceback()}}{ The \code{traceback()} method can be used after an error in the R subprocess. It is equivalent to the \code{\link[base:traceback]{base::traceback()}} call, in the subprocess. On callr version 3.8.0 and above, you need to set the \code{callr.traceback} option to \code{TRUE} (in the main process) to make the subprocess save the trace on error. This is because saving the trace can be costly for large objects passed as arguments. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$traceback()} \if{html}{\out{
}} } \subsection{Returns}{ The same output as from \code{\link[base:traceback]{base::traceback()}} } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-debug}{}}} \subsection{\code{r_session$debug()}}{ Interactive debugger to inspect the dumped frames in the subprocess, after an error. See more at \link{r_session_debug}. On callr version 3.8.0 and above, you need to set the \code{callr.traceback} option to \code{TRUE} (in the main process) to make the subprocess dump frames on error. This is because saving the frames can be costly for large objects passed as arguments. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$debug()} \if{html}{\out{
}} } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-attach}{}}} \subsection{\code{r_session$attach()}}{ Experimental function that provides a REPL (Read-Eval-Print-Loop) to the subprocess. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$attach()} \if{html}{\out{
}} } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-print}{}}} \subsection{\code{r_session$print()}}{ Print method for an \code{r_session}. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$print(...)} \if{html}{\out{
}} } \subsection{Arguments}{ \if{html}{\out{
}} \describe{ \item{\code{...}}{Arguments are not used currently.} } \if{html}{\out{
}} } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-cleanup}{}}} \subsection{\code{r_session$cleanup()}}{ Delete the temporary files created for this R session. Only call this if you are sure that the process is done and you don't need to read from it anymore. If you don't call this method explicitly, the temporary files will be deleted when the process object is garbage collected. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$cleanup()} \if{html}{\out{
}} } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-finalize}{}}} \subsection{\code{r_session$finalize()}}{ Finalizer that is called when garbage collecting an \code{r_session} object, to clean up temporary files. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$finalize()} \if{html}{\out{
}} } } \if{html}{\out{

}} \if{html}{\out{}} \if{latex}{\out{\hypertarget{method-r_session-clone}{}}} \subsection{\code{r_session$clone()}}{ The objects of this class are cloneable with this method. \subsection{Usage}{ \if{html}{\out{
}} \preformatted{r_session$clone(deep = FALSE)} \if{html}{\out{
}} } \subsection{Arguments}{ \if{html}{\out{
}} \describe{ \item{\code{deep}}{Whether to make a deep clone.} } \if{html}{\out{
}} } } }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/eval.R, R/presets.R
\name{r}
\alias{r}
\alias{r_safe}
\title{Evaluate an expression in another R session}
\usage{
r(
  func,
  args = list(),
  libpath = .libPaths(),
  repos = default_repos(),
  stdout = NULL,
  stderr = NULL,
  poll_connection = TRUE,
  error = getOption("callr.error", "error"),
  cmdargs = c("--slave", "--no-save", "--no-restore"),
  show = FALSE,
  callback = NULL,
  block_callback = NULL,
  spinner = show && interactive(),
  system_profile = FALSE,
  user_profile = "project",
  env = rcmd_safe_env(),
  timeout = Inf,
  package = NULL,
  arch = "same",
  ...
)

r_safe(
  func,
  args = list(),
  libpath = .libPaths(),
  repos = default_repos(),
  stdout = NULL,
  stderr = NULL,
  poll_connection = TRUE,
  error = getOption("callr.error", "error"),
  cmdargs = c("--slave", "--no-save", "--no-restore"),
  show = FALSE,
  callback = NULL,
  block_callback = NULL,
  spinner = show && interactive(),
  system_profile = FALSE,
  user_profile = "project",
  env = rcmd_safe_env(),
  timeout = Inf,
  package = NULL,
  arch = "same",
  ...
)
}
\arguments{
\item{func}{Function object to call in the new R process.
The function should be self-contained and only refer to
other functions and use variables explicitly from other packages
using the \code{::} notation. By default the environment of the function
is set to \code{.GlobalEnv} before passing it to the child process.
(See the \code{package} option if you want to keep the environment.)
Because of this, it is good practice to create an anonymous
function and pass that to \code{callr}, instead of passing
a function object from a (base or other) package. In particular

\if{html}{\out{<div class="sourceCode">}}\preformatted{r(.libPaths)
}\if{html}{\out{</div>}}

does not work, because \code{.libPaths} is defined in a special
environment, but

\if{html}{\out{<div class="sourceCode">}}\preformatted{r(function() .libPaths())
}\if{html}{\out{</div>}}

works just fine.}

\item{args}{Arguments to pass to the function. Must be a list.}

\item{libpath}{The library path. If \code{NULL}, then the library path
is not modified at all in the subprocess. This is useful for
subprocesses that should use the library path of a fresh R session,
e.g. as set up by a project \code{.Rprofile}.}

\item{repos}{The \code{repos} option. If \code{NULL}, then no
\code{repos} option is set. This options is only used if
\code{user_profile} or \code{system_profile} is set \code{FALSE},
as it is set using the system or the user profile.}

\item{stdout}{The name of the file the standard output of
the child R process will be written to.
If the child process runs with the \code{--slave} option (the default),
then the commands are not echoed and will not be shown
in the standard output. Also note that you need to call \code{print()}
explicitly to show the output of the command(s).
IF \code{NULL}, then standard output is not returned, but
it is recorded and included in the error object if an error happens.
Various special values for this argument such as \code{"|"} are explained
in the \code{stdout} argument of \link[processx:process]{processx::process}.}

\item{stderr}{The name of the file the standard error of
the child R process will be written to.
In particular \code{message()} sends output to the standard
error. If nothing was sent to the standard error, then this file
will be empty. This argument can be the same file as \code{stdout},
in which case they will be correctly interleaved. If this is the
string \code{"2>&1"}, then standard error is redirected to standard output.
IF \code{NULL}, then standard output is not returned, but
it is recorded and included in the error object if an error happens.
Various special values for this argument such as \code{"|"} are explained
in the \code{stdout} argument of \link[processx:process]{processx::process}.}

\item{poll_connection}{Whether to have a control connection to
the process. This is used to transmit messages from the subprocess
to the main process.}

\item{error}{What to do if the remote process throws an error.
See details below.}

\item{cmdargs}{Command line arguments to pass to the R process.
Note that \code{c("-f", rscript)} is appended to this, \code{rscript}
is the name of the script file to run. This contains a call to the
supplied function and some error handling code.}

\item{show}{Logical, whether to show the standard output on the screen
while the child process is running. Note that this is independent
of the \code{stdout} and \code{stderr} arguments. The standard
error is not shown currently.}

\item{callback}{A function to call for each line of the standard
output and standard error from the child process. It works together
with the \code{show} option; i.e. if \code{show = TRUE}, and a
callback is provided, then the output is shown of the screen, and the
callback is also called.}

\item{block_callback}{A function to call for each block of the standard
output and standard error. This callback is not line oriented, i.e.
multiple lines or half a line can be passed to the callback.}

\item{spinner}{Whether to show a calming spinner on the screen while
the child R session is running. By default it is shown if
\code{show = TRUE} and the R session is interactive.}

\item{system_profile}{Whether to use the system profile file.}

\item{user_profile}{Whether to use the user's profile file.
If this is \code{"project"}, then only the profile from the working
directory is used, but the \code{R_PROFILE_USER} environment variable
and the user level profile are not. See also "Security considerations"
below.}

\item{env}{Environment variables to set for the child process.}

\item{timeout}{Timeout for the function call to finish. It can be a
\link[base:difftime]{base::difftime} object, or a real number, meaning seconds.
If the process does not finish before the timeout period expires,
then a \code{system_command_timeout_error} error is thrown. \code{Inf}
means no timeout.}

\item{package}{Whether to keep the environment of \code{func} when passing
it to the other package. Possible values are:
\itemize{
\item \code{NULL} (the default): equivalent to \code{TRUE} if \code{func} inherits from
\code{"crate"} (i.e. was created with \code{carrier::crate()}), and \code{FALSE}
otherwise.
\item \code{FALSE}: reset the environment to \code{.GlobalEnv}.
\item \code{TRUE}: keep the environment as is.
\item \code{pkg}: set the environment to the \code{pkg} package namespace.
}}

\item{arch}{Architecture to use in the child process, for multi-arch
builds of R. By default the same as the main process. See
\code{\link[=supported_archs]{supported_archs()}}. If it contains a forward or backward slash
character, then it is taken as the path to the R executable.
Note that on Windows you need the path to \code{Rterm.exe}.}

\item{...}{Extra arguments are passed to \code{\link[processx:run]{processx::run()}}.}
}
\value{
Value of the evaluated expression.
}
\description{
From \code{callr} version 2.0.0, \code{r()} is equivalent to \code{r_safe()}, and
tries to set up a less error prone execution environment. In particular:
\itemize{
\item Ensures that at least one reasonable CRAN mirror is set up.
\item Adds some command line arguments to avoid saving \code{.RData} files, etc.
\item Ignores the system and user profiles (by default).
\item Sets various environment variables: \code{CYGWIN} to avoid
warnings about DOS-style paths, \code{R_TESTS} to avoid issues
when \code{callr} is invoked from unit tests, \code{R_BROWSER}
and \code{R_PDFVIEWER} to avoid starting a browser or a PDF viewer.
See \code{\link[=rcmd_safe_env]{rcmd_safe_env()}}.
}
}
\details{
The \code{r()} function from before 2.0.0 is called \code{\link[=r_copycat]{r_copycat()}} now.
}
\section{Error handling}{


\code{callr} handles errors properly. If the child process throws an
error, then \code{callr} throws an error with the same error message
in the main process.

The \code{error} expert argument may be used to specify a different
behavior on error. The following values are possible:
\itemize{
\item \code{error} is the default behavior: throw an error in the main process,
with a prefix and the same error message as in the subprocess.
\item \code{stack} also throws an error in the main process, but the error
is of a special kind, class \code{callr_error}, and it contains
both the original error object, and the call stack of the child,
as written out by \code{\link[utils:dump.frames]{utils::dump.frames()}}. This is now deprecated,
because the error thrown for \code{"error"} has the same information.
\item \code{debugger} is similar to \code{stack}, but in addition
to returning the complete call stack, it also start up a debugger
in the child call stack, via \code{\link[utils:debugger]{utils::debugger()}}.
}

The default error behavior can be also set using the \code{callr.error}
option. This is useful to debug code that uses \code{callr}.

callr uses parent errors, to keep the stacks of the main process and the
subprocess(es) in the same error object.
}

\section{Security considerations}{


\code{callr} makes a copy of the user's \code{.Renviron} file and potentially of
the local or user \code{.Rprofile}, in the session temporary
directory. Avoid storing sensitive information such as passwords, in
your environment file or your profile, otherwise this information will
get scattered in various files, at least temporarily, until the
subprocess finishes. You can use the keyring package to avoid passwords
in plain files.
}

\section{Transporting objects}{


\code{func} and \code{args} are copied to the child process by first serializing them
into a temporary file using \code{\link[=saveRDS]{saveRDS()}} and then loading them back into the
child session using \code{\link[=readRDS]{readRDS()}}. The same strategy is used to copy the result
of calling \code{func(args)} to the main session. Note that some objects, notably
those with \code{externalptr} type, won't work as expected after being
saved to a file and loaded back.

For performance reasons \code{compress=FALSE} is used when serializing with
\code{\link[=saveRDS]{saveRDS()}}, this can be disabled by setting
\code{options(callr.compress_transport = TRUE)}.
}

\examples{
\dontshow{if (FALSE) withAutoprint(\{ # examplesIf}
# Workspace is empty
r(function() ls())

# library path is the same by default
r(function() .libPaths())
.libPaths()
\dontshow{\}) # examplesIf}
}
\seealso{
Other callr functions:
\code{\link[=r_copycat]{r_copycat()}},
\code{\link[=r_vanilla]{r_vanilla()}}
}
\concept{callr functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/presets.R
\name{r_vanilla}
\alias{r_vanilla}
\title{Run an R child process, with no configuration}
\usage{
r_vanilla(
  func,
  args = list(),
  libpath = character(),
  repos = c(CRAN = "@CRAN@"),
  cmdargs = "--slave",
  system_profile = FALSE,
  user_profile = FALSE,
  env = character(),
  ...
)
}
\arguments{
\item{func}{Function object to call in the new R process.
The function should be self-contained and only refer to
other functions and use variables explicitly from other packages
using the \code{::} notation. By default the environment of the function
is set to \code{.GlobalEnv} before passing it to the child process.
(See the \code{package} option if you want to keep the environment.)
Because of this, it is good practice to create an anonymous
function and pass that to \code{callr}, instead of passing
a function object from a (base or other) package. In particular

\if{html}{\out{<div class="sourceCode">}}\preformatted{r(.libPaths)
}\if{html}{\out{</div>}}

does not work, because \code{.libPaths} is defined in a special
environment, but

\if{html}{\out{<div class="sourceCode">}}\preformatted{r(function() .libPaths())
}\if{html}{\out{</div>}}

works just fine.}

\item{args}{Arguments to pass to the function. Must be a list.}

\item{libpath}{The library path. If \code{NULL}, then the library path
is not modified at all in the subprocess. This is useful for
subprocesses that should use the library path of a fresh R session,
e.g. as set up by a project \code{.Rprofile}.}

\item{repos}{The \code{repos} option. If \code{NULL}, then no
\code{repos} option is set. This options is only used if
\code{user_profile} or \code{system_profile} is set \code{FALSE},
as it is set using the system or the user profile.}

\item{cmdargs}{Command line arguments to pass to the R process.
Note that \code{c("-f", rscript)} is appended to this, \code{rscript}
is the name of the script file to run. This contains a call to the
supplied function and some error handling code.}

\item{system_profile}{Whether to use the system profile file.}

\item{user_profile}{Whether to use the user's profile file.
If this is \code{"project"}, then only the profile from the working
directory is used, but the \code{R_PROFILE_USER} environment variable
and the user level profile are not. See also "Security considerations"
below.}

\item{env}{Environment variables to set for the child process.}

\item{...}{Additional arguments are passed to \code{\link[=r]{r()}}.}
}
\description{
It tries to mimic a fresh R installation. In particular:
\itemize{
\item No library path setting.
\item No CRAN(-like) repository is set.
\item The system and user profiles are not run.
}
}
\section{Security considerations}{


\code{callr} makes a copy of the user's \code{.Renviron} file and potentially of
the local or user \code{.Rprofile}, in the session temporary
directory. Avoid storing sensitive information such as passwords, in
your environment file or your profile, otherwise this information will
get scattered in various files, at least temporarily, until the
subprocess finishes. You can use the keyring package to avoid passwords
in plain files.
}

\examples{
\dontshow{if (FALSE) withAutoprint(\{ # examplesIf}
# Compare to r()
r(function() .libPaths())
r_vanilla(function() .libPaths())

r(function() getOption("repos"))
r_vanilla(function() getOption("repos"))
\dontshow{\}) # examplesIf}
}
\seealso{
Other callr functions:
\code{\link[=r]{r()}},
\code{\link[=r_copycat]{r_copycat()}}
}
\concept{callr functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/processx-forward.R
\docType{import}
\name{reexports}
\alias{reexports}
\alias{run}
\alias{process}
\alias{poll}
\title{Objects exported from other packages}
\keyword{internal}
\description{
These objects are imported from other packages. Follow the links
below to see their documentation.

\describe{
  \item{processx}{\code{\link[processx:poll]{poll()}}, \code{\link[processx:process]{process}}, \code{\link[processx:run]{run()}}}
}}
